/*
*************************************
file:  actions.c
*************************************
*/



#include "bmath.h"


#define dbg_flag 0


/*
******************************************
Display boolean function.

HYP: n <= 32.
******************************************
*/


void display_bf(
int n,   /*  arity boolean function   F   */
bdd F   /* relation    */
)

{  /*  begin */

/* declarations  */


unsigned int i, max_in;
int *x;

/*  program  */

#if (dbg_flag > 100)
printf("\ndisplay_bf: ckp 100 (begin)\n");
#endif

x = (int *) malloc(n * sizeof(int));

if (x == NULL)
{
    printf("\n\nError: no space for x (display_bf)");
    exit (1234);
}

/* x != NULL  */

/* define max_in   */
max_in = 1;
for (i = 0; i < n; i++)
{
    max_in = 2*max_in;
}

for (i = 0; i < max_in; i++)
{
 	 	/* define x  */
 	 	conv_dec_to_bin(n, i, x);
 
 	 	/* print result   */
 	 	
 	 	printf("\n\ninput %u = 0x%x, output = %u",
 	 	i,
 	 	i,
 	 	eval_bdd(F, x, n)
 	 	);

}


free(x);

}  /*  end  */




