


/*
**
**  file cache.h
**
**
**  primitives on bit operations 
**
*/


#ifndef cache_h
#define cacheh


#include <stdio.h>
#include <stdlib.h>
#include <limits.h>


typedef void *cache_value; 




extern
int get_cache_size();

extern
int get_cache_elements();


extern
void start_cache_env();

extern 
cache_value read_from_cache(cache_value A);


extern 
cache_value write_into_cache(cache_value A );


extern
void print_cache_info();

extern
void set_cache_par(unsigned int cachesize);


#endif



