
/*
**
**   read cache memory for store A
**
**   return store in cache (if any) and
**   define values in A (if possible)
**
*/


#include "local.h"




/*
**  it is user responsability
**  to guarantee that a is within the range
**
*/


type_gstore read_cache(cache_memory T, type_gstore A)
{
/* declarations  */
  int i, a, size_keys;

#if cache_measure
static int count = 0;
#endif

/* programs  */


#if cache_measure
count++;
#endif


   a = tuple_cache(T, A);


   if (  ((cache_MEM *) T) -> table[a] == NULL )
   /* then  */ /* not found  */
         {
            return (NULL);
         }

/*  ((cache_MEM *) T) -> table[tuple_cache(A)] != NULL  */



size_keys = read_gstore_size_key(A);


 for (i = 0; i < size_keys; i++)
	{
          if ( 
               read_gstore_word(A, i) != 
               read_gstore_word( ((cache_MEM *) T) -> table[a], i)
             )
         /* then */  /*  not found  */
                  {
                        return (NULL);
                  }

/*  size_keys in A == size_keys in table[a]  */
	
	}



/*   found  */
    

            copy_gstore_value(A,  ((cache_MEM *) T) -> table[a]);

/*  value in table also in A now  */

/*  
((cache_MEM *) T) -> table[a] and A are equal now.
It is up to the user to get rid of one of them
*/


            return (  ((cache_MEM *) T) -> table[a] );


}  /*  end program  */





type_gstore read_from_cache(type_gstore A)
{
   return ( read_cache(T_cache, A) );
   
}

