
/*
**   pairs A's
**
**
*/


#include "local.h"


int tuple_cache(cache_memory T, type_gstore A)

/*
**  hashfunction for multiple keys
**  Assume m = ((Hashtable *) T) -> arity[0] = keys in q
**
**  extra keys not considered 
**
**  A[i] positive, negative or zero. 
**
**  in ((Hashtable *) T) -> arity
**  we have the arity and sizes
**  of T
**
**  i.e.
**  
** ((Hashtable *) T) -> arity[0] = arity
**
** ((Hashtable *) T) -> arity[i] = size of field i 
** (i = 1, ... arity).
**
*/

{  /* declarations  */
   unsigned int total, base;
   int i, size_keys;

   /* program  */

   size_keys = read_gstore_size_key(A);
   
   base = 1u;
   total =  (read_gstore_word(A, 0)%(((cache_MEM *) T) -> sizetab));




   for (i = 1; i < size_keys; i++)
      {

          base =  (
(
 (UINT_MAX%( ((cache_MEM *) T) -> sizetab ) + 1)%( ((cache_MEM *) T) -> sizetab )
) * base         )%(((cache_MEM *) T) -> sizetab);

          total = 
(total +  
          ( base * (
                           read_gstore_word(A, i)%(((cache_MEM *) T) -> sizetab)
                        )
           )%(((cache_MEM *) T) -> sizetab)

)%(((cache_MEM *) T) -> sizetab) ;

       }



   return ( (signed int) total );
 }
  

