/*
**
**  file vertex.h
**
**
**  primitives on vertex 
**
*/


#ifndef dag_h
#define dag_h


#include <stdlib.h>
#include <stdio.h>
#include <limits.h>



typedef void *dag_vertex;

extern
void start_dag_env();

extern
dag_vertex get_dag_vertex(unsigned int *B);

extern
int get_dag_htable_elements();

extern
int get_num_bdd_vtx();



extern
int get_dag_htable_size();

extern
void print_dag_info();


extern
void lock_gvertex(dag_vertex v);

extern
void unlock_gvertex(dag_vertex v);


extern
int locked_gvertex(dag_vertex v);


extern
int unlocked_gvertex(dag_vertex v);


extern
void print_all_dag(
FILE *pfile,
void (* print_dag_vertex_info)(FILE *pfile, void *v)
);



extern
void fprint_dag_gvtx(FILE *pfile);



extern
void set_dag_par(
unsigned int sizeht,
unsigned int gcthr,
double loadfact
);

#endif
