
/*
***************************************************************

file:  get_dag_vertex.c

***************************************************************
*/



#include "dag.h"
#include "local.h"


#define dbg_flag 0


dag_vertex get_dag_vertex(unsigned int *B)

{  /*  begin  */

/* declarations  */
dag_vertex u, next_u;
int i, nonpointer_size, pointer_size;


/*  program  */


#if (dbg_flag > 100)
printf("\nget_dag_vertex: ckp 100 (begin)");
#endif

                    u = (dag_vertex) read_lkup_table(T_dag, B);

#if (dbg_flag > 100)
printf("\nget_dag_vertex: ckp 200");
#endif

                    if (u == NULL) 
                    then  /*  new vertex  */

                        {

#if (dbg_flag > 100)
printf("\nget_dag_vertex: ckp 300");
#endif

/*
**   do gc on T_dag  
*/



garbage_collection(T_dag);



#if (dbg_flag > 100)
printf("\nget_dag_vertex: ckp 400");
#endif
                          u = get_new_gvertex(B);
                         
#if (dbg_flag > 100)
printf("\nget_dag_vertex: ckp 500");
#endif
                          write_gvertex_plot(u, NULL);

#if (dbg_flag > 100)
printf("\nget_dag_vertex: ckp 600");
#endif

#if 0
/*  Not needed since initialized in  get_new_gvertex   */
write_gvertex_in_edges(u, 0);
#if (dbg_flag > 100)
printf("\nget_dag_vertex: ckp 700");
#endif
#endif

                       
                         write_lkup_table(T_dag, u);

#if (dbg_flag > 100)
printf("\nget_dag_vertex: ckp 750");
#endif
 
/*
**  update max_size_graph (used for info)
*/

if ( get_lkup_table_elements(T_dag) > max_size_graph) 
/* then */   max_size_graph = get_lkup_table_elements(T_dag);

#if (dbg_flag > 100)
printf("\nget_dag_vertex: ckp 800");
#endif




/*
**  end update max_size_graph
*/



/*  incrememt count of input edges  */

nonpointer_size = size_gvtx_nonptrlab(u);  /* > 0  */

#if (dbg_flag > 100)
printf("\nget_dag_vertex: ckp 900");
#endif


pointer_size = nonpointer_size + size_gvtx_ptrlab(u);

#if (dbg_flag > 100)
printf("\nget_dag_vertex: ckp 1000");
#endif

             for (i = nonpointer_size; i < pointer_size; i++)
                     {

#if (dbg_flag > 100)
printf("\nget_dag_vertex: ckp 1100.%d", i);
#endif
         next_u = (dag_vertex) gvertex_tlab(u, i);

#if (dbg_flag > 1000)
printf("\nget_dag_vertex: ckp 1200.%d, next_u = 0x%x", i, next_u);
#endif

                       if (next_u != NULL)
                       then
                               {
#if (dbg_flag > 1000)
printf("\nget_dag_vertex: ckp 1300.%d", i);
#endif
                                  lock_gvertex(next_u);
#if (dbg_flag > 1000)
printf("\nget_dag_vertex: ckp 1400.%d", i);
#endif
                                  
                               }

#if (dbg_flag > 100)
printf("\nget_dag_vertex: ckp 4000.%d", i);
#endif
                    

                     }   /*  end for  */










         }   /*  end then  (u == NULL)  */

         /*  u defined  */


#if (dbg_flag > 100)
printf("\nget_dag_vertex: ckp 10000 (end)");
#endif

    return (u);


} /*  end program new */


