/*
**
**  file vertex.h
**
**
**  primitives on vertex 
**
*/


#ifndef dag_h
#define dag_h


#include <stdlib.h>
#include <stdio.h>
#include <limits.h>

typedef void *dag_vertex;

extern
void start_dag_env();

extern
dag_vertex get_dag_vertex(unsigned int *B);

extern
int get_dag_htable_elements();

extern
int get_dag_htable_size();

extern
void print_dag_info();



#if 0
extern 
void read_vertex_info(ptrvertex v, unsigned int *A);
read_vertex_labels

extern
unsigned int get_vertex_label(
ptrvertex v, 
int i 
);

extern
unsigned int read_vertex_nonpointer(
ptrvertex v, 
int i 
);
get_vertex_nonptr_label

extern
unsigned int read_vertex_pointer(
ptrvertex v, 
int i 
);
get_vertex_ptr_label


extern
unsigned int fast_read_vertex_pointer(
ptrvertex v, 
int size_labels,
int i 
);
fast_get_vertex_nonptr_label


extern
unsigned int read_vertex_pmark(
ptrvertex v, 
int i 
);
get_vertex_pmark


extern
unsigned int fast_read_vertex_pmark(
ptrvertex v, 
int size_labels,
int i 
);
fast_get_vertex_pmark


extern
unsigned int read_vertex_size_lgh(ptrvertex v);
get_vertex_sizebit_lgh


extern
unsigned int get_vtx_info_size(ptrvertex v);
get_vtx_label_size

extern
unsigned int read_mtx_size_lgh(unsigned int *A);
extern
unsigned int get_mtx_info_size(unsigned int *A);

extern
unsigned int read_vertex_1_label(
ptrvertex v, 
int i 
);
get_vertex_good_label

extern
int get_label_size(unsigned int size_lgh, unsigned int A0);
get_vtx_nonptr_lab_size

extern
int get_pointer_size(unsigned int size_lgh, unsigned int A0);
get_vtx_ptr_lab_size

extern
int get_info_size(unsigned int size_lgh, unsigned int A0);


extern 
int read_vertex_in_edges(ptrvertex v);

extern 
void write_vertex_in_edges(ptrvertex v, int value);

extern
void lock_vertex(ptrvertex v);


extern
void unlock_vertex(ptrvertex v);


extern
int locked_vertex(ptrvertex v);


extern
int unlocked_vertex(ptrvertex v);





#endif



#endif
