

#include "dag.h"
#include "local.h"


/* print all dag in file filename  */
 
void print_all_dag(
FILE *pfile,
void (* print_dag_vertex_info)(FILE *pfile, void *v)
)
/*
**  prints rbdd G
*/
{
/* declarations  */
int i;
void *v;


/* program  */


for (i = 0; i < get_dag_htable_size(); i++)
	{  /* for  */
	   /* print all vertices in row i  */
	   
       v = read_lkuptable_entry(T_dag, i);
       
	   while ( v != NULL)
	   	{   /* while  */
	   	   
	   	  (* print_dag_vertex_info)(pfile, v);
	   
	   	  v =  read_lkuptable_vtxplot(T_dag, v);
	   	
	   	}   /* while  */

	}  /* for  */



}   /* end program  */




void fprint_dag_gvtx(FILE *pfile)
{
   print_all_dag(pfile, fprint_gvtx);
}