/*
**
**  file:   store.h
**
**
*/

#ifndef gstore_h
#define gstore_h



#include <stdio.h>
#include <stdlib.h>
#include <limits.h>




typedef void *type_gstore;




extern
type_gstore get_new_gstore(
unsigned int size_key_info, 
unsigned int size_value_info);

extern
void lock_gstore(type_gstore p);

extern
void unlock_gstore(type_gstore p);



extern
void write_gstore_in_edges(
type_gstore p, 
unsigned int value
);


extern
unsigned int read_gstore_in_edges(
type_gstore p
);



extern
unsigned int read_gstore_value(
type_gstore p,
int i
);

extern
unsigned int write_gstore_value(
type_gstore p,
int i,
unsigned int value
);


extern
void copy_gstore_value(
type_gstore A,
type_gstore B
);


extern
void free_gstore(type_gstore p);

extern
unsigned int read_gstore_keys(
type_gstore p,
int i
);

extern
void write_gstore_keys(
type_gstore p,
int i,
unsigned int value
);


extern
unsigned int read_gstore_word(
type_gstore p,
int i
);

void write_gstore_size_key(
type_gstore p, 
unsigned int value
);

unsigned int read_gstore_size_key(
type_gstore p
);

void write_gstore_size_value(
type_gstore p, 
unsigned int value
);

unsigned int read_gstore_size_value(
type_gstore p
);





#endif
