
/*
**
**  file prototypes.h
**
**
**  primitives on vertex 
**
*/



#include "gvertex.h"

#include "local.h"

#define dbg_flag 0  /* noraml value: 0  */





#define cszvtx 4   /* size of constant size vertices  */





void update_gvertex_info(int size_new_vertex)
{



#if (flag_gvertex_info > 10)

/* defclarations  */
int i;
static int count = 0;





/* program  */

#if (dbg_flag > 10)
printf("\nupdate_gvertex_info:%u: ckp 100: (begin): info_gvertex = 0x%x, info_gvertex[%u] = %u",
count,
info_gvertex,
size_new_vertex,
info_gvertex[size_new_vertex]
); 
#endif





if (count == 0)
/* then: define info_gvertex[i]  */
  {
     for (i = 0; i < 10; i++)
        {
          info_gvertex[i] = 0;
        }

/* update count */
count++;

  }
 

/* count == 1  */
/* info_gvertex defined  */

#if (dbg_flag > 10)
if (size_new_vertex >= 10)
  {
printf("\nupdate_gvertex_info:%u: error size_new_vertex = %u",
count,
size_new_vertex
);
   exit (1000);
  }
#endif

info_gvertex[size_new_vertex] = 
info_gvertex[size_new_vertex] + 1;





#if (dbg_flag > 10)
printf("\nupdate_gvertex_info:%u: ckp 2000: end: info_gvertex[%u] = %u",
count,
size_new_vertex,
info_gvertex[size_new_vertex]
); 
#endif

#endif

}






void print_gvertex_info()
{

#if (flag_gvertex_info > 10)





/* declarations  */
int i;
unsigned int size_in_bytes[2];

/* program  */

size_in_bytes[0] = 0;  /* variables size vertices  */
size_in_bytes[1] = 0;  /* constant size (=  cszvtx) vertices  */

printf("\ngvertex info: vertices created so far:");
for (i = 0; i < 10; i++)
   {
      if ( info_gvertex[i]  /*  != 0  */ )
      /* then  */
         {
             size_in_bytes[0] = size_in_bytes[0] + 4*i*info_gvertex[i];
             size_in_bytes[1] = size_in_bytes[1] + 4* cszvtx*info_gvertex[i];
             
             printf("\ngvertex info: number of vertices of size %d = %u",
i,
info_gvertex[i]
);
         }
   }


printf("\ngvertex info: bytes for variable word size vertices = %u", 
size_in_bytes[0]);

printf("\ngvertex info: bytes for constant %d word size vertices = %u", 
 cszvtx,
 size_in_bytes[1]);

printf("\ngvertex info: saving = %u, saving ratio %f", 
size_in_bytes[1] - size_in_bytes[0],
((float) (size_in_bytes[1] - size_in_bytes[0]))
/ ((float) size_in_bytes[1])
);


#endif
     
}
