

/*
***********************************************************************
file bddhdr.h
***********************************************************************
*/






#ifndef graphheaderh
#define graphheaderh



#include <stdio.h>
#include <stdlib.h>
#include <limits.h>

#include "bddvtx.h"



typedef void *bdd;



extern
ptrvertex read_graph_root(bdd G);
extern
void write_graph_root(bdd G, ptrvertex v);



extern
int read_graph_p_flip(bdd G);
extern
void write_graph_p_flip(bdd G, int value);


extern
int read_graph_p_swap(bdd G);
extern
void write_graph_p_swap(bdd G, int value);


extern
unsigned int read_graph_flip(bdd G);
extern
void write_graph_flip(bdd G, unsigned int value);



extern
void write_graph_vindex(bdd G, unsigned int value);

extern
unsigned int read_graph_vindex(bdd G);



extern
bdd get_graph_header();

extern
void delete_graph_header(bdd G);


extern
int bdd_root_var_index(bdd G);

extern
bdd duplicate(bdd G);


extern
void delete_bdd(bdd G);



#ifndef deletegraph
#define deletegraph(G) delete_bdd(G)
#endif


#ifndef deleterbdd
#define deleterbdd(G) delete_bdd(G)
#endif


#endif


 
