
/*
**
**  file htable.h
**
**
**  primitives for hash table
**
*/


#ifndef htable_h
#define htable_h


#include <stdio.h>
#include <stdlib.h>
#include <limits.h>





typedef void *htable;


/*
returns nonzero iff entru with key is in htable T.
If entry found then *A = value
*/

extern 
int read_ht(htable T, unsigned int key, unsigned int *value);


extern 
void write_ht(htable T, unsigned int key, unsigned int value);

extern 
htable create_htable(unsigned int  ht_size);

extern
unsigned int get_htable_size(htable T);

extern
unsigned int get_htable_elements(htable T);

extern
unsigned int get_ht_nonnull(htable T);


extern
unsigned int read_htable_entry(htable T, unsigned int i);


extern
void delete_ht(htable T);

extern
void print_ht(FILE *myfile, htable T);


extern
htable get_htable();


#endif








