/*
**  file:  create.c
**
*/


#include "local.h"

#define HT_SIZE 1009    /* this shuold be a prime number  */





htable get_htable()
{
   return ( create_htable(HT_SIZE) );
}



htable create_htable(unsigned int  ht_size)
{  /*  begin program  */


/* declarations  */
  hash_table *T;
  int i;

    T = (hash_table *) malloc(sizeof(hash_table));
 
    if (T == NULL)
    /* then  */ 
         {
            printf("\n**ERROR** no space for hash table header (create_htable)\n");
            exit (1000);
         }

    T -> table = (ht_value *) malloc(ht_size * sizeof(ht_value));

    if (T -> table == NULL)
    /* then  */ 
         {
            printf("\n**ERROR** no space for hash table (create_htable)\n");
            exit (1000);
         }




/* inizialization */

    T -> elements_in_table = 0;
    T -> size_table = ht_size;
    T -> non_null_entry = 0;


/*
**   initialize table
**
*/


    for (i = 0; i < ht_size; i++)
       {
         T -> table[i] = (unsigned int ) NULL;
       }


/* end inizialization */

     return (T);


}  /*  end program  */

