
/*
**
**  file look.up.table.c
**
**
**  primitives for look_up_table (variable size keys)
**
**  version 1.1
*/




#include "htable.h"



typedef unsigned int ht_value;


struct Hash_Table
{
  unsigned int size_table;
  unsigned int elements_in_table;
  unsigned int non_null_entry;
  ht_value *table;
};


typedef struct Hash_Table hash_table;





unsigned int *get_new_bk();
unsigned int *read_bk_next(unsigned int *v);
unsigned int read_bk_value(unsigned int *v);
unsigned int read_bk_key(unsigned int *v);
void write_bk_key(unsigned int *v, unsigned int value);
void write_bk_value(unsigned int *v, unsigned int value);
void write_bk_next(unsigned int *v, unsigned int *value);





