/*
**
**  file: read.lkup.table
**
*/

#include "local.h"


#define dbg_flag 0







void print_ht(FILE *myfile, htable T)
{

/* declarations  */
  ht_value *v;
  unsigned int i, j;

#if (dbg_flag > 0)
static int count = 0;
#endif

/* programs  */


#if (dbg_flag > 0)
count++;
#endif


    for (i = 0; i < get_htable_size(T); i++)
       {
          v = (ht_value *) ( ((hash_table *) T) -> table[i] );
          
          fprintf(myfile, "\nrow %d", i); 
          j = 0;
          while (v != NULL)
          {
             
             fprintf(myfile, "\n         bk %d: (%u, %u, 0x%x)",
             		j, 
             		read_bk_key(v),
             		read_bk_value(v),
             		read_bk_next(v)
             );
             v = read_bk_next(v);
             
             j++;
          }
          
       }



}  /* end program  */
