                               
/*
********************************************************
file:  restrict
********************************************************
*/


/*
********************************************************
restriction on p
********************************************************
*/

/*
********************************************************
HYP:
input:  restrion in nf
output: restriction in nf
********************************************************
*/


#include "local.h"

#define dbg0_restrict 0
#define dbg0_do_restrict 0
#define dbg5_do_restrict (dbg0_do_restrict && 0x0)

#define dbg_flag 0    /*  normal value:  0  */


#define then /* then */

/* after restriction read_store_dvindex(p, 2) well defined  */





void restriction(type_bdd_store p)

{  /*   begin  restriction  */


#if (dbg_flag > 100)
unsigned int vindex[4];
#endif


  if (read_store_rswitch(p)  /* != 0  */)
  then  /* restriciton may be necessary  */
        {
        
#if dbg0_restrict
printf("\ncall restriction: (no restriction) read_store_rswitch(0x%x) = 0x%x\n",
p,
read_store_rswitch(p)
);
#endif
            restriction_step(p);
            
/* broadcast dvindex define   */

#if (dbg_flag > 100)
printf("\nrestriction: ckp 2000: store p = 0x%x", p);
printf("\nbroadcast dvindex = %d", read_store_dvindex(p, 2));
get_vindexes_store(p, vindex);
printf(
"\nvindex[0] = %d, vindex[1] = %d, vindex[2] = %d, vindex[3] = %d", 
vindex[0], vindex[1], vindex[2], vindex[3]);
#endif
            
        }
else  /* no restriciton necessary  */
        {
        
#if dbg0_restrict
printf("\ncall restriction: (no restriction) read_store_rswitch(0x%x) = 0x%x\n",
p,
read_store_rswitch(p)
);
#endif

/*  define brodcast dvindex  */

     write_store_dvindex(p, 2, 0);
     
        }

}  /*  end restriction  */









void restriction_step(type_bdd_store p)

{  /*   begin  restriction  */


/*  declarations  */

unsigned int vindex_G[4];


/*  program  */

/*  define vindexes and restriction index (in vindex_G[3])  */
get_vindexes_store(p, vindex_G);

#if (dbg_flag > 100)
printf("\nrestriction_step: ckp 100: store p = 0x%x", p);
printf("\nvindex[0] = %d, vindex[1] = %d, vindex[2] = %d",
vindex_G[0], vindex_G[1], vindex_G[2]);
printf("\nvindex[3] = restriction index = %d", vindex_G[3]);
#endif


/*  test side 1 of if_then_else for restriction    */
if ( vindex_G[1] == vindex_G[3] )
then  
/*  side 1 of if_then_else to be restricted, thus G1 nonterminal */
        {

    do_restriction(p, vindex_G, 1);
    
			/*  test side 2 of if_then_else for restriction    */
			if ( vindex_G[2] == vindex_G[3] )
			then  
			/*  side 2 of if_then_else to be restricted, thus G2 nonterminal */
        		{
    				do_restriction(p, vindex_G, 2);
    				
/* restore nf for restriction before returning  */

              /* old version:  restriction_nf(p);   */
					restriction_nf_vindex(p, vindex_G);

/*  define broadcast dvindex  */
write_store_dvindex(
p, 
2, 
min_3(
vindex_G[0], 
vindex_G[1], 
vindex_G[2])
);

                            return ;
    				
    				
        		}

/* restore nf for restriction before returning   */
              /* old version:  restriction_nf(p);   */
					restriction_nf_vindex(p, vindex_G);

/*  define broadcast dvindex  */
write_store_dvindex(
p, 
2, 
min_3(vindex_G[0], vindex_G[1], vindex_G[2])
);
                           return ;


        }
 



         


/*   side 1 not to be restricted, test side 2  */


if ( vindex_G[2] == vindex_G[3] )
then  /*  side 2 of if_then_else to be restricted  */
        {
        
                do_restriction(p, vindex_G, 2);
                
/* restore nf for restriciton before returning   */
              /* old version:  restriction_nf(p);   */
					restriction_nf_vindex(p, vindex_G);

/*  define broadcast dvindex  */
write_store_dvindex(
p, 
2, 
  min_3(vindex_G[0], vindex_G[1],  vindex_G[2])
);
                           return ;
                       
         }

/* no restriction takes place  */

/*  define broadcast dvindex  */
write_store_dvindex(
p, 
2, 
0
);


}  /*  end  restriction   */







void do_restriction(
type_bdd_store p,
unsigned int vindex_G[4],
unsigned int ifte_branch   /*  ifte branch for restriciton, ifte_branch = 1, 2  */
)

{  /*   begin  do_restriction  */


/*  declarations  */

type_bdd_store p_new;
unsigned int new_vindex[2][3];
unsigned int new_dvindex, new_dv_sgn;
unsigned int r_bit;

#if dbg0_do_restrict
static int count = 0;
#endif


/*  program  */
#if dbg0_do_restrict
count++;
#endif

#if dbg5_do_restrict
if (
       terminal((ptrvertex) read_store_vertex(p, ifte_branch))
    )
then   /* error  */
      {
printf("\n\n************************************************");
printf("\ndo_restriction: %d: error, ckp 100: trying to restrictc a terminal vertex",
count
);
printf("\nifte_branch = %d", ifte_branch);
printf("\n************************************************\n\n");
             }
      
#endif

            r_bit = (read_store_rbit(p) + ifte_branch + 1)%2;
            
           /*  restrict side ifte_branch  if_then_else  */
           
/*  create store  */
           p_new  = get_new_bdd_store();

/* compute next state  */
           
           next_state(
r_bit,
ifte_branch,
p,
p_new,
new_vindex,
vindex_G
);

/* update p  */

write_store_vertex(
p, 
ifte_branch, 
read_store_vertex(p_new, ifte_branch)
);
write_store_p_flip(
p, 
ifte_branch, 
read_store_p_flip(p_new, ifte_branch)
);
write_store_p_swap(
p, 
ifte_branch, 
read_store_p_swap(p_new, ifte_branch)
);
write_store_flip(
p, 
ifte_branch, 
read_store_flip(p_new, ifte_branch)
);

/*  compute new_dvindex, new_dv_sgn  */
def_dv_sgn(
vindex_G[0],
new_vindex[r_bit][ifte_branch],
&new_dvindex,
&new_dv_sgn
);

write_store_dvindex(p, ifte_branch - 1, new_dvindex);
write_store_dv_sgn(p, ifte_branch - 1, new_dv_sgn);  


/* update vindex_G   */

vindex_G[ifte_branch] = new_vindex[r_bit][ifte_branch];


/*  delete store  */
free_bdd_store(p_new);

}  /*  end do_restriction  */






