


/*
************************************************
file:    root_is_1_redex
************************************************
*/


#include "local.h"



#define dbg0_ris1r 0
#define dbg5_ris1r (dbg0_ris1r && 0x0)

#define then  /* then */
                           
int root_is_1_redex(
type_bdd_store p,
type_bdd_store new_p_0,
type_bdd_store new_p_1
)


/*                  
**   do 1-reductions on old_new_vb_aux[0] -> vertex   (i = 0, 1)
**   
**
**
*/

{
   /*  declarations  */

#if dbg0_ris1r
static int count = 0;
#endif

   /*  program  */

#if dbg0_ris1r
count = count + 1;
#endif

      /*  test if old_new_vb_aux[0] -> vertex is 1-redex  */

#if dbg5_ris1r
printf("\nroot_is_1_redex: %d:", count);
printf("\nread_store_vertex(new_p_0, 3) = 0x%x; read_store_vertex(new_p_1, 3) = 0x%x",
read_store_vertex(new_p_0, 3),
read_store_vertex(new_p_1, 3)
);
printf("\nread_store_p_swap(new_p_0, 3) = 0x%x; read_store_p_swap(new_p_1, 3) = 0x%x",
read_store_p_swap(new_p_0, 3),
read_store_p_swap(new_p_1, 3)
);
printf("\nread_store_p_flip(new_p_0, 3) = 0x%x; read_store_p_flip(new_p_1, 3) = 0x%x",
read_store_p_flip(new_p_0, 3),
read_store_p_flip(new_p_1, 3)
);
printf("\nread_store_flip(new_p_0, 3) = 0x%x; read_store_flip(new_p_1, 3) = 0x%x",
read_store_flip(new_p_0, 3),
read_store_flip(new_p_1, 3)
);
printf("\nread_store_vertex(p, 3) = 0x%x; read_store_flip(p, 3) = 0x%x",
read_store_vertex(p, 3),
read_store_flip(p, 3)
);
#endif

   
         if ( read_store_vertex(new_p_0, 3) != read_store_vertex(new_p_1, 3) )
         then  /*  root is not a 1-redex  */
             {    /*  then_4  */  
               return (0);
             }   /*  then_4  */  


/* canonical form used  */

               if ( read_store_p_swap(new_p_0, 3) != 
                     read_store_p_swap(new_p_1, 3)
                   )                                
               then  /* root is not a good 1-redex candidate */
                    {    /*  then_3  */  
         
                       return (0);

                    }     /*  then_3  */  



               if ( read_store_p_flip(new_p_0, 3) != 
                     read_store_p_flip(new_p_1, 3)
                   )                                
                          then  /*  root is not a good 1-redex candidate */
 /*  then_2  */       {
                         return (0);
  /*  then_2  */     }

               if ( read_store_flip(new_p_0, 3) != 
                     read_store_flip(new_p_1, 3)
                   )                                
                          then  /*  root is not a good 1-redex candidate */
 /*  then_2  */       {
                         return (0);
  /*  then_2  */     }



/* compare vertex shifts:
 newupd[0] =  ((unsigned int *) read_store_vertex(p, 3))[0];
 newupd[1] =  ((unsigned int *) read_store_vertex(p, 3))[1].
*/

            if ( ((unsigned int *) read_store_vertex(p, 3))[0] 
                 != 
                 ((unsigned int *) read_store_vertex(p, 3))[1]
               )
             then  /*  root is not a good 1-redex candidate  */

  {  /*   1234  */
                   
return (0);

  }   /*   1234  */




/*  newupd[0] == newupd[1]   */
            
/*   root is a 1-redex  */

return (1);


  
  

}
