


#include "local.h"



void getgraphinfo(bdd G, int *info)
/*
**
**   info is info[info_size]
**
**   visits graph G and gets
**   info, i.e. :
**
**   info[0] is the size of the graph;
**
**   info[1] nonused
*
**   info[4] is the number of shift_box
**   in the graph.
**
**   info[2] is the number of edges 
**   in the graph;
**
**   info[3] is the number of vertices having at
**   least a nonzero label among flip, swap, shift
**
**   info[5] is the number of vertices having 
**   at least a non 0 shift
**
*/
{ /*  declarations  */

#if 0
  ptrvertex v;
  mark_type visited;

 /* program  */

v = read_graph_root(G);
#endif

  info[0] = 0; 
  info[1] = 0; info[4] = 0;
  info[3] = 0; info[5] = 0;
  info[6] = 0; info[7] = 0;

#if 0

  visited = get_new_mark();



  getgraphinfo_step(visited, v, info);

/*  now info[0], info[3], info[5] are well defined  */


/*  look at rootlabel  */

 
/*  now info[4] is well defined  */

/*  compute number of edges in G  */

  if (terminal(v))
  then { info[2] = 0; }
  else { info[2] = 2 * (info[0] - 1);  }


#endif

}


#if 0
static void getgraphinfo_step(mark_type visited, ptrvertex v,
int *info)
/*
**
**  recursive step for getgraphinfo
**
*/
{  /*  declarations  */
   int i;


   /* program  */

   /* v is a non-visited vertex, thus increment size */

   info[0] = info[0] + 1;

/*  Note: if v is terminal then swap, shift are NULL  */

   /*  mark v as visited */

   write_vertex_mark(v, visited);


   if (nonterminal(v))
   then {
          /*  v nonterminal  */
  

         /* update info[3]  */
         if ( ! zero_labels(v) )
         then
            { info[3] = info[3] + 1;  }



          /*  visit  */

          for (i = 0; i < 2; i = i + 1)
              { 
 
             

                if ( read_vertex_mark(read_vertex_next(v, i)) != visited )
                then  /*  v -> next[i] not yet visited  */
                     {
                       getgraphinfo_step(visited, read_vertex_next(v, i), info);
                     }
               }
         }


}


#endif
