

#include "local.h"




void printinfo(bdd G)
/*
**  prints information about rbdd G
*/
{  /* declarations  */
   int info[info_size];


/* program  */

#if 0
   getgraphinfo(G, info);

   printf("\ninfo on graph: \n");
   printf("sizegraph = number of vertices = %d\n", info[0]); 
   printf("number of vertices with at least a nonzero label = %d\n", info[3]);
   printf("number of edges in graph = %d\n", info[2]);
   printf("graph memory size = %d\n",
 (size_of_vertex() * info[0]) 
);

#endif



#if 0
   printf("total_size = \n");
   printf("graph_size + ((size_shift*shift)/size_vertex) = %f\n",
   info[0] + 
   ( 
      ( ((float) sizeof(shiftbox)) * info[4] )
    /((float) sizeof(vertex))
    ) 
   );

#endif


  print_dag_info();
  printCPUtime();
}



void print_bdd_info()
/*
**  prints information about bdd
*/
{  /* declarations  */


/* program  */

printf("\n\n********** begin print_bdd_info *******************************\n");

  
  printf("\ncache info: num.elements in cache = %d; size cache = %d",
  get_cache_elements(), 
  get_cache_size());
  print_dag_info();  
  printCPUtime();


printf("\n\n********** end print_bdd_info *******************************\n\n");

}


