/*
**  file:  create.lkup.table
**
*/


#include "lookuptb.h"
#include "local.h"


look_up_table create_lk_up_table(
int table_size,
Value_to_Value read_plot,
Value_Value write_plot,
Value_Seq_to_Boole test_less_than,
Value_Seq_to_Boole test_equal,
Value_Value_to_Boole data_less_than,
Value_to_Void free_value,
Value_to_Void update_free_tags,
Value_to_Boole to_be_erased,

Value_to_Uint htvtx_hlab,
Value_Uint_to_Uint htvtx_tlab,
Value_to_Uint size_htvtx_alllab,
Value_to_Uint get_htkey_hlab,
Value_Uint_to_Uint get_htkey_tlab,
Value_to_Uint size_htkey_alllab
)

{  /*  begin program  */


/* declarations  */
  lkup_table *T;
  int i;

    T = (lkup_table *) malloc(sizeof(lkup_table));
 
    if (T == NULL)
    then 
         {
            printf("\n**ERROR_0** no space for look_up_table\n");
            exit (1000);
         }

    T -> table = (lk_up_table_value *) malloc(table_size * sizeof(lk_up_table_value));

    if (T -> table == NULL)
    then 
         {
            printf("\n**ERROR_1** no space for look_up_table\n");
            exit (1000);
         }




/* inizialization */

    T -> elements_in_table = 0;
    T -> size_table = table_size;
    T -> non_null_entry = 0;

    T -> read_plot = read_plot;
    T -> write_plot = write_plot;
    T -> test_less_than = test_less_than;
    T -> test_equal = test_equal;
    T -> free_value = free_value;
    T -> data_less_than = data_less_than;
    T -> update_free_tags = update_free_tags;
    T -> to_be_erased = to_be_erased;
    
    T -> htvtx_hlab = htvtx_hlab;
    T -> htvtx_tlab = htvtx_tlab;
    T -> size_htvtx_alllab = size_htvtx_alllab;
    T -> get_htkey_hlab = get_htkey_hlab;
    T -> get_htkey_tlab = get_htkey_tlab;
    T -> size_htkey_alllab = size_htkey_alllab;


/*
**   initialize table
**
*/

    

    for (i = 0; i < table_size; i++)
       {
         T -> table[i] = NULL;
       }


/* end inizialization */

     return (T);


}  /*  end program  */

