

/*
**
** file: get_new_vertex
**
*/



#include "local.h"



#define dbg_flag 0   /* normal value: 0  */





void start_bddvtx_env()
{
/*  declarations  */

unsigned int B[8];


/* program  */

#if (dbg_flag > 0)
printf("\nstart_bddvtx_env: ckp 100: (begin)");
#endif

B[0] = 0;  /*  flip side 0  */
B[1] = 0;  /*  flip side 1  */
B[2] = 0;  /*  swap side 0  */
B[3] = 0;  /*  swap side 1  */
B[4] = 0;  /*  shift side 0  */
B[5] = 0;  /*  shift side 1  */
B[6] = (unsigned int) NULL;  /*  next side 0  */
B[7] = (unsigned int) NULL;  /*  next side 1  */

default_bddvtx = get_bdd_vertex(B);


/*  
    default_bddvtx cannot be deleted,
    thus locked forever.
*/


#if (dbg_flag > 0)
printf("\nstart_bddvtx_env: locking default_bddvtx = 0x%x",
default_bddvtx
);
#endif

lock_gvtx_forever(default_bddvtx);

#if (dbg_flag > 0)
printf("\nstart_bddvtx_env: locked default_bddvtx = 0x%x",
default_bddvtx
);
#endif



#if (use_extra_gvtx_info != 0)
write_extra_info_gvtx(
default_bddvtx, 
gvtx_level, 
1
);
#endif


#if (dbg_flag > 0)
printf("\nstart_bddvtx_env: return: default_bddvtx = 0x%x: (end)", 
default_bddvtx
);
#endif


}   /*  start_bddvtx   */







