/*
*************************************
File: p.c
*************************************
*/

#include "local.h"


/*
*************************************
HYP:
Args already evaluated in runenv;
composition needed.

*************************************
*/


#define sz_ap_tab 256



static void* aptab[sz_ap_tab];







/*
************************************************
Begin: To be replaced with function definitions
************************************************
*/






/* To be called before running bfp program  */

void def_apply_table()
{

aptab[tk_ifte] = (void *) apply_ifte;
aptab[tk_compose] = (void *) apply_compose;
aptab[tk_xarg] = (void *) apply_xarg;
aptab[tk_boolean] = (void *) apply_boolean;
aptab[tk_loopback] = (void *) apply_loopback;
aptab[tk_free] = (void *) apply_free;
aptab[tk_join] = (void *) apply_join;
aptab[tk_prj] = (void *) apply_prj;


aptab[tk_isone] = (void *) apply_isone;
aptab[tk_eval] = (void *) apply_eval;
aptab[tk_satasg] = (void *) apply_satasg;
aptab[tk_C] = (void *) apply_C_code;


aptab[tk_begin] = (void *) apply_begin;
aptab[tk_end] = (void *) apply_end;

aptab[tk_exec] = (void *) apply_exec;




}       /*   def_apply_table   */






ap_type apply(void *regopcode)
{ 
   return ( (ap_type) aptab[((unsigned int) regopcode)] );
}











