/*
************************************
file: ifte.c
************************************
*/


#include "local.h"




#define dbg_flag 0  /* normal value: 0  */


void apply_compose(prghdr *p)
{
/* dcl  */


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif


/*  prg  */


#if (print_info > 5)


#if (filter_ids > 100)
if ( print_id_info(p) )
/* print id info  */
{
#endif

begin_prt_info(p);


#if (keep_ids > 0)
printf(": compose %s ... ", vtxeval(p -> pc, 1));

#if 0
printf(" %s %u %s",
vtxeval(regfield(p -> pc, compose_word0), 1),
regfield(p -> pc, compose_word0 + 1),
vtxeval(regfield(p -> pc, compose_word0 + 2), 1)
);
#endif

#endif




#if (keep_ids == 0)
printf(": compose p%x ... ", p -> pc);

#if 0
printf(" p%x %u p%x",
regfield(p -> pc, compose_word0),
regfield(p -> pc, compose_word0 + 1),
regfield(p -> pc, compose_word0 + 2)
);
#endif


#endif


#if (filter_ids > 100)
}
#endif

#endif

#if (dbg_flag > 10)
printf("\napply_compose:%u: begin: p = 0x%x, pc = 0x%x", count, p, p -> pc);
#endif


/* store old bddvalue  */


p -> old_bddvalue =  filter_resetted(regfield(p -> pc, bddvalue));




#if (dbg_flag > 10)
printf("\napply_compose:%u: old_bddvalue = 0x%x", 
count, p -> old_bddvalue);
#endif


regfield(p -> pc, bddvalue) = 
glb_bdd_filter(
 compose(
	read_bddvalue(regfield(p -> pc, compose_word0)), 
	((unsigned int) regfield(p -> pc, compose_word0 + 1)), 
	read_bddvalue(regfield(p -> pc, compose_word0 + 2))
       )
);


/* update present bddvalue */
p -> new_bddvalue =  regfield(p -> pc, bddvalue);



#if (dbg_flag > 10)
printf("\napply_compose:%u: new_bddvalue = 0x%x", 
count, regfield(p -> pc, bddvalue)
);
#endif






#if (print_info > 5)


#if (filter_ids > 100)
if ( print_id_info(p) )
/* print id info  */
{
#endif

end_prt_info(p);


#if (filter_ids > 100)
}
#endif

#endif





/* increment pc */

p -> pc = regfield(p -> pc, ptr_down);





#if (dbg_flag > 10)
printf("\napply_compose:%u: newpc = 0x%x", count, p -> pc);
#endif


}  /*  apply_compose  */
