/*
************************************
file: exec.c

HYP:
Only 
exec "lts filename: (R 1)
supported.
************************************
*/


#include "local.h"


#define dbg_flag 0 /* normal value: 0  */
#define dbg_bdd 0  /* normal value: 0  */
#define dbg_vtx 0  /* normal value: 0  */



void apply_exec(prghdr *p)
{
/* dcl  */


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif


/*  prg  */
#if (dbg_bdd > 100)
printf("\n\n");
#endif




#if (print_info > 5)

#if (filter_ids > 100)
if ( print_id_info(p) )
/* print id info  */
{
#endif

begin_prt_info(p);


#if (keep_ids > 0)
printf(": exec %s ( ... ", vtxeval(p -> pc, 1));
#endif


#if (keep_ids == 0)
printf(": exec p%x ... ", p -> pc);
#endif




#if (filter_ids > 100)
}
#endif

#endif



#if (dbg_flag > 10)
printf("\napply_exec:%u: begin: p = 0x%x, pc = 0x%x", count, p, p -> pc);
#endif

/* store old bddvalue  */

p -> old_bddvalue = 
filter_resetted(
   read_bddvalue(vtxeval(regfield(p -> pc, join_word0 + 1), 1))
               );



#if (dbg_flag > 10)
printf("\napply_exec:%u: old_bddvalue = 0x%x", 
count, p -> old_bddvalue);
#endif



/* compute new value: we need to look at filename here */
/* set to 1 just for testing */


regfield(
    vtxeval(regfield(p -> pc, join_word0 + 1), 1),
                     bddvalue
       )
 = glb_bdd_one;


/* update present bddvalue */
p -> new_bddvalue =  glb_bdd_one;



#if (dbg_flag > 10)
printf("\napply_exec:%u: new_bddvalue = 0x%x.0x%x", 
count, 
regfield(p -> pc, bddvalue),
read_graph_root(
	regfield(p -> pc, bddvalue)
		)
);
#endif




#if (print_info > 5)

#if (filter_ids > 100)
if ( print_id_info(p) )
/* print id info  */
{
#endif

  end_prt_info(p);


#if (filter_ids > 100)
}
#endif

#endif



/* increment pc */

p -> pc = regfield(p -> pc, ptr_down);



#if (dbg_flag > 10)
printf("\napply_exec:%u: newpc = 0x%x", count, p -> pc);
#endif


}  /*  apply_exec  */
