/*
************************************
file: ifte.c
************************************
*/


#include "local.h"


#define dbg_flag 0  /* normal value: 0  */



void apply_join(prghdr *p)
{
/* dcl  */
unsigned int i;

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif


/*  prg  */

#if (print_info > 5)

#if (filter_ids > 100)
if ( print_id_info(p) )
/* print id info  */
{
#endif

begin_prt_info(p);


#if (keep_ids > 0)
   printf(": join %s ( ... ", vtxeval(p -> pc, 1) );
#endif


#if (keep_ids == 0)
                      printf(": join p%x ( ... ",
p -> pc
);
#endif



#if 0
              
                    for (
i = 0; 
i < (unsigned int) regfield(p -> pc, join_word0); 
i++)
                       {
#if (keep_ids > 0)
printf("%s ",
   vtxeval(vtxeval(regfield(p -> pc, join_word0 + 1), i), 1)
 );
#endif


#if (keep_ids == 0)
printf("%u ",
    vtxeval(regfield(p -> pc, join_word0 + 1), i)
 );
#endif
                       } /* for */

#endif



                      printf(")");


#if (filter_ids > 100)
}
#endif


#endif



#if (dbg_flag > 10)
printf("\napply_join:%u: begin: p = 0x%x, pc = 0x%x", count, p, p -> pc);
printf("\nglb_bdd_zero == 0x%x; glb_bdd_one == 0x%x", 
glb_bdd_zero,
glb_bdd_one
);
#endif


/* join bddvalue is always 0 */
regfield(p -> pc, bddvalue) = glb_bdd_zero;

/* update present bddvalue */
p -> new_bddvalue =  regfield(p -> pc, bddvalue);


/*
We choose old bddvalue as follows:
old_bddvalue = 0 if all join components unchanged
old_bddvalue = 1 if at least a join component changed
*/



/* define  old bddvalue  */

p -> old_bddvalue = glb_bdd_zero;


for (
i = 0; 
i < (unsigned int) regfield(p -> pc, join_word0); 
i++)
                       {  /* for i */

#if (dbg_flag > 10)
printf("\napply_join:%u: for: i = %u", count, i);
printf("\nread_bddarray(p -> pc, i) == 0x%x", 
read_bddarray(p -> pc, i)
);

printf(
"\nregfield(p -> pc, join_word0 + 1) == 0x%x", 
regfield(p -> pc, join_word0 + 1)
);
printf(
"\nvtxeval(regfield(p -> pc, join_word0 + 1), i) == 0x%x", 
vtxeval(regfield(p -> pc, join_word0 + 1), i)
);
printf(
"\nread_bddvalue(vtxeval(regfield(p -> pc, join_word0 + 1), i)) == 0x%x", 
read_bddvalue(vtxeval(regfield(p -> pc, join_word0 + 1), i))
);
#endif


  if ( !bdd_equal(
             (bdd) read_bddarray(p -> pc, i),

            (bdd) read_bddvalue(
 vtxeval(regfield(p -> pc, join_word0 + 1), i)
                               )
                 )
 
    )
/*  join component i changed */
{   /* then 1 */

#if (dbg_flag > 10)
printf("\napply_join:%u: begin then: join component i = %u changed", count, i);
#endif

p -> old_bddvalue = glb_bdd_one;

/*  update */

#if (dbg_flag > 10)
printf("\napply_join:%u: free 0x%x", count, read_bddarray(p -> pc, i));
#endif

delete_nonglb_bdd( read_bddarray(p -> pc, i) );


#if (dbg_flag > 10)
printf("\napply_join:%u: update", count);
#endif


vtxeval(regfield(p -> pc, bddarray), i)
=
glb_bdd_copy(
    read_bddvalue(
 vtxeval(regfield(p -> pc, join_word0 + 1), i)
                               )
);

#if (dbg_flag > 10)
printf("\napply_join:%u: end then: vtxeval(regfield(p -> pc, bddarray), i) = 0x%x", 
count,
vtxeval(regfield(p -> pc, bddarray), i)
);
#endif


} /* then 1 */


                       }  /* for i  */



/*
  old_bddvalue and bddarray defined  
*/



#if (dbg_flag > 10)
printf("\napply_join:%u: old_bddvalue = 0x%x", 
count, p -> old_bddvalue);
#endif





#if (dbg_flag > 10)
printf("\napply_join:%u: new_bddvalue = 0x%x", 
count, regfield(p -> pc, bddvalue)
);
#endif





#if (print_info > 5)

#if (filter_ids > 100)
if ( print_id_info(p) )
/* print id info  */
{
#endif

end_prt_info(p);

#if (filter_ids > 100)
}
#endif

#endif


/* increment pc */

p -> pc = regfield(p -> pc, ptr_down);

#if (dbg_flag > 10)
printf("\napply_join:%u: newpc = 0x%x", count, p -> pc);
#endif


}  /*  apply_join  */
