/*
************************************
file: skip.c
************************************
*/


#include "local.h"




#define dbg_flag 0  /* normal value: 0  */


/*
***********************************
Return 1 if id in pc does not start with _,
0 else
***********************************
*/


int print_id_info(prghdr* p)
{
/* dcl  */


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif


/*  prg  */

#if (dbg_flag > 10)
fprintf(stderr, "\nprint_id_info:%u: begin", count);
#endif


if (keep_ids == 0) 
/* no print */
{

#if (dbg_flag > 10)
fprintf(stderr, "\nprint_id_info:%u: keep_ids == 0: return 0", count);
#endif

return (0);

}


#if (dbg_flag > 10)
fprintf(stderr, "\nprint_id_info:%u: id = %s", 
count, 
(char *) vtxeval(p -> pc, 1)
);
#endif


if ( ((char *) vtxeval(p -> pc, 1))[0] == '_')
/* internal id */
   {


#if (dbg_flag > 10)
fprintf(stderr, "\nprint_id_info:%u: '_' found: return 0.", 
count
);
#endif

    return (0);  

   }



#if (dbg_flag > 10)
fprintf(stderr, "\nprint_id_info:%u: '_' not found: return 1.", 
count
);
#endif

/* id does not start with _  */

    return (1);
 



}  /*  print_id_info  */
