/*
**
**  file: delee.c
**
*/




#include "local.h"


#define dbg_flag 0  /*  normal value:  0  */



/*
*******************************
Check that for all ids there is
a definition.
I.e. *info is not NULL.


*******************************
*/









void check_id_def(void* T)
{

/* declarations  */
  ht_value *v;
  unsigned int i;

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif

/* programs  */


#if (dbg_flag > 10)
printf("\n\ncheck_id_def:%u: begin: symbol_table = 0x%x",
count,
T
);
#endif


    for (i = 0; i < get_symbtab_size(T); i++)
       {


#if (dbg_flag > 10)
printf("\ncheck_id_def:%u: check ids in row %u",
count,
i
);
#endif




          v = (ht_value *) ( ((hash_table *) T) -> table[i] );
          

 


        
          while (v != NULL)
          {

#if (dbg_flag > 10)
printf("\ncheck_id_def:%u: delete row %u: key = %s",
count,
i,
read_stbk_key((void *) v)
);
#endif 




 if ( read_stbk_tkcode((void *) v) == tk_id )
 /*  check id def  */
 { 
 
    if (*((void**) read_stbk_info((void *) v)) == NULL )
    /* error  */
      {


          printf("\nerror: id %s has not been defined\n",
                  read_stbk_key((void *) v)
                );

           exit (1);
     }
   
   /*  ok  */

 } 

/*  ok  */

             v = read_stbk_next((void *) v);
 


          }    /*  while  */



          
       }   /*  for i  */



#if (dbg_flag > 10)
printf("\ncheck_id_def:%u: end",
count
);
#endif

}  /* end program  */
