/*
*************************************
file: newdef.c


Read id def via boole.


Returns pointer to id defined.
*************************************
*/


#include "local.h"



#define dbg_flag 0  /* normal value: 0  */
 


void check_newdef(void* *p  /* token */)
{
/*  dcl  */

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif


/*  prg  */


#if (dbg_flag > 10)
printf("\ncheck_newdef:%u: begin: check file %s, line %u, def of %s", 
count,
lexan_fname(), 
lex_line_number(),
read_stbk_key(p[1])
);
#endif


/* This is id def. 
   Since ids defined at most once
   id value should be  NULL
*/

if ( *((void* *) read_stbk_info(p[1])) != NULL)
/* error */
 {
  printf("\nparse error in file %s line %u: redefinition of %s",
                          lexan_fname(), lex_line_number(),
read_stbk_key(p[1])
);
         exit (1);
 }



/* ok: id not previously defined */



}  /*  check_newdef  */ 












