/*
*************************************
file: store.c


Read varord and store it in vertex
vtx
This is to be used by query.
*************************************
*/


#include "local.h"



#define dbg_flag 0  /* normal value: 0  */
 


void read_varord(void* vtx, void* *p  /* token */)
{
/*  dcl  */

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif


/*  prg  */


#if (dbg_flag > 1000)
printf("\nread_varord:%u: begin: vtx = 0x%x, token = 0x%x", 
count, vtx, p);
#endif


/* read varord, i.e. ordlist_reg  */

read_new_token(p);
if (p[0] != (void *) tk_id)
/* error */
{
                 printf("\nerror in file %s line %u: id expected",
                          lexan_fname(), lex_line_number());

                 exit (1);
}

/* ok ordlist id found */


#if (dbg_flag > 1000)
printf("\nread_varord:%u: found ordlist id %s, varord=0x%x", 
count, 
read_stbk_key(p[1]),
read_stbk_info(p[1])
);
#endif

vtxeval(vtx, query_word0 + 1) = read_stbk_info(p[1]);

#if (dbg_flag > 1000)
printf("\nread_varord:%u: end: vtx varord = 0x%x", 
count, 
vtxeval(vtx, query_word0 + 1)
);
#endif


}  /*  read_varord  */ 












