/*
*********************************
file: bp10.c
*********************************
*/


#include "local.h"

#include <time.h>


#include "etlogo.h"


#define dbg_flag 0   /*  normal value: 0  */
#define dbg_flag_1 0   /*  normal value: 0  */




void bp10(char *prgfile, char* answfile)
{
/* declarations  */
FILE *qfile;
FILE *cfile;

prghdr* prg;



/* prg */


#if (dbg_flag > 0)
printf("\nbp10: begin: prgfile = %s, answfile = %s",
prgfile, answfile
);
#endif


printf("\n\n\nbp10 version: 1.1 (April 97)");
et_signature();




#if (dbg_flag > 0)
printf("\nbp10: init run env");
#endif


/* initialize run env. (bdd, etc)  */

init_run_env();


#if (dbg_flag > 0)
printf("\nbp10: upload and execute %s", prgfile);
#endif


/* upload and run prg */
prg = upload(prgfile, answfile);




#if (dbg_flag > 10)
printf("\nbp10: show prgfile");
download(prg, "showprg.b10");
#endif


#if (dbg_flag > 100)
printf("\nbp10: check syntax");
#endif


#if 0
/* done in bp11  */
syntax(prg);
#endif



#if (dbg_flag > 100)
printf("\nbp10: run program");
#endif

#if 0
/* done in upload() */
runprg(prg);
#endif




/*  Complete file .c  if any  */


if ( prg -> cfilename != NULL )
/* C code in file */
{

cfile = fopen(prg -> cfilename, "a");
dumpbddtab(cfile);
fclose(cfile);

}



printf("\n\n\nbp10: time, memory info:\n\n\n");

print_rusage(stdout);

#if 0
system("ps -u | egrep \"PID|bp10\""); /* linux home PC */
system("ps -lu $USER | egrep \"PID|bp10\""); /* SUN, Solaris: smaq20 */
#endif



#if (dbg_flag > 100)
printf("\nbp10: end");
#endif

}    /*  main  */



