/*
*************************************
file: loopopt.c

Esy part of loop optimization.



*************************************
*/


#include "local.h"



#define dbg_flag 0 /* normal value: 0  */
 

/*
 Append new_reg to prg_reg
*/


/*
HYP: regfield(prg_reg, ptr_down) != NULL
*/
 

void append_newreg(void *prg_reg, void *new_reg)
{
/* dcl */

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif


/* prg  */

#if (dbg_flag > 100)
printf("\nappend_newreg:%u: begin: prg_reg = 0x%x, new_reg = 0x%x", 
count, prg_reg, new_reg
);
#endif


/*  append new_reg to prg_reg */

regfield(new_reg, ptr_down) = regfield(prg_reg, ptr_down);
regfield(new_reg, ptr_up) = prg_reg;
regfield(regfield(prg_reg, ptr_down), ptr_up) = new_reg;
regfield(prg_reg, ptr_down) = new_reg;



#if (dbg_flag > 100)
printf("\nappend_newreg:%u: end", 
count
);
#endif

}  /*  append_newreg  */



