/*
*************************************
file: loopopt.c

Esy part of loop optimization.



*************************************
*/


#include "local.h"



#define dbg_flag 0 /* normal value: 0  */
 

/*
 Move prg_reg in program p
 after append_reg.
*/


void* move_reg(prghdr *p, void *append_reg, void *prg_reg)
{
/* dcl */

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif


/* prg  */

#if (dbg_flag > 100)
printf("\nmove_reg:%u: begin: program = 0x%x; append_reg = 0x%x, prg_reg = 0x%x", 
count, p, append_reg, prg_reg);
#endif


   
/* unlink prg_reg */

vtxeval(
 regeval(
    vtxeval(regeval(prg_reg), ptr_up)),
 ptr_down) =
vtxeval(regeval(prg_reg), ptr_down);

vtxeval(
 regeval(
    vtxeval(regeval(prg_reg), ptr_down)),
 ptr_up) =
vtxeval(regeval(prg_reg), ptr_up);


#if (dbg_flag > 100)
printf("\nmove_reg:%u: link prg_reg to append_reg", count);
#endif



/* link prg_reg to append_reg */
vtxeval(regeval(prg_reg), ptr_up) = append_reg;
vtxeval(regeval(prg_reg), ptr_down) = 
   vtxeval(regeval(append_reg), ptr_down);

vtxeval(
   regeval(vtxeval(regeval(append_reg), ptr_down)), 
   ptr_up)
=
prg_reg;

vtxeval(regeval(append_reg), ptr_down) = prg_reg;

   
#if (dbg_flag > 100)
printf("\nmove_reg:%u: end: return prg_reg = 0x%x", 
count, prg_reg);
#endif

return (prg_reg);


}  /*  move_reg  */





