/*
*************************************
file: download.c



Write program p in file filename.
*************************************
*/


#include "local.h"



#define dbg_flag 0   /* normal value: 0  */
#define print_ord 100  /* normal value: 0  */
#define argpos_arity 20  /* used in print argpos */




void bsa_download(prghdr* phdr, /* program header */
              char *filename)
{

/* dcl  */
FILE* fileptr;
void* p;  /* prg label for instruction  */
void *p_vtx;   /* prg vertex  */
unsigned int i;



#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
printf("\nbsa_download:%u: begin, open file", count);
#endif


/* initialize lexan  */

fileptr = fopen(filename, "w");



#if (dbg_flag > 100)
printf("\nbsa_download:%u: print reglist", count);
#endif



/*
*************************
No reglists in bsa
*************************
*/




/*
*************************
No xlists in bsa
*************************
*/



/*
*************************
Print ordlists
*************************
*/

fprintf(fileptr, "\n\n/* Ordlist (at most one) */\n\n");

/*  first instruction */
p = phdr -> ordlist;

 while (p != NULL)
  {
       /* print line, p != NULL */

p_vtx = *((void* *) p);

       fprint_bsareg(fileptr, phdr, p);

       p = ((void* *) p_vtx)[ptr_down];

  }   /* while */







#if (dbg_flag > 100)
printf("\nbsa_download:%u: print program", count);
#endif


/*
*************************
Print program instructions
*************************
*/
fprintf(fileptr, "\n\n/* Program Instructions */\n\n");

/*  first instruction */
p = phdr -> prg;




 while (p != NULL)
  {
       /* print line, p != NULL */

       p_vtx = *((void* *) p);

       fprint_bsareg(fileptr, phdr, p);

       p = ((void* *) p_vtx)[ptr_down];

  }   /* while */







#if (dbg_flag > 100)
printf("\nbsa_download:%u: close file", count);
#endif



fclose(fileptr);


#if (dbg_flag > 10)
printf("\nbsa_download:%u: end", count);
#endif




}  /*  prg  */





















