/*
*********************************
file: bsa.c
*********************************
*/


#include "local.h"
#include "etlogo.h"




#define dbg_flag 0   /*  normal value: 0  */




void bp30(char *prgfile, char* outfile)
{
/* declarations  */


prghdr* prg;


/* prg */


#if (dbg_flag > 0)
printf("\nbp30: begin: prgfile = %s, outfile = %s",
prgfile, outfile
);
#endif



 printf("\n\n\nbp30 version: 1.1 (April 1997)");

et_signature();



#if (dbg_flag > 0)
printf("\nbp30: upload %s", prgfile);
#endif


prg = upload(prgfile);


#if (dbg_flag > 10)
printf("\nbp30: show input prgfile in: showprg.bp30");
download(prg, "showprg.bp30");
#endif


#if (dbg_flag > 0)
printf("\nbp30: if no ordlist define ordlist (automatic var ordering)");
#endif


def_ordlist(prg);



#if (dbg_flag > 10)
printf("\nbp30: show ordlist in: ordprg.bp30");
download(prg, "ordvar.bp30");
#endif



#if (dbg_flag > 0)
printf("\nbp30: compute absolute indexes");
#endif

def_abs_idx(prg);


#if (dbg_flag > 0)
printf("\nbp30: show abs indexes in: abp30dx.bp30");
download(prg, "abp30dx.bp30");
#endif




#if (dbg_flag > 0)
printf("\nbp30: show compose translation in: bsacmp.bp30");
bsa_download(prg, "bsacmp.bp30");
#endif




#if (dbg_flag > 100)
printf("\nbp30: define ordlist for bsa");
#endif


def_bsa_ordlist(prg);


#if (dbg_flag > 0)
printf("\nbp30: show ordlist ofr bsa in: ordlist.bp30");
bsa_download(prg, "ordlist.bp30");
#endif




bsa_download(prg, outfile);



printf("\n\n\nbp30: time, memory info:\n\n\n");

print_rusage(stdout);

#if 0
system("ps -u | egrep \"PID|bp30\""); /* linux home PC */
system("ps -lu tronci | egrep \"PID|bp30\""); /* SUN, Solaris: smaq20 */
#endif


#if (dbg_flag > 100)
printf("\nbp30: end");
#endif

}    /*  main  */



