/*
*************************************
file: deford.c


If no ordlist is given an argument ordering
is choosen automatically.
*************************************
*/


#include "local.h"



#define dbg_flag 0 /* normal value: 0  */




void def_ordlist(prghdr* p)
{
/* dcl */



#if (dbg_flag > 0)
static int count = 0;
count++;
#endif


/* prg  */

#if (dbg_flag > 100)
printf("\ndef_ordlist:%u: begin: program = 0x%x", count, p);
#endif

if (p -> ordlist != NULL)
/* ordlist defined */
{

   return;
}


/* ordlist not defined: define it */

/* automatic ordering should be called. TO BE IMPLEMENTED */

/* Meantime we use the following default ordering */

p -> ordlist = get_prgreg();
vtxeval(p -> ordlist, 0) = get_prgvtx(size_ordlist);
vtxeval(p -> ordlist, 1) = "AutVarOrd";
regfield(p -> ordlist, op_code) = (void *) tk_ordlist;
regfield(p -> ordlist, ptr_up) = NULL;
regfield(p -> ordlist, ptr_down) = NULL;
regfield(p -> ordlist, ordlist_word0) = (void *) 1;
regfield(p -> ordlist, ordlist_word0 + 1) = get_prgvtx(1);
vtxeval(
	regfield(p -> ordlist, ordlist_word0 + 1),
	0
       ) = (void *) 0;





#if (dbg_flag > 100)
printf("\ndef_ordlist:%u: end: program = 0x%x", count, p);
#endif


}   /* prg  */






