/*
*************************************
file: binop.c


Read id def via binary operator:
and
or
xor
eq
nor
nand
imp.

HYP: op string in reg.
*************************************
*/


#include "local.h"



#define dbg_flag 0  /* normal value: 0  */
 


void* read_boole_op(void* *p  /* token */, unsigned int arity)
{
/*  dcl  */
unsigned int i;

void* result;
void* vtx;


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif


/*  prg  */


#if (dbg_flag > 1000)
printf("\nread_boole_op:%u: ckp 100 (begin)", count);
#endif


/* 
   Opcode is in token[0].
   We need to read (arity + 1) ids.  
   They are all id's.
   The first one is the one being defined.
*/



vtx = get_prgvtx(size_0op + arity);


((void* *) vtx)[op_code] = p[0];


read_new_token(p);
if (p[0] != (void *) tk_id)
/* error */
{
                 printf("\nerror in file %s line %u: id expected",
                          lexan_fname(), lex_line_number());

                 exit (1);
}


/* ok: p[0] == tk_id  */

check_newdef(p);

result = read_stbk_info(p[1]);
*((void* *) result) = vtx;




for (i = 0; i < arity; i++)
   {

read_new_token(p);
if (p[0] != (void *) tk_id)
/* error */
{
                 printf("\nerror in file %s line %u: id expected",
                          lexan_fname(), lex_line_number());

                 exit (1);
}


/* ok: p[0] == tk_id  */

((void* *) vtx)[size_0op + i] = read_stbk_info(p[1]);


    }






/* return result */

return (result);


}  /*  read_boole_op()  */ 












