/*
*************************************
file: binders.c


Read exists, forall.

HYP: op string in reg.
*************************************
*/


#include "local.h"



#define dbg_flag 0  /* normal value: 0  */
 


void* read_quantifiers(void* *p  /* token */)
{
/*  dcl  */
void* result;
unsigned int arity;


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif


/*  prg  */


#if (dbg_flag > 1000)
printf("\nread_quantifiers:%u: ckp 100 (begin)", count);
#endif


/* 
   Opcode is in token[0].
   We need to read (arity + 1) ids.  
   They are all id's.
   The first one is the one being defined.
*/


result = read_boole_op(p, &arity);

if ( arity != 2 )
/* error */
  {
                 printf("\nerror in file %s line %u: 1 rhs arg expected",
                          lexan_fname(), lex_line_number());

                 exit (1);

  }

/* ok  */


/* return result */

return (result);


}  /*  read_quantifiers()  */ 












