/*
*************************************
file: boole.c


Read id def via boole.


Returns pointer to id defined.
*************************************
*/


#include "local.h"



#define dbg_flag 0  /* normal value: 0  */
 


void* read_boole(void* *p  /* token */)
{
/*  dcl  */
void* result;
unsigned int arity;


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif


/*  prg  */


#if (dbg_flag > 1000)
printf("\nread_boole:%u: ckp 100 (begin)", count);
#endif


/* 
   Opcode is in p[0].
   We need to read 1 id and an unsigned int
*/


result = read_xlist(p, &arity);

if ( (unsigned int) regfield(result, bop_word0) > 1 )
/* error */
  {
                 printf("\nerror in file %s line %u: 0 or 1 expected",
                          lexan_fname(), lex_line_number());

                 exit (1);

  }

/* ok  */

if ( arity != 1 )
/* error */
  {
                 printf("\nerror in file %s line %u: 1 rhs arg expected",
                          lexan_fname(), lex_line_number());

                 exit (1);

  }

/* ok  */




    
/* return result */

return (result);


}  /*  read_boole  */ 












