/*
*************************************
file: xarg.c


Read id def via boole.


Returns pointer to id defined.
*************************************
*/


#include "local.h"



#define dbg_flag 0  /* normal value: 0  */
 


void* read_prj(void* *p  /* token */)
{
/*  dcl  */
void* result;
void *listq_fifo, *tlist_vtx;

void *bop_opcode;



#if (dbg_flag > 0)
static int count = 0;
count++;
#endif


/*  prg  */


#if (dbg_flag > 1000)
printf("\nread_boo:%u: ckp 100 (begin)", count);
#endif


/* 
   Opcode is in token[0].
   We need to read 2 ids and an unsigned int
*/


/* store opcode */
bop_opcode = p[0];



/* read lhs */


read_new_token(p);
if (p[0] != (void *) tk_id)
/* error */
{
                 printf("\nerror in file %s line %u: id expected",
                          lexan_fname(), lex_line_number());

                 exit (1);
}

#if (dbg_flag > 100)
printf("\nread_boole_op:%u: lhs id: %s", count, read_stbk_key(p[1]));
#endif



/* ok: p[0] == tk_id  */

check_newdef(p);


result = read_stbk_info(p[1]);


tlist_vtx =  get_prgvtx(bop_word0 + 2);

vtxeval(tlist_vtx, op_code) = (void *) tk_prj;
regeval(result) = tlist_vtx;
  






read_new_token(p);
if (p[0] != (void *) tk_id)
/* error */
{
                 printf("\nerror in file %s line %u: id expected",
                          lexan_fname(), lex_line_number());

                 exit (1);
}

#if (dbg_flag > 100)
printf("\nread_boole_op:%u: rhs id: %s", count, read_stbk_key(p[1]));
#endif



/* ok: p[0] == tk_id  */

/* store */
vtxeval(tlist_vtx, bop_word0) = read_stbk_info(p[1]);





/*  read num  */

read_new_token(p);
if (p[0] != (void *) tk_num)
/* error */
{
                 printf("\nerror in file %s line %u: num expected",
                          lexan_fname(), lex_line_number());

                 exit (1);
}

#if (dbg_flag > 100)
printf("\nread_boole_op:%u: rhs num: %u", count, p[1]);
#endif



/* ok: p[0] == tk_num  */


/* store */
vtxeval(tlist_vtx, bop_word0 + 1) = p[1];





/*  read )  */

read_new_token(p);
if (p[0] != (void *) tk_rightpar)
/* error */
{
                 printf("\nerror in file %s line %u: ')' expected",
                          lexan_fname(), lex_line_number());

                 exit (1);
}

#if (dbg_flag > 100)
printf("\nread_boole_op:%u: rhs )", count);
#endif





/* return result */

return (result);


}  /*  read_prj  */ 












