/*
*************************************
file: and.c

Print and into ifte.

HYP: bdd 0 in __0, bdd 1 in __1.
*************************************
*/


#include "local.h"



#define dbg_flag 0  /* normal value: 0  */




void exec(FILE* fileptr, void* prg_reg)
{
/* dcl */
unsigned int i;

/* prg  */


#if (dbg_flag > 10)
fprintf(stderr, "\nexec: begin");
#endif

               fprintf(fileptr, "exec");

#if (dbg_flag > 10)
fprintf(stderr, "\nexec: arity = ");
fprintf(stderr, "%u", 
((unsigned int) regfield(prg_reg, bop_arity))
);
#endif

               fprintf(fileptr, " \"%s\" (",
regfield(prg_reg, bop_word0)
);


#if (dbg_flag > 10)
fprintf(stderr, "\nexec: string printed: ");
fprintf(stderr, "%s", regfield(prg_reg, bop_word0));
#endif


for (i = 1; 
     i < ((unsigned int) regfield(prg_reg, bop_arity));
     i = i + 2)
{

               fprintf(fileptr, " %s",
vtxeval(regfield(prg_reg, bop_word0 + i), 1)
);

#if (dbg_flag > 10)
fprintf(stderr, "\nexec: id %u printed: ", i);
fprintf(stderr, "%s", vtxeval(regfield(prg_reg, bop_word0 + i), 1) );
#endif

               fprintf(fileptr, " %u",
regfield(prg_reg, bop_word0 + i + 1)
);

#if (dbg_flag > 10)
fprintf(stderr, "\nexec: idsize %u printed: ", i);
fprintf(stderr, "%u", regfield(prg_reg, bop_word0 + i + 1) );
#endif


}  /* for i */


fprintf(fileptr, " )\n");


#if (dbg_flag > 10)
fprintf(stderr, "\nexec: end");
#endif



}  /*  exec()  */

















