/*
********************************
file: local.h

********************************
*/



#include "parser.h"
#include "lexan.h"
#include "prgvtx.h"
#include "lextkns.h"



void* read_new_term();


void* create_fifo();
void in_fifo(void *fifo, unsigned int value);
unsigned int out_fifo(void *fifo);
void delete_fifo(void *fifo);
void** emptyfifo(void* tbuf, unsigned int tsize);



void* atom_id(void* p[2]   /*  token  */);
void* atom_num(void* p[2]   /*  token  */);
void* atom_string(void* p[2]   /*  token  */);
void* atom_keyword(void* p[2]   /*  token  */);
void* read_op(void* p[2]   /*  token  */);


void* read_new_term();


void emptyfifo2vtx(
void* listq, /* fifo buffer */
void* tlist,   /* vtx buffer */
unsigned int listsize  /* fifo size */
);


void check_newdef(void* *p  /* token */);


void read_varord(void* vtx, void* *p  /* token */);


int check_ordlist(void* ordlist_reg  /* != NULL */);




void* read_quantifiers(void* *p  /* token */);





void eptybopfifo2vtx(
void* listq, /* fifo buffer */
void* tlist,   /* vtx buffer */
unsigned int listsize  /* fifo size */
);


