/*
*********************************
file: go.c
*********************************
*/


#include "local.h"



#define dbg_flag 0  /*  normal value: 0  */

#include "etlogo.h"



void bp61(char *prgfile, char* outfile)
{
/* declarations  */


prghdr* prg;


/* prg */


#if (dbg_flag > 0)
printf("\nbp61: begin: prgfile = %s, outfile = %s",
prgfile, outfile
);
#endif



  printf("\n\n\nbp61 version: 1.1 (June 1997)");
et_signature();



#if (dbg_flag > 0)
printf("\nbp61: upload(%s, %s)", prgfile, outfile);
#endif


prg = upload(prgfile, outfile);


#if (dbg_flag > 10)
printf("\nbp61: end upload\n");
#endif



#if 0

#if (dbg_flag > 10)
printf("\nbp61: begin syntax");
#endif



 syntax(prg);



#if (dbg_flag > 10)
printf("\nbp61: syntax done: begin translation");
download(prg, "showprg.b61");
#endif


translate(prg, outfile);



#if (dbg_flag > 10)
printf("\nbp61: end translation");
#endif

#endif




printf("\n\n\nbp61: time, memory info:\n\n\n");

print_rusage(stdout);

#if 0
system("ps -u | egrep \"PID|bp61\""); /* linux home PC */
system("ps -lu tronci | egrep \"PID|bp61\""); /* SUN, Solaris: smaq20 */
#endif




#if (dbg_flag > 100)
printf("\nbp61: end");
#endif

}    /*  main  */



