/*
*************************************
file: eqv.c

HYP:
No terms nested in bp63.


*************************************
*/


#include "local.h"



#define dbg_flag 0   /* normal value: 0  */





/*
************************

term is an id or a keyword,

string returned.

************************
*/


char* singleton(void* term)
{
/* dcl  */


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
printf("\nsingleton:%u: begin", count);
#endif


switch ( (int) vtxeval(term, op_code) )
    {

        case tk_id:

                  return (

(char *) 
vtxeval(
   idarray(vtxeval(term, op_word0)),
   lexid_string
       )

                         );

        case tk_ap:  /* error */

                fprintf(stderr, 
"\nsingleton: Error: ap term found: expected id or atom\n");

exit (1);




       default:  /* keyword assumed */


        return (
keywstring( (unsigned int) vtxeval(term, op_code) )
               );




    }    /* switch */


}  /* singleton  */


