/*
********************************
file: local.h
********************************
*/

#include "lexan.h"
#include "prgvtx.h"
#include "trans.h"


#define BUF_SIZE 200


char* get_char_buf(unsigned int size);
int term_trans(FILE* fileptr, void* term);
int atom_trans(FILE* fileptr, void* term);
int nonatom_trans(FILE* fileptr, void* term);
int defapterm_trans(FILE* fileptr, void* term);
int bopterm_trans(char *prfxname, FILE* fileptr, void* term);



void eqv(FILE* fileptr,  void* term);
void add(FILE* fileptr,  void* term);
void sub(FILE* fileptr,  void* term);
void mult(FILE* fileptr,  void* term);



void mux(FILE* fileptr,  void* term);

void mux_term(
FILE* fileptr, 
void *term, 
unsigned int k, 
unsigned int X_size
);



void less(FILE* fileptr,  void* term);


void less_step(
FILE* fileptr,  
void* term, 
unsigned int k
);



void leq(FILE* fileptr,  void* term);


void leq_step(
FILE* fileptr,  
void* term, 
unsigned int k
);




void grt(FILE* fileptr,  void* term);


void grt_step(
FILE* fileptr,  
void* term, 
unsigned int k
);




void geq(FILE* fileptr,  void* term);


void geq_step(FILE* fileptr,  void* term, unsigned int k);
