/*
*************************************
file: eqv.c

HYP:
No terms nested in bp63.


*************************************
*/


#include "local.h"



#define dbg_flag 0   /* normal value: 0  */





/*
************************
To be implemented

term is
=
(def p (eqv p1 p2))


************************
*/


void eqv(FILE* fileptr,  void* term)
{
/* dcl  */

int i, lhs_size;

void *rhs_term;

char buf[10][BUF_SIZE];

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
printf("\neqv:%u: begin", count);
#endif

rhs_term = vtxeval(term, op_word0 + 2);



#if (dbg_flag > 10)
printf("\neqv:%u: rhs_term = 0x%x: ", count, rhs_term);
print_term(stderr, rhs_term);
#endif


lhs_size = 
(int) 
vtxeval(
    idarray(vtxeval(vtxeval(rhs_term, op_word0 + 1), op_word0)),
    lexid_vctsize
       );


#if (dbg_flag > 10)
printf("\neqv:%u: size of rhs terms = %u", count, lhs_size);
#endif



i = 0;




sprintf(buf[0], "%s_%u_%u",
signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
4*i
);

mkaux(buf[0]);


fprintf(fileptr, "(def %s (prj %s %u))\n",

buf[0],

singleton(vtxeval(rhs_term, op_word0 + 1)),

i

);


#if (dbg_flag > 10)
printf("\neqv:%u:  defined %s_%u_%u", count, 
signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
4*i
);
#endif









sprintf(buf[0], "%s_%u_%u",
signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
4*i + 1
);

mkaux(buf[0]);

fprintf(fileptr, "(def %s (prj %s %u))\n",

buf[0],

singleton(vtxeval(rhs_term, op_word0 + 2)),

i

);






#if (dbg_flag > 10)
printf("\neqv:%u:  defined %s_%u_%u", count, 
signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
4*i + 1
);
#endif






sprintf(buf[0], "%s_%u_%u",
signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
4*i + 3
);



sprintf(buf[1], "%s_%u_%u",
signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
4*i
);


sprintf(buf[2], "%s_%u_%u",
signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
4*i + 1
);


mkaux(buf[0]);
mkaux(buf[1]);
mkaux(buf[2]);

fprintf(fileptr, "(def %s (eq %s %s))\n",

buf[0],

buf[1],

buf[2]

);







#if (dbg_flag > 10)
printf("\neqv:%u:  defined %s_%u_%u", count, 
signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
4*i + 2
);
#endif


/* define transitions */

for (i = 1; i < lhs_size; i++)
   {


#if (dbg_flag > 10)
printf("\neqv:%u:  begin for i = %u", count, i);
#endif





sprintf(buf[0], "%s_%u_%u",
signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
4*i
);

mkaux(buf[0]);


fprintf(fileptr, "(def %s (prj %s %u))\n",

buf[0],

singleton(vtxeval(rhs_term, op_word0 + 1)),

i

);









sprintf(buf[0], "%s_%u_%u",
signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
4*i + 1
);

mkaux(buf[0]);


fprintf(fileptr, "(def %s (prj %s %u))\n",

buf[0],

singleton(vtxeval(rhs_term, op_word0 + 2)),

i

);






sprintf(buf[0], "%s_%u_%u",
signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
4*i + 2
);


sprintf(buf[1], "%s_%u_%u",
signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
4*i
);


sprintf(buf[2], "%s_%u_%u",
signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
4*i + 1
);


mkaux(buf[0]);
mkaux(buf[1]);
mkaux(buf[2]);


fprintf(fileptr, "(def %s (eq %s %s))\n",

buf[0],

buf[1],

buf[2]

);







sprintf(buf[0], "%s_%u_%u",
signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
4*i + 3
);

sprintf(buf[1], "%s_%u_%u",
signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
4*(i - 1) + 3
);


sprintf(buf[2], "%s_%u_%u",
signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
4*i + 2
);


mkaux(buf[0]);
mkaux(buf[1]);
mkaux(buf[2]);


fprintf(fileptr, "(def %s (and %s %s))\n",

buf[0],

buf[1],

buf[2]
);




#if (dbg_flag > 10)
printf("\neqv:%u:  end for i = %u", count, i);
#endif


   }   /* for i */


/* i = lhs_size  */





sprintf(buf[0], "%s_%u_%u",
signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
4*(i - 1) + 3
);


mkaux(buf[0]);

fprintf(fileptr, "(def %s %s)\n",

vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_string
       ),


buf[0]

);




#if (dbg_flag > 10)
printf("\neqv:%u: end", count);
#endif

}  /* eqv */


