/*
*************************************
file: trans.c

HYP:
No terms nested in bp65.


*************************************
*/


#include "local.h"



#define dbg_flag 0   /* normal value: 0  */





/*
************************
To be implemented

term is
=
(def p (inc A))

************************
*/


void inc(FILE* fileptr, void* term)
{
/* dcl  */

unsigned int i, size;
void *rhs_term, *rhs_arg_1;


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
printf("\ninc:%u: begin term:\n", count);
print_term(stderr, term);
#endif

rhs_term = vtxeval(term, op_word0 + 2);

#if (dbg_flag > 10)
printf("\ninc:%u: rhs_term = 0x%x: \n", count, rhs_term);
print_term(stderr, rhs_term);
#endif


rhs_arg_1 = vtxeval(rhs_term, op_word0 + 1);

#if (dbg_flag > 10)
printf("\ninc:%u: rhs_arg_1 = 0x%x: \n", count, rhs_arg_1);
print_term(stderr, rhs_arg_1);
#endif


size = (unsigned int) vtxeval(rhs_arg_1, outsize);

#if (dbg_flag > 10)
printf("\ninc:%u: size = %u", count, size);
#endif


fprintf(fileptr, "(dcl %s%u %u)\n",

signe(),
vtxeval(
   idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
   lexid_idcount
       ),
size

);

#if (dbg_flag > 10)
printf("\ninc:%u: dcl done", count);
#endif


fprintf(fileptr, "(def %s%u (uint %u 1))\n",

signe(),
vtxeval(
   idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
   lexid_idcount
       ),
size

);

#if (dbg_flag > 10)
printf("\ninc:%u: def uint done", count);
#endif


fprintf(fileptr, "(def %s (add %s %s%u))\n",


vtxeval(
   idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
   lexid_string
       ),



vtxeval(
   idarray(vtxeval(rhs_arg_1, op_word0)),
   lexid_string
       ),


signe(),
vtxeval(
   idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
   lexid_idcount
       )


);



#if (dbg_flag > 10)
printf("\ninc:%u: def add done: end", count);
#endif

}   /*  prg  */







