/*
********************************
file: local.h
********************************
*/

#include "lexan.h"
#include "prgvtx.h"
#include "trans.h"


#define BUF_SIZE 100



char* get_char_buf(unsigned int size);
int term_trans(FILE* fileptr, void* term);
int atom_trans(FILE* fileptr, void* term);
int nonatom_trans(FILE* fileptr, void* term);
int defapterm_trans(FILE* fileptr, void* term);
int bopterm_trans(char *prfxname, FILE* fileptr, void* term);




void defprocess(
FILE* fileptr, 
void* term
);


void transition(
FILE* fileptr, 
void* term,
unsigned int j
);




void stability(
FILE* fileptr, 
void* term,
unsigned int j
);


void inc(FILE* fileptr, void* term);

void dec(FILE* fileptr, void* term);

