/*
*************************************
file: default.c
*************************************
*/


#include "local.h"



#define dbg_flag 0   /* normal value: 0  */





int case_default(FILE *fileptr, void* term)
{
/* dcl */
void * apterm;
unsigned int record_args;
unsigned int i;
char *buf;


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
printf("\ncase_default:%u: begin", count);
#endif



apterm = vtxeval(term, op_word0 + 2);

record_args = (unsigned int) vtxeval(apterm, op_args);


/* unfold args */

for (i = 1; i < record_args; i++)
   {

if ( (int) vtxeval(vtxeval(apterm, op_word0 + i), op_code) == tk_ap )
/* unfold */
{


buf = get_char_buf(BUF_SIZE);

sprintf(buf, "%s.%u.%u",
signe(),
vtxeval(
  idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
  lexid_idcount
        ),
i
);


bopterm_trans(buf, fileptr, vtxeval(apterm, op_word0 + i)); 

free(buf);
}


   }   /*  for i  */



fprintf(fileptr, "(def %s (%s ",

vtxeval(
  idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
  lexid_string
        ),

keywstring(
  (unsigned int) vtxeval(vtxeval(apterm, op_word0), op_code)
          )

);




for (i = 1; i < record_args; i++)
   {

switch ( (int) vtxeval(vtxeval(apterm, op_word0 + i), op_code) )
{

     case tk_id:  /* var */

           fprintf(fileptr, "%s ",
vtxeval(
  idarray(vtxeval(vtxeval(apterm, op_word0 + i), op_word0)),
  lexid_string
        )
);

         break;



 case tk_num:  /* var */

           fprintf(fileptr, "%u ",
  vtxeval(vtxeval(apterm, op_word0 + i), op_word0)
 );

         break;


   case tk_ap:

      fprintf(fileptr, "%s.%u.%u ",
signe(),
vtxeval(
  idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
  lexid_idcount
        ),
i
);


         break;



     default:  /* atom keyword  */

 fprintf(fileptr, "%s ",
keywstring(
  (unsigned int) vtxeval(vtxeval(apterm, op_word0 + i), op_code)
          )
);



         break;

   
}   /* switch */


   }   /*  for i  */


fprintf(fileptr, "))\n");




return (0);



#if (dbg_flag > 10)
printf("\ncase_default:%u: end", count);
#endif


}  /*  case_default */




