/*
*************************************
file: const.c


Defines value for const id's.




*************************************
*/


#include "local.h"



#define dbg_flag 0   /* normal value: 0  */




void const_term(prghdr* phdr)
{
/* dcl  */
void  *p;  /* prg label for instruction  */
void *term;

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
printf("\nprg_outsize:%u: begin", count);
#endif



/*  first instruction */
p = phdr -> prg;




 while (p != NULL)
  {
       /* print line, p != NULL */

       const_id(vtxeval(p, prgwrd_value));

       p = vtxeval(p, ptr_down);


  }



#if (dbg_flag > 10)
printf("\nprg_outsize:%u: end", count);
#endif

}  /*  prg  */







unsigned int const_id(void* term)
{
/* dcl  */

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
printf("\nterm_outsize:%u: begin", count);
#endif




#if (dbg_flag > 0)
fprintf(stderr, "\n\nterm_outsize: term: ");
print_term(stderr, term);
#endif

switch ( (unsigned int) vtxeval(term, op_code) )
     {
         case tk_ap: 

         
                   return (nonatom_term(term));


         default:  /* atom: cannot be (const ...) */

                   return ( 0 );
   

     }






#if (dbg_flag > 10)
printf("\nterm_outsize:%u: end", count);
#endif

}  /*  prg  */








/*
**************
term is (ap id/keyword .... )
**************
*/


unsigned int nonatom_term(void* term)
{
/* dcl  */
void *op_term, *rhs_term;
unsigned int lhsop, rhs_op, new_vctsize;

void *array_term;
unsigned int i, array_size, record_size, record_args;

void *record_term, *record_term_def;

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
printf("\nnonatom_term:%u: begin", count);
#endif




lhsop = (unsigned int) vtxeval(vtxeval(term, op_word0), op_code);



#if (dbg_flag > 0)
fprintf(stderr, "\n\nnonatom_term: lhsop = %u: term: ", lhsop);
print_term(stderr, term);
#endif


switch (lhsop)
     {

        case tk_const:  /* const */


#if (dbg_flag > 0)
fprintf(stderr, "\nnonatom_term: switch: const: term = 0x%x",
term
);
#endif

/* define id value */



vtxeval(
   idarray(
      vtxeval(vtxeval(term, op_word0 + 1), op_word0)
          ), 
   lexid_value
)
=
(void *) eval_expr( vtxeval(term, op_word0 + 2) );



vtxeval(
   idarray(
      vtxeval(vtxeval(term, op_word0 + 1), op_word0)
          ), 
   lexid_type
)
=
(void *) id_const;





#if (dbg_flag > 0)
fprintf(stderr, "\nnonatom_term: dcl end: id %s",
vtxeval(
   idarray(
      vtxeval(vtxeval(term, op_word0 + 1), op_word0)
          ), 
   lexid_string
)
);
#endif



                  return ( 
(unsigned int)
vtxeval(
   idarray(
      vtxeval(vtxeval(term, op_word0 + 1), op_word0)
          ), 
   lexid_value
)
                          );







                 default:  /* do nothing */

                           return ( 0 );




          }  /* switch */





#if (dbg_flag > 10)
printf("\nnonatom_term:%u: end", count);
#endif

}  /*  prg  */
















