/*
*************************************
file: const.c


Defines value for const id's.




*************************************
*/


#include "local.h"



#define dbg_flag 0   /* normal value: 0  */




void syntax_enum(prghdr* phdr)
{
/* dcl  */
void  *p;  /* prg label for instruction  */
void *term;

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
printf("\nsyntax_enum:%u: begin", count);
#endif



/*  first instruction */
p = phdr -> prg;




 while (p != NULL)
  {
       /* print line, p != NULL */

       enum_ids(vtxeval(p, prgwrd_value));

       p = vtxeval(p, ptr_down);


  }



#if (dbg_flag > 10)
printf("\nsyntax_enum:%u: end", count);
#endif

}  /*  prg  */







void enum_ids(void* term)
{
/* dcl  */

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
printf("\nenum_ids:%u: begin", count);
#endif




#if (dbg_flag > 0)
fprintf(stderr, "\n\nenum_ids: term: ");
print_term(stderr, term);
#endif

switch ( (unsigned int) vtxeval(term, op_code) )
     {
         case tk_ap: 

         
                   nonatom_enum(term);


         default:  /* atom: cannot be (enum ...) */

                   return ;
   

     }






#if (dbg_flag > 10)
printf("\nenum_ids:%u: end", count);
#endif

}  /*  prg  */








/*
**************
term is (ap id/keyword .... )
**************
*/


void nonatom_enum(void* term)
{
/* dcl  */
void  *rhs_term;
unsigned int lhsop;

unsigned int i, rhs_size;


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
printf("\nnonatom_enum:%u: begin", count);
#endif




lhsop = (unsigned int) vtxeval(vtxeval(term, op_word0), op_code);



#if (dbg_flag > 0)
fprintf(stderr, "\n\nnnonatom_enum: lhsop = %u: term: ", lhsop);
print_term(stderr, term);
#endif


switch (lhsop)
     {

        case tk_enum:  /* enum */


#if (dbg_flag > 0)
fprintf(stderr, "\nnonatom_enum: switch: enum: term = 0x%x",
term
);
#endif

/* define lexid_def for all enum ids. */

rhs_term = vtxeval(term, op_word0 + 3);

rhs_size = (unsigned int) vtxeval(rhs_term, op_args);


for (i = 0; i < rhs_size; i++)
   {

vtxeval(
   idarray(
      vtxeval(vtxeval(rhs_term, op_word0 + i), op_word0)
          ), 
   lexid_def
)
=
term;

vtxeval(
   idarray(
      vtxeval(vtxeval(rhs_term, op_word0 + i), op_word0)
          ), 
   lexid_type
)
=
(void *) id_enum;


vtxeval(
   idarray(
      vtxeval(vtxeval(rhs_term, op_word0 + i), op_word0)
          ), 
   lexid_value
)
=
(void *) i;


   }  /* for i */






                 default:  /* do nothing */

                           return ;




          }  /* switch */





#if (dbg_flag > 10)
printf("\nnonatom_enum:%u: end", count);
#endif

}  /*  prg  */
















