/*
******************
file mkall.c

Read file in format:

<planat_suffix>
sig_0
sig_1
...


argv[1] is the name of the file
containing 
<plant_suffix> and
list of signals (1 bit arrays).

Result on stdout

HYP:
Just one signal for line.
At least one signal.
******************
*/

#include <stdlib.h>
#include <stdio.h>


#define USIZE 200


main(int argc, char* argv[])
{
/* dcls */
int i = 0;
int j;


FILE *sigfile;

int ck_end ;

char sigbuf[USIZE];
char sigbuf2[USIZE];
char psuffix[USIZE];



/* prg  */


sigfile = fopen(argv[1], "r");

ck_end = fscanf(sigfile, "%s", psuffix);

if (ck_end == EOF)
/*   end of it  */
{
fprintf(stderr, "\n\nError: No plant suffix: Unexpected EOF");
fclose(sigfile);
exit (1);
}


while (1)
 {

/* read u_to  */

/* find name as ith signal  */

  for (j = 0; j <= i; j++)
     {

ck_end = fscanf(sigfile, "%s", sigbuf);

if (ck_end == EOF)
/*   end of it  */
{
fprintf(stderr, "\n\nError: no signals: Unexpected EOF");
fclose(sigfile);
exit (1);
}

/* ck_end != EOF */


     }  /* for j */

/* name found in sigfile */


rewind(sigfile);
/* skip suffix  */
ck_end = fscanf(sigfile, "%s", psuffix);





  for (j = 0; j <= i; j++)
     {

ck_end = fscanf(sigfile, "%s", sigbuf);

if (ck_end == EOF)
/*   end of it  */
{
fprintf(stderr, "\n\nError: no signals: Unexpected EOF");
fclose(sigfile);
exit (1);
}

/* ck_end != EOF */



     }  /* for j */



/* ck_end != EOF */


/* read u_from  */



/* check if there are u_from */



/* ck_end != EOF */
ck_end = fscanf(sigfile, "%s", sigbuf2);

if (ck_end == EOF)
/*   no u_tr_from to be red */
{
fclose(sigfile);
return (0);
}

/* ck_end != EOF */


printf("\n(def u%s1%s (record\n",
psuffix,
sigbuf
);



  while (ck_end != EOF)
     {

/* ck_end != EOF */

printf("%s\n", sigbuf2);
ck_end = fscanf(sigfile, "%s", sigbuf2);


     }  /* while ck_end */

printf("))\n\n");


rewind(sigfile);
/* skip suffix  */
ck_end = fscanf(sigfile, "%s", psuffix);

i++;




 }  /* while (1)  */


fclose(sigfile);



}  /* main */

