/*
******************
file psigrec.c

Generates records 
u_tr_to_.,
u_tr_from_.


argv[1] is the name of the file
containing list of signals (1 bit arrays).

Result on stdout

HYP:
Just one signal for line.
At least one signal.
******************
*/

#include <stdlib.h>
#include <stdio.h>


#define USIZE 200


main(int argc, char* argv[])
{
/* dcls */
int i = 0;
int j;


FILE *sigfile;

int ck_end ;

char sigbuf[USIZE];



/* prg  */


sigfile = fopen(argv[1], "r");

while (1)
 {

/* read u_tr_to  */


ck_end = fscanf(sigfile, "%s", sigbuf);

printf("\n(def u_tr_to_%d (record\n", i);


  for (j = 0; j <= i; j++)
     {

if (ck_end == EOF)
/*   end of it  */
{
fprintf(stderr, "\n\nUnexpected EOF");
exit (1);
}

/* ck_end != EOF */

printf("%s\n", sigbuf);
ck_end = fscanf(sigfile, "%s", sigbuf);


     }  /* for j */

printf("))\n\n");




/* read u_tr_from  */

if (ck_end == EOF)
/*   no u_tr_from to be red */
{
return (0);
}




/* ck_end != EOF */


printf("\n(def u_tr_from_%d (record\n", i + 1);



  while (ck_end != EOF)
     {

/* ck_end != EOF */

printf("%s\n", sigbuf);
ck_end = fscanf(sigfile, "%s", sigbuf);


     }  /* while ck_end */

printf("))\n\n");


rewind(sigfile);

i++;




 }  /* while (1)  */



}  /* main */

