/*
************************************************
file: primes.c
************************************************
*/

/*
************************************************
Print prime numbers up to MAX_PRIME
************************************************
*/


#include <stdio.h>
#include <stdlib.h>



#define MAX_PRIME 200000

/*  sugar  */
#define then  /*  then  */
#define true  1
#define false  0


int get_next_prime(int *A, int i);

main()
{

/* declarations  */


int A[MAX_PRIME + 1];
int i;


/* program  */

#if 0
/*
****************************
begin:    output redirection   
****************************
*/

fclose(stdout);

freopen("primes.lst", "w", stdout);

/*
****************************
end:    output redirection   
****************************
*/
#endif



setbuf(stdout, NULL);


printf("\nList of first %d primes\n\n", MAX_PRIME);



/* initialize A  */

A[0] = 2;
printf("\nprime %d = %d", 0, 2);

A[1] = 3;
printf("\nprime %d = %d", 1, 3);

A[2] = 5;
printf("\nprime %d = %d", 2, 5);

A[3] = 7;
printf("\nprime %d = %d", 3, 7);


A[4] = 11;
printf("\nprime %d = %d", 4, 11);

  /*  i = last A entry defined  */

for (i = 5; i < MAX_PRIME; i++)
   {
     /* look for least prime > A[i]  */
     
     
     A[i] = get_next_prime(A, i);
     printf("\nprime %d = %d", i, A[i]);

     
  }  /*  end for i  */
   




}  /*  end main  */





int get_next_prime(int *A, int i)
/*
*******************
In A[0], ... A[i - 1] first i primes.
Returns i-th prime.
Hyp.:  A[i - 1] > 2 (i > 1)
*******************
*/
{

/* declarations  */
int j, prime_cand;


/*  program  */

   prime_cand = A[i - 1] + 2;

   j = 0;
     
     while (true)
          {
          
            /*  test if prime_cand is a prime number  */
            
            if (A[j] * A[j] > prime_cand)
            then  /* prime_cand is a prime  */
                {
                   return (prime_cand);
                } 
            
            /* A[j] * A[j] <= prime_cand  */
            
            if (prime_cand%A[j]   /* != 0  */ )
            then  /*  keep testing (prime_cand%A[j] != 0) */
                 {
                   j++;
                 }    
            else /* prime_cand%A[j] == 0, thus prime_cand is not prime  */
                     {
                       prime_cand = prime_cand + 2;
                       j = 0;
                     }
               
            
          }  /*  end while   */
          
 
}


