/*
**
**  file: read.lkup.table
**
*/

#include "local.h"

#include <string.h>



#define dbg_flag 0




void* read_symbtab_entry(void* T, unsigned int i)
{
   return (
(void *) ((hash_table *) T) -> table[i]
          );
}








/*
************************************
returns pointer to bucket in symbtab
with key key if it exists.
NULL else
************************************
*/




void* read_symbtab_bucket(void* T, char* key)
{

/* declarations  */
  ht_value *v;
  unsigned int a;  
  
#if (dbg_flag > 0)
static int count = 0;
#endif

/* programs  */


#if (dbg_flag > 0)
count = count + 1;
#endif


/*  hash key   */

a = symbtab_hash(get_symbtab_size(T), key);  




   if (  (ht_value *) ( ((hash_table *) T) -> table[a] ) == NULL )
   /* then:    no data with given key  */ 
   {
       return (NULL);
   }



/*  ((hash_table *) T) -> table[a] != NULL  */

/* There might be a data with given key  */


   v = (ht_value *) ( ((hash_table *) T) -> table[a] ) ;
   

   /*  v != NULL  */

   while ( 
            strcmp(read_stbk_key(v), key) <= 0 
                                /*  read_stbk_key(v)<= key  */
         ) 
      {

       /*  v !=  NULL  */

    	if ( strcmp(read_stbk_key(v), key) == 0
                           /*  read_stbk_key(v) == key */
           )
    	/*  then: found  */
        	{
           		return (v);
        	}





/* not yet found  */
         v =  read_stbk_next(v);

        if (v == NULL) 
           /*  no data in table  */
           return (NULL);


       /*  v != NULL  */

      }



/* data not in table  */

       return (NULL);






}  /* end program  */



