/*
*************************************
file:  conv.bits.bdds.c
*************************************
*/

#define dbg_flag 0


#include "bmath.h"


/*
******************************************
a is a sequence of num_bits bits;
b will contain a sequence of num_bits bdds.
******************************************
*/


void conv_bin_to_bdds(int num_bits, int *a, bdd *b)

{  /*  begin */

/* declarations  */
int k;


/*  program  */

#if (dbg_flag > 100)
printf("\nconv_bits_to_bdds: ckp 100\n");
#endif

for (k = 0; k < num_bits; k++)
   {
      if ( a[k]%2 /*  != 0  */)
      /* then */ 
          b[k] = one();
      else 
          b[k] = zero();
   }

#if (dbg_flag > 100)
printf("\nconv_bits_to_bdds: ckp 200\n");
#endif


}  /*  end  */
