/*
*************************************
file:  conv.bits.bdds.c
*************************************
*/

#define dbg_flag 0


#include "bmath.h"


/*
******************************************
b will contain the k LSBs of a.
******************************************
*/


void conv_dec_to_bdds(int num_bits, unsigned int a, bdd *b)

{  /*  begin */

/* declarations  */
int k;


/*  program  */

#if (dbg_flag > 100)
printf("\nconv_dec_to_bdds: ckp 100\n");
#endif

for (k = 0; k < num_bits; k++)
   {

#if (dbg_flag > 1000)
printf("\nconv_dec_to_bdds: ckp 100.100.%d\n", k);
#endif

      if ( (a & 0x1)  /*  != 0  */)
      /* then */ 
      	{
#if (dbg_flag > 1000)
printf("\nconv_dec_to_bdds: ckp 100.200.%d\n", k);
#endif
          b[k] = one();

#if (dbg_flag > 1000)
printf("\nconv_dec_to_bdds: ckp 100.300.%d\n", k);
#endif
        }
      else 
      	{
#if (dbg_flag > 1000)
printf("\nconv_dec_to_bdds: ckp 100.400.%d\n", k);
#endif
          b[k] = zero();
          
#if (dbg_flag > 1000)
printf("\nconv_dec_to_bdds: ckp 100.500.%d\n", k);
#endif
        }

#if (dbg_flag > 1000)
printf("\nconv_dec_to_bdds: ckp 100.600.%d\n", k);
#endif


       a = (a >> 1);
       
   }

#if (dbg_flag > 100)
printf("\nconv_dec_to_bdds: ckp 200\n");
#endif


}  /*  end  */
