/*
*************************************
file:  column_prob.c
*************************************
*/


#define dbg_flag 0

#include "bmath.h"



void conv_dec_to_bin(int num_bits, unsigned int a_in, int *b_out)

{  /*  begin */

/* declarations  */
int k;


/*  program  */

#if (dbg_flag > 100)
printf("\nconv_dec_to_bin: ckp 100\n");
#endif

for (k = 0; k < num_bits; k++)
   {
   	 b_out[k] = ((a_in >> k) & 0x1);
   }


#if (dbg_flag > 1000)
printf(
"\n\nBegin %d bit representation of integer %d\n", 
num_bits,
a_in
);
for (k = 0; k < num_bits; k++)
   {
printf("b_out[%d] = %d\n", k, b_out[k]); 
   }
printf(
"\n\nEnd %d bit representation of integer %d\n", 
num_bits,
a_in
);
#endif

#if (dbg_flag > 100)
printf("\nconv_dec_to_bin: ckp 200\n");
#endif

}  /*  end  */
