
#include "local.h"


#define dbg_flag 0



/* 
***********************
Old version: 
this is ok, but new version should be faster.
However this is not the case.
************************
*/


bdd there_exists(int i, bdd F)
/*
**  returns graph
**  representing function
**  (there exists x(i) s.t.: F) 
**
*/
{
/*  declarations  */
bdd buffer[3];

#if (dbg_flag > 0)
static int count = 0;
#endif

  /* program */

#if (dbg_flag > 0)
count++;
#endif

#if (dbg_flag > 100)
printf("\nthere_exists:%d: ckp 100 (begin)", count);
#endif


buffer[0] = restrict(F, i, 0);
buffer[1] = restrict(F, i, 1);
buffer[2] = OR(buffer[0], buffer[1]);

delete_bdd(buffer[0]);
delete_bdd(buffer[1]);

/*  return result  */

#if (dbg_flag > 100)
printf("\nthere_exists:%d: ckp 900 (end)", count);
#endif

   return ( buffer[2] );

}






#if 0

/*  
**********************
New version: this should be faster than old version.
Unfortunately experimentally we found that
this is not the case.
**********************
*/


bdd there_exists(int i, bdd F)
/*
**  returns graph
**  representing function
**  (there exists x(i) s.t.: F) 
**
*/
{
/*  declarations  */
bdd buffer[3];

#if (dbg_flag > 0)
static int count = 0;
#endif

  /* program */

#if (dbg_flag > 0)
count++;
#endif

#if (dbg_flag > 100)
printf("\nthere_exists:%d: ckp 100 (begin)", count);
#endif



buffer[2] = shift_variables(F, 1);
buffer[0] = varx(0);
buffer[1] = ifter(buffer[0], buffer[2], buffer[2], i + 1, 1, 1);
delete_bdd(buffer[2]);
delete_bdd(buffer[0]);


buffer[0] = restrict(buffer[1], 0, 0);
buffer[2] = restrict(buffer[1], 0, 1);
delete_bdd(buffer[1]);


buffer[1] = OR(buffer[0], buffer[2]);
delete_bdd(buffer[2]);
delete_bdd(buffer[0]);

buffer[0] = shift_variables(buffer[1], -1);
delete_bdd(buffer[1]);



/*  return result  */

#if (dbg_flag > 100)
printf("\nthere_exists:%d: ckp 900 (end)", count);
#endif

   return ( buffer[0] );

}
#endif








bdd there_exists_vct(int *x, int n, bdd F)
/*
**  returns graph
**  representing function
**  (F[i := G]) 
*/
{
/*  declarations  */
bdd result, buffer, G;
int i;

/*  program  */


if (n <= 0)
then return (F);
else  /*  n > 0  */
     {

/*  define variable y[i]  */
   
     result = there_exists(x[0], F);
     
     for (i = 1; i < n; i++)
        {
           buffer = there_exists(x[i], result);
           delete_bdd(result);
           result = buffer;
        }

/*  result defined  */

      return ( result );
    
     }


}
