#include "local.h"


#define dbg_flag 0




/* 
***********************
Old version: 
this is ok, but new version should be faster.
However this is not the case.
************************
*/


bdd for_all(int i, bdd F)
/*
**  returns graph
**  representing function
**  (for_all x(i) s.t.: F) 
**
*/
{
/*  declarations  */
bdd buffer[3];

#if (dbg_flag > 0)
static int count = 0;
#endif

  /* program */

#if (dbg_flag > 0)
count++;
#endif

#if (dbg_flag > 100)
printf("\nfor_all:%d: ckp 100 (begin)", count);
#endif


buffer[0] = restrict(F, i, 0);
buffer[1] = restrict(F, i, 1);
buffer[2] = AND(buffer[0], buffer[1]);

delete_bdd(buffer[0]);
delete_bdd(buffer[1]);

/*  return result  */

#if (dbg_flag > 100)
printf("\nfor_all:%d: ckp 900 (end)", count);
#endif

   return ( buffer[2] );

}









#if 0
/*  
**********************
New version: this should be faster than old version.
Unfortunately experimentally we found that
this is not the case.
**********************
*/



bdd for_all(int i, bdd F)
/*
**  returns graph
**  representing function
**  (for_all x(i) s.t.: F) 
**
*/
{
/*  declarations  */
bdd buffer[3];

#if (dbg_flag > 0)
static int count = 0;
#endif

  /* program */

#if (dbg_flag > 0)
count++;
#endif

#if (dbg_flag > 100)
printf("\nfor_all:%d: ckp 100 (begin)", count);
#endif


buffer[2] = shift_variables(F, 1);
buffer[0] = varx(0);
buffer[1] = ifter(buffer[0], buffer[2], buffer[2], i + 1, 1, 1);
delete_bdd(buffer[2]);
delete_bdd(buffer[0]);


buffer[0] = restrict(buffer[1], 0, 0);
buffer[2] = restrict(buffer[1], 0, 1);
delete_bdd(buffer[1]);


buffer[1] = AND(buffer[0], buffer[2]);
delete_bdd(buffer[2]);
delete_bdd(buffer[0]);

buffer[0] = shift_variables(buffer[1], -1);
delete_bdd(buffer[1]);

/*  return result  */

#if (dbg_flag > 100)
printf("\nfor_all:%d: ckp 900 (end)", count);
#endif

   return ( buffer[0] );

}

#endif
