



/*
**
**  file local.h
**
**
**  primitives on cache_memory 
**
*/


#include "cache.h"
#include "gstore.h"


typedef void *cache_memory;



#define cache_measure 0


/*
**  each key is assumed to have T -> arity[0] 
**  elements
**
*/


struct Cache_Mem
{
  int numelem;
  int sizetab;
  type_gstore *table;
};


typedef struct Cache_Mem cache_MEM;



extern
cache_memory T_cache;

extern
int SIZE_CACHE;



int tuple_cache(cache_memory T, type_gstore A);



 
cache_value read_cache(cache_memory T, cache_value A);

cache_value write_cache(cache_memory T, cache_value A );

cache_memory create_cache(int cache_size);

int read_cache_size(cache_memory T);

int read_cache_elements(cache_memory T);

