/*
***************************************
file: dag.read.write.c
***************************************
*/



#include "dag.h"
#include "local.h"



int get_dag_htable_elements()
{
  return (get_lkup_table_elements(T_dag));
}



int get_num_bdd_vtx()
{
  return (get_lkup_table_elements(T_dag));
}




int get_dag_htable_size()
{
  return (get_lkup_table_size(T_dag));
}


void print_dag_info()
{

printf("\ndag info: size dag hash table T_dag = %d",
get_lkup_table_size(T_dag) 
);

printf("\ndag info: elements in T_dag = %d; non_null_entries in T_dag = %d",
get_lkup_table_elements(T_dag), 
get_non_null_entry(T_dag));

printf("\ndag info: max size dag up to now = %d",
max_size_graph 
);

printf("\ndag info: vertices to be deleted = %d",
to_be_deleted 
);

printf("\ndag info: vertex sizes:");
print_gvertex_info();

}
