

/*
**
** file:  get_new_store
**
**
*/



#include "local.h"

#define dbg_flag 0   /*  normal value: 0  */




type_gstore get_new_gstore(
unsigned int size_key_info, 
unsigned int size_value_info)

{  /*  begin program  */
/*  declarations  */
type_gstore p;
int size;


/* program  */

#if (dbg_flag > 10)
fprintf(stderr, "\nget_new_gstore: ckp 10: \nsize_key_info = %u, size_value_info = %u",
size_key_info,
size_value_info
);
#endif




size =   map_size_key( size_key_info & 0x3 )
       + map_size_value( size_value_info & 0x3 );

#if (dbg_flag > 10)
fprintf(stderr, "\nget_new_gstore: ckp 20: size = %u", size);
#endif

p = (type_gstore) malloc(sizeof(unsigned int) * size);


#if (dbg_flag > 10)
fprintf(stderr, "\nget_new_gstore: ckp 30: new gstore p = 0x%x", p);
#endif


if (p == NULL)
/* then  */  /* error  */
       {
           printf("\nerror: no space for new gstore (get_new_gstore)\n");
           exit (1000);
        }

#if (dbg_flag > 10)
fprintf(stderr, "\nget_new_gstore: ckp 40: p == 0x%x != NULL", p);
#endif


write_gstore_in_edges(p, 0);
write_gstore_size_key(p, size_key_info);
write_gstore_size_value(p, size_value_info);



#if dbg5_store
count_store++;
created_store++;
#endif

#if (dbg_flag > 10)
fprintf(stderr, "\nget_new_gstore: ckp 100: return p == 0x%x\n",
p);
#endif

return (p);

}  /*  end program  */




