/*
**
**  file: data.less.than
**
*/


/*
**  returns true iff key in v is less than key in p
**
**  NULL vertex have key infinity
**
*/


#include "gvertex.h"


int gdata_less_than(gvertex v, gvertex p)

{  /*  begin program  */

/* declarations */
int i; 
unsigned int info_size[2];



/* program  */

  if (v == NULL)
  /* then */ return (0);

/*  v != NULL */

if (p == NULL)
/* then */ return (1);

/* v, p != NULL  */

info_size[0] = size_gvtx_alllab(v);
info_size[1] = size_gvtx_alllab(p);


if ( info_size[0] < info_size[1] )
/*  then  */  return (1);

if ( info_size[0] > info_size[1] )
/*  then  */  return (0);

/*  info_size[0] == info_size[1]  */


           if ( gvertex_hlab(v) <  gvertex_hlab(p) )
           /* then */ return (1) ;  /*  v < p  */

           if ( gvertex_hlab(v) >  gvertex_hlab(p) )
           /* then */ return (0);  /*  p < v  */

/* result not known */ 

   for (i = 1; i < info_size[0]; i++) 
        {           
           if ( gvertex_tlab(v, i) <  gvertex_tlab(p, i) )
           /* then */ return (1) ;  /*  v < p  */

           if ( gvertex_tlab(v, i) >  gvertex_tlab(p, i) )
           /* then */ return (0);  /*  p < v  */

/* result not known */ 
        }


 /* (key of v) == (key of p) */


   return (0);

               
 
}  /*  end program  */


