/*
****************************************************
deleting functions
*********************************************
*/


#include "local.h"

#define dbg_flag 0    /* normal value: 0 */

#define dbg_nodel 0   /* This MUST be 0, unless dbg */
#define dbg_nounlock 0   /* This MUST be 0, unless dbg */



void delete_bdd(bdd G)
/*
**  deletes bdd G 
*/
{

  /* program */

#if (dbg_flag > 100)
printf("\n\ndelete_bdd: ckp 100 (begin): root = 0x%x", read_graph_root(G));
 printf("\nG = 0x%x, G[0] = 0x%x, G[1] = 0x%x, G[2] = 0x%x\n",
 (unsigned int) G,
 ((unsigned int *)G)[0], 
 ((unsigned int *)G)[1], 
 ((unsigned int *)G)[2]);
#endif



#if (dbg_flag > 1000)
printf("\ndelete_bdd: ckp 200 (unlocking root bdd)");
#endif


#if (dbg_nounlock != 0)
fprintf(stderr, "\ndelete_bdd: no unlocking: G = 0x%x, v = 0x%x",
G,
read_graph_root(G)
);
#endif


#if (dbg_nounlock == 0)
unlock_bdd_vertex(read_graph_root(G));
#endif



#if (dbg_flag > 1000)
printf("\ndelete_bdd: ckp 300 (unlocked root bdd)");
#endif

    
#if (dbg_flag > 1000)
printf("\ndelete_bdd: ckp 400 (delete_graph_header)");
#endif



#if (dbg_nodel > 10)
fprintf(stderr, 
"\ndelete_bdd: no delete_graph_header G = 0x%x, vtx = 0x%x",
G,
read_graph_root(G)
);
#endif

#if (dbg_nodel == 0)
delete_graph_header(G);
#endif


#if (dbg_flag > 100)
printf("\ndelete_bdd: ckp 1000 (end)");
#endif
 
}

