
/*
***********************************************************************
file rw.graph.header
***********************************************************************
*/


#include "local.h"

#define dbg0_read_graph_root 0
#define dbg_write_graph_root 0







#define word_root 0

#define word_p_flip 2
#define position_p_flip 0
#define mask_p_flip 0x1   /*  bit 0 */

#define word_p_swap 2
#define position_p_swap 1
#define mask_p_swap 0x2    /*  bit 1 */

#define word_swap 2
#define position_swap 2
#define mask_swap 0x4     /*  bit 2  */

#define word_flip 2
#define position_flip 3
#define mask_flip 0x8     /*  bit 3  */

#define word_vindex 1









/*  flags for get_graph_header  */





ptrvertex read_graph_root(bdd G)
/*
** creates bdd header
*/
{

#if dbg0_read_graph_root
static int count = 0;
#endif

/*  program  */

#if dbg0_read_graph_root
count = count + 1;
printf("\nread_graph_root:%d: root = 0x%x\n", 
count, 
((unsigned int *) G)[word_root]
);
#endif

   return ( 
             (ptrvertex) ((unsigned int *) G)[word_root]
          );




}





void write_graph_root(bdd G, ptrvertex v)
/*
** creates bdd header
*/
{

#if dbg_write_graph_root
static int count = 0;
#endif

/*  program  */

#if dbg_write_graph_root
count++;
printf("\nwrite_graph_root:%d: root = 0x%x\n", 
count, 
(unsigned int) v
);
#endif

 ((unsigned int *) G)[word_root] = (unsigned int) v;
 

}




int read_graph_p_flip(bdd G)
/*
** creates bdd header
*/
{

                        return (
                                  read_bdd_store_generic(
                                        G, 
                                        word_p_flip, 
                                        position_p_flip, 
                                        mask_p_flip
                                        )
                               );

}





void write_graph_p_flip(bdd G, int value)
/*
** creates bdd header
*/
{

                         write_bdd_store_generic(
                            G, 
                            word_p_flip, 
                            position_p_flip, 
                            mask_p_flip, 
                            (unsigned int) value
                            );

}




int read_graph_p_swap(bdd G)
/*
** creates bdd header
*/
{

                        return (
                                  read_bdd_store_generic(
                                        G, 
                                        word_p_swap, 
                                        position_p_swap, 
                                        mask_p_swap
                                        )
                               );

}





void write_graph_p_swap(bdd G, int value)
/*
** creates bdd header
*/
{

                         write_bdd_store_generic(
                            G, 
                            word_p_swap, 
                            position_p_swap, 
                            mask_p_swap, 
                            (unsigned int) value
                            );

}





unsigned int read_graph_flip(bdd G)
/*
** creates graph header
*/
{

                        return (
                                  read_bdd_store_generic(
                                        G, 
                                        word_flip, 
                                        position_flip, 
                                        mask_flip
                                        )
                               );

}





void write_graph_flip(bdd G, unsigned int value)
/*
** creates bdd header
*/
{

                         write_bdd_store_generic(
                            G, 
                            word_flip, 
                            position_flip, 
                            mask_flip, 
                            (unsigned int) value
                            );
 
}




void write_graph_vindex(bdd G, unsigned int value)
/*
** creates bdd header
*/
{

 ((unsigned int *) G)[word_vindex] = value;
 
 
 
 
}




unsigned int read_graph_vindex(bdd G)
/*
** creates bdd header
*/
{

   return ( 
             ((unsigned int *) G)[word_vindex]
          );

}



int bdd_root_var_index(bdd G)
/*
**  read header vindex
*/
{

   return ( 
             ((unsigned int *) G)[word_vindex]
          );

}
