/*
**
**  file: read.lkup.table
**
*/

#include "local.h"


#define dbg_flag 0




unsigned int read_htable_entry(htable T, unsigned int i)
{
   return (
   			(ht_value) ((hash_table *) T) -> table[i]
   		  );
}






/*
returns nonzero iff entru with key is in htable T.
If entry found then *A = value
*/

int read_ht(htable T, unsigned int key, ht_value *A)
{

/* declarations  */
  ht_value *v;
  unsigned int a;  
  
#if (dbg_flag > 0)
static int count = 0;
#endif

/* programs  */


#if (dbg_flag > 0)
count = count + 1;
#endif


/*  hash key   */

a = key%get_htable_size(T);

   if (  (ht_value *) ( ((hash_table *) T) -> table[a] ) == NULL )
   /* then:    no data with given key  */ 
   {
   	  *A = 0;
       return (0);
   }



/*  ((hash_table *) T) -> table[a] != NULL  */

/* There might be a data with given key  */


   v = (ht_value *) ( ((hash_table *) T) -> table[a] ) ;
   

   /*  v != NULL  */

   while ( read_bk_key(v) <= key ) 
      {

    	if ( read_bk_key(v) == key )
    	/*  then: found  */
        	{
           		*A = read_bk_value(v);
           		return (1);
        	}

         v =  read_bk_next(v);

      }



/* data not in table  */

   	  *A = 0;
       return (0);






}  /* end program  */
