/*
**********************************************************
file:  ifte_non_1_red
**********************************************************
*/


#include "local.h"

#define dbg_flag 0        /* normal value: 0  */
#define threshold 300


#define then /* then */



void ifte_r_non_1_red(
type_bdd_store p,
type_bdd_store new_p_0,
type_bdd_store new_p_1
)

{   /*  begin  ifte_non_1_red*/

/*  declarations  */
#if (dbg_flag > 0)
static unsigned int count = 0;
#endif

unsigned int root_label[8], temp_p;
int swap_broadcasting, flip_broadcasting, vertex_flip;
unsigned int shift_0, shift_1;
unsigned int p_swap_0, p_swap_1;
unsigned int flip_0, flip_1;




/*
***************************************

flip_broadcasting is p_flip for root

swap_broadcasting is p_swap for root

***************************************
*/




/*
**********************************************************
 begin: define_side_1
**********************************************************
*/


/* declarations   */

   /*  program  */

#if (dbg_flag > 0)
count++;
#endif

#if (dbg_flag > 0)
if (dbg_flag > threshold)
{
printf(
"\nifte_r_non_1_red:%u: ckp 100: (begin): arg = (p = 0x%x, new_p_0 = 0x%x, new_p_1 = 0x%x)",
count,
p,
new_p_0,
new_p_1
);
}
#endif







if (read_store_vertex(new_p_0, 3) > read_store_vertex(new_p_1, 3))
then  /* swap  */
       {

#if (dbg_flag > 0)
if (dbg_flag > threshold)
{
printf(
"\nifte_r_non_1_red:%u: ckp 110: swap",
count
);
}
#endif


           swap_broadcasting = 1;

/*  swap results  */

           temp_p = (unsigned int) new_p_0;
           new_p_0 = new_p_1;
           new_p_1 = (type_bdd_store) temp_p;


#if (dbg_flag > 0)
if (dbg_flag > threshold)
{
printf(
"\nifte_r_non_1_red:%u: ckp 120: read_store_vertex(p, 3) = 0x%x",
count,
read_store_vertex(p, 3)
);
}
#endif




/* define shifts  */

shift_0 = ((unsigned int *) read_store_vertex(p, 3))[1];



#if (dbg_flag > 0)
if (dbg_flag > threshold)
{
printf(
"\nifte_r_non_1_red:%u: ckp 130: shift_0 = %u",
count,
shift_0
);
}
#endif







shift_1 = ((unsigned int *) read_store_vertex(p, 3))[0];




#if (dbg_flag > 0)
if (dbg_flag > threshold)
{
printf(
"\nifte_r_non_1_red:%u: ckp 130: shift_1 = %u",
count,
shift_1
);
}
#endif


       }
else /*  new_vb[0] -> vertex <= new_vb[1] -> vertex  (1) (no swap) */
      {
 

#if (dbg_flag > 0)
if (dbg_flag > threshold)
{
printf(
"\nifte_r_non_1_red:%u: ckp 150: nonswap",
count
);
}
#endif



          swap_broadcasting = 0;



/*  define shifts  */


#if (dbg_flag > 0)
if (dbg_flag > threshold)
{
printf(
"\nifte_r_non_1_red:%u: ckp 160: read_store_vertex(p, 3) = 0x%x",
count,
read_store_vertex(p, 3)
);
}
#endif



shift_0 = ((unsigned int *) read_store_vertex(p, 3))[0];



#if (dbg_flag > 0)
if (dbg_flag > threshold)
{
printf(
"\nifte_r_non_1_red:%u: ckp 170: shift_0 = %u",
count,
shift_0
);
}
#endif


shift_1 = ((unsigned int *) read_store_vertex(p, 3))[1];



#if (dbg_flag > 0)
if (dbg_flag > threshold)
{
printf(
"\nifte_r_non_1_red:%u: ckp 180: shift_1 = %u",
count,
shift_1
);
}
#endif



      }


#if (dbg_flag > 0)
if (dbg_flag > threshold)
{
printf("\nifte_r_non_1_red:%u: ckp 200: read_store_vertex(p, 3) = 0x%x = %u", 
count,
read_store_vertex(p, 3),
read_store_vertex(p, 3)
);
}
#endif


/* free shift space    */
free((unsigned int *) read_store_vertex(p, 3));

#if (dbg_flag > 0)
if (dbg_flag > threshold)
{
printf("\nifte_r_non_1_red:%u: ckp 300:", count);
}
#endif

/* define swap broadcasting  */

write_store_p_swap(p, 3, swap_broadcasting);

#if (dbg_flag > 0)
if (dbg_flag > threshold)
{
printf("\nifte_r_non_1_red:%u: ckp 400:", count);
}
#endif

/*
**********************************************************
end : define_side_1
**********************************************************
*/

 /*  sons and shifts for root well defined at this point  */


/*
**********************************************************
begin   define_root_swap
**********************************************************
*/


           if ( nonterminal((ptrvertex) read_store_vertex(new_p_0, 3)) )
           then
p_swap_0 = (swap_broadcasting +  read_store_p_swap(new_p_0, 3))%2;

          else  p_swap_0 = 0x0;



           if ( nonterminal((ptrvertex) read_store_vertex(new_p_1, 3)) )
           then
p_swap_1 = (swap_broadcasting +  read_store_p_swap(new_p_1, 3))%2;

          else  p_swap_1 = 0x0;



/*
**********************************************************
end:   define_root_swap
**********************************************************
*/


#if (dbg_flag > 0)
if (dbg_flag > threshold)
{
printf("\nifte_r_non_1_red:%u: ckp 500:", count);
}
#endif

/*
**********************************************************
 begin:  do_flip_reduction
**********************************************************
*/


/*  program  */



if (read_store_p_flip(new_p_0, 3) < read_store_p_flip(new_p_1, 3))
then  /*  vertex_flip = 1 and no flip broadcasting  */
       {
            vertex_flip = 1;  flip_broadcasting = 0;
        }
else  /*  aux_flip[0] >= aux_flip[1]  */
      {
         if(read_store_p_flip(new_p_1, 3) == 1)
         then
 /* read_store_p_flip(new_p_0) == 1 == read_store_p_flip(new_p_1)  */
                {

                   vertex_flip = 0;  flip_broadcasting = 1;

 
                }
           else  /* read_store_p_flip(new_p_1) == 0   ;  begin (1)  */
                  {

         if(read_store_p_flip(new_p_0, 3) == 0)
         then /* aux_flip[0] == 0 == aux_flip[1]  */
                {

                   vertex_flip = 0;  flip_broadcasting = 0;


                }
           else  
/* 
**  aux_flip[0] == 1  and   aux_flip[1] == 0
*/
                   {
                      vertex_flip = 1;  flip_broadcasting = 1;
                   }

                   }  /*  end (1)  */
       }


#if (dbg_flag > 0)
if (dbg_flag > threshold)
{
printf("\nifte_r_non_1_red:%u: ckp 600:", count);
}
#endif



/*  store p_flip  */

write_store_p_flip(p, 3, flip_broadcasting);
write_store_flip(p, 3, vertex_flip);

/*  define flip_0, flip_1 */

flip_0 = read_store_flip(new_p_0, 3);
flip_1 = read_store_flip(new_p_1, 3);

#if (dbg_flag > 0)
if (dbg_flag > threshold)
{
printf("\nifte_r_non_1_red:%u: ckp 700:", count);
printf("\nflip_0 = 0x%x, flip_1 = 0x%x\n",
flip_0,
flip_1
);
}
#endif




/*
**********************************************************
 end:  do_flip_reduction
**********************************************************
*/


/*
*************************************************************

begin:  define root and broadcast  

*************************************************************
*/

  
 /*  All root parameters known at this point  */


/*  define vertex label */

root_label[0] = flip_0;
root_label[1] = flip_1;
root_label[2] = p_swap_0;
root_label[3] = p_swap_1;
root_label[4] = shift_0;
root_label[5] = shift_1;
root_label[6] = read_store_vertex(new_p_0, 3);
root_label[7] = read_store_vertex(new_p_1, 3);


#if dbg0_ifte_n1r
if (
(shift_0 > 100)
||
(shift_1 > 100)
)
then  /*  error  */
    {
printf("\n***ifte_non_1_red: shift_0 = 0x%x, shift_1 = 0x%x\n",
shift_0, 
shift_1
);
    }


#endif



/* 
***************************************************************
    get new vertex from pool
***************************************************************
*/


#if (dbg_flag > 0)
if (dbg_flag > threshold)
{
printf("\nifte_r_non_1_red:%u: ckp 800:", count);
}
#endif

write_store_vertex(p, 3, (unsigned int) get_bdd_vertex(root_label));


#if (dbg_flag > 0)
if (dbg_flag > threshold)
{
printf("\nifte_r_non_1_red:%u: ckp 900:", count);
}
#endif

/*  complete define broadcast   */

/* 
non necessary since dvindex(p, 2) 
already well defined by restriction 
*/

#if 0
write_store_dvindex(p, 2, read_store_dvindex(p, 2) + 0);
#endif



/*
*************************************************************

end:  define root and broadcast  

*************************************************************
*/

#if (dbg_flag > 0)
if (dbg_flag > threshold)
{
printf("\nifte_r_non_1_red:%u: ckp 2000: (end)", count);
}
#endif

}  /*   end   ifte_non_1_red   */
