
/*
************************************************
file:  define_next_dvindex
************************************************
*/

#include "local.h"

      
#define then /* then */

#define dbg_flag 0


void define_next_dvindex(
type_bdd_store new_p, 
unsigned int new_vindex[3]
)


{ /*  begin  */

unsigned int dvindex[2];
unsigned int dv_sgn[2];

/* program  */

/*  compute dvindex and dv_sgn  */

#if (dbg_flag > 100)
printf("\ndefine_next_dvindex: ckp: 100");
printf("\nvertex = 0x%x, new_vindex[0] = %u = 0x%x", 
read_store_vertex(new_p, 0), 
new_vindex[0],
new_vindex[0]
);

printf("\nvertex = 0x%x, new_vindex[1] = %u = 0x%x", 
read_store_vertex(new_p, 1),
new_vindex[1],
new_vindex[1]
);

printf("\nvertex = 0x%x, new_vindex[2] = %u = 0x%x\n", 
read_store_vertex(new_p, 2),
new_vindex[2],
new_vindex[2]
);
#endif


def_d_vindex(
new_vindex[0],
new_vindex[1],
new_vindex[2],
&(dvindex[0]),
&(dvindex[1]),
&(dv_sgn[0]),
&(dv_sgn[1])
);


#if (dbg_flag > 100)
printf("\ndefine_next_dvindex: ckp: 200");
printf("\ndvindex[0] = %u = 0x%x, dv_sgn[0] = %u",
 dvindex[0], 
 dvindex[0], 
 dv_sgn[0]
 );
 
printf("\ndvindex[1] = %u = 0x%x, dv_sgn[1] = %u\n", 
dvindex[1], 
dvindex[1], 
dv_sgn[1]
);
#endif

/*  updating  */

               write_store_dvindex(new_p, 0, dvindex[0]);
               write_store_dv_sgn(new_p, 0, dv_sgn[0]);
               write_store_dvindex(new_p, 1, dvindex[1]);
               write_store_dv_sgn(new_p, 1, dv_sgn[1]);

}  /*  end program  */

 








void define_next_r_dv(
type_bdd_store p, 
unsigned int vindex_G[4],   /*  vindex_G[3] = restriction index  */
type_bdd_store new_p_0, 
type_bdd_store new_p_1, 
unsigned int new_vindex[2][3]
)


{ /*  begin  */

unsigned int rdvindex;
unsigned int rsgn;
unsigned int r_vindex;

/* program  */

if ( read_store_rswitch(p)  /* !=  0 */)
	{ /* if  */
	   
/* define restriction for new_p_0  */

/* define new rdvindex, rsgn  */
     
def_dv_sgn(
new_vindex[0][0],
vindex_G[3],
&rdvindex,
&rsgn
);
    


/*  updating  */

               write_store_rdvindex(new_p_0, rdvindex);
               write_store_rsgn(new_p_0, rsgn);
               write_store_rbit(new_p_0, read_store_rbit(p));
               write_store_rswitch(new_p_0, read_store_rswitch(p));


/*  restore nf (hyp: dvindex, dv_sgn in new_p are already well defined)  */

restriction_nf(new_p_0);



/* define restriction for new_p_1  */

/* define new rdvindex, rsgn  */
     
def_dv_sgn(
new_vindex[1][0],
vindex_G[3],
&rdvindex,
&rsgn
);
    


/*  updating  */

               write_store_rdvindex(new_p_1, rdvindex);
               write_store_rsgn(new_p_1, rsgn);
               write_store_rbit(new_p_1, read_store_rbit(p));
               write_store_rswitch(new_p_1, read_store_rswitch(p));


/*  restore nf (hyp: dvindex, dv_sgn in new_p are already well defined)  */

restriction_nf(new_p_1);
 
 
 
       } /* if then  */
       
else  /* read_store_rswitch(p) ==  0  */  
     {

/*  updating  */

               write_store_rdvindex(new_p_0, 0);
               write_store_rsgn(new_p_0, 0);
               write_store_rbit(new_p_0, 0);
               write_store_rswitch(new_p_0, 0);
               
               
               write_store_rdvindex(new_p_1, 0);
               write_store_rsgn(new_p_1, 0);
               write_store_rbit(new_p_1, 0);
               write_store_rswitch(new_p_1, 0);

     } 


#if dbg5_d_r_dv
if ( read_store_rswitch(p) /*  != 0  */ )
then 
printf("define_next_r_dv: read_store_rswitch(0x%x) = 0x%x\n", 
p, 
read_store_rswitch(p)
);
#endif



}  /*  end program  */

 
