/*
***********************************************

file: define_sons

***********************************************
*/




/*
********************************************************

p, p_new_0, p_new_1  are already existing stores

********************************************************
*/



#include "local.h"

#define dbg0_def_r_sons 0
#define dbg5_def_r_sons 0
#define dbg_catch_nxt_trm 0

#define dbg_flag 0


#define then /* then */


void define_r_sons(
type_bdd_store p, 
type_bdd_store p_new_0, 
type_bdd_store p_new_1
)

{  /* begin  */

/*  declarations  */
int i;
unsigned int vindex_G[4],  min_vindex, head_vindex;
unsigned int new_vindex[2][3];
unsigned int *shift_values;



#if (dbg_catch_nxt_trm > 10)
int ii;
#endif

/* program */

/*  compute vindex_G[0], vindex_G[1], vindex_G[2]  */

#if (dbg_flag > 100)
printf("\ndefine_r_sons: ckp: 10:");
printf("\nread_store_vertex(p, 0) = 0x%x", read_store_vertex(p, 0));
printf("\nread_store_vertex(p, 1) = 0x%x", read_store_vertex(p, 1));
printf("\nread_store_vertex(p, 2) = 0x%x", read_store_vertex(p, 2));

printf(
"\nread_store_dvindex(p, 0) = %u = 0x%x, read_store_dv_sgn(p, 0) = %u",
read_store_dvindex(p, 0), 
read_store_dvindex(p, 0),
read_store_dv_sgn(p, 0)
);

printf(
"\nread_store_dvindex(p, 1) = %u = 0x%x, read_store_dv_sgn(p, 1) = %u",
read_store_dvindex(p, 1), 
read_store_dvindex(p, 1), 
read_store_dv_sgn(p, 1)
);
#endif


get_vindexes_store(p, vindex_G);



#if (dbg_flag > 100)
printf("\ndefine_r_sons: ckp: 50:");
printf(
"\nvindex_G[0] = %u = 0x%x; vindex_G[1] = %u = 0x%x; vindex_G[2] = %u = 0x%x",
vindex_G[0], 
vindex_G[0],
vindex_G[1], 
vindex_G[1],
vindex_G[2],
vindex_G[2]
);

#if 0
for (i = 0; i < 3; i++)
  {
printf("\n v = vertex_%d: v = 0x%x; next(v, 0) = 0x%x; next(v, 1) = 0x%x",
i,
read_store_vertex(p, i),
read_vertex_next((ptrvertex) read_store_vertex(p, i), 0),
read_vertex_next((ptrvertex) read_store_vertex(p, i), 1)
);
  }
printf("\nrsgn = %d; rdvindex = %d; rbit = %d; rswitch = %d",
read_store_rsgn(p),
read_store_rdvindex(p),
read_store_rbit(p),
read_store_rswitch(p)
);
#endif

#endif


  
/*  compute min_vindex  */

/*  At least one vertex is nonterminal  */

              min_vindex = UINT_MAX;

              for (i = 0; i < 3; i++)
                  {
             if (
/*
       nonterminal((ptrvertex) read_store_vertex(p, i))
                   && 
*/

  (vindex_G[i] < min_vindex)
                 )
             then  min_vindex = vindex_G[i];
                  }


/*  min_vindex defined  */
 




             for (i = 0; i < 3; i++)
                  {
                      if  (       min_vindex == vindex_G[i]
/*

  &&  nonterminal((ptrvertex) read_store_vertex(p, i))
*/

                           ) 
                      then  /*  vertex nonterminal  */
                              {

#if dbg5_def_r_sons
printf("\ndefine_r_sons: ckp: 100\n");
#endif


/*  define nextstate  */

#if (dbg_catch_nxt_trm > 10)
if ( terminal((ptrvertex) read_store_vertex(p, i)) )
then 
     {
      
      printf("\n\n******************************************************");
      printf("\ndefine_r_sons: error: next_state on terminal vertex\n");

printf("\ndefine_r_sons: ckp: 50:");

printf(
"\nread_store_dv_sgn(p, 0) = %d; read_store_dvindex(p, 0) = %u = 0x%x",
read_store_dv_sgn(p, 0), read_store_dvindex(p, 0), 
read_store_dvindex(p, 0));

printf(
"\nread_store_dv_sgn(p, 1) = %d; read_store_dvindex(p, 1) = %u = 0x%x",
read_store_dv_sgn(p, 1), read_store_dvindex(p, 1), 
read_store_dvindex(p, 1));


printf("\nvindex_G[0] = 0x%x; vindex_G[1] = 0x%x; vindex_G[2] = 0x%x.",
vindex_G[0],
vindex_G[1],
vindex_G[2]
);

for (ii = 0; ii < 3; ii++)
  {
printf("\n v = vertex_%d: v = 0x%x; next(v, 0) = 0x%x; next(v, 1) = 0x%x",
ii,
read_store_vertex(p, ii),
read_vertex_next((ptrvertex) read_store_vertex(p, ii), 0),
read_vertex_next((ptrvertex) read_store_vertex(p, ii), 1)
);
  }
printf("\nrsgn = %d; rdvindex = %d; rbit = %d; rswitch = %d",
read_store_rsgn(p),
read_store_rdvindex(p),
read_store_rbit(p),
read_store_rswitch(p)
);
printf("\n******************************************************\n\n");
     
     }
#endif


                                next_state(
0, i, p, p_new_0, new_vindex, vindex_G);

#if dbg5_def_r_sons
printf("\ndefine_r_sons: ckp: 150\n");
#endif

                                next_state(
1, i, p, p_new_1, new_vindex, vindex_G);

#if dbg5_def_r_sons
printf("\ndefine_r_sons: ckp: 200\n");
#endif
 
                               }  /*  end then  */

                      else  /*  vertex does not need updating */
                           {
 /*  state unchanged  */

#if dbg5_def_r_sons
printf("\ndefine_r_sons: ckp: 300\n");
#endif
                                      same_next_state(
i, p, p_new_0, new_vindex[0], vindex_G
);
                                      same_next_state(
i, p, p_new_1, new_vindex[1], vindex_G
);

#if dbg5_def_r_sons
printf("\ndefine_r_sons: ckp: 400\n");
#endif


                           }

                    }   /*  end for_i  */


       define_next_dvindex(p_new_0, new_vindex[0]);
       define_next_dvindex(p_new_1, new_vindex[1]);

#if dbg5_def_r_sons
printf("\ndefine_r_sons: ckp: 500\n");
#endif

/*  define next restriction parameters, result in nf  */
       define_next_r_dv(p, vindex_G, p_new_0, p_new_1, new_vindex);




#if dbg5_def_r_sons

printf("\ndefine_r_sons: ckp: 550:");
printf("\nnew_vindex[0][0] = %u; new_vindex[0][1] = %u; new_vindex[0][2] = %u.",
new_vindex[0][0],
new_vindex[0][1],
new_vindex[0][2]
);

for (i = 0; i < 3; i++)
  {
printf("\n v0 = vertex_%d = 0x%x; next(v0, 0) = 0x%x; next(v0, 1) = 0x%x",
i,
read_store_vertex(p_new_0, i),
read_vertex_next((ptrvertex) read_store_vertex(p_new_0, i), 0),
read_vertex_next((ptrvertex) read_store_vertex(p_new_0, i), 1)
);
  }
  
#if 0
printf("\nrsgn = %d; rdvindex = %d; rbit = %d; rswitch = %d",
read_store_rsgn(p_new_0),
read_store_rdvindex(p_new_0),
read_store_rbit(p_new_0),
read_store_rswitch(p_new_0)
);
#endif
  
printf("\nnew_vindex[1][0] = %u; new_vindex[1][1] = %u; new_vindex[1][2] = %u.",
new_vindex[1][0],
new_vindex[1][1],
new_vindex[1][2]
);

for (i = 0; i < 3; i++)
  {
printf("\n v1 = vertex_%d = 0x%x; next(v1, 0) = 0x%x; next(v1, 1) = 0x%x",
i,
read_store_vertex(p_new_1, i),
read_vertex_next((ptrvertex) read_store_vertex(p_new_1, i), 0),
read_vertex_next((ptrvertex) read_store_vertex(p_new_1, i), 1)
);
  }

#if 0
printf("\nrsgn = %d; rdvindex = %d; rbit = %d; rswitch = %d",
read_store_rsgn(p_new_1),
read_store_rdvindex(p_new_1),
read_store_rbit(p_new_1),
read_store_rswitch(p_new_1)
);
#endif
 
#endif


#if dbg5_def_r_sons
printf("\ndefine_r_sons: ckp: 600\n");
#endif






/*  defines root shifts under the hypothesis that p_new_i nonterminal  */

/* 
Shift values stored in array shift_value pointed by 
read_store_vertex(p, 3).
*/






shift_values = (unsigned int *) malloc(2 * sizeof(unsigned int));





if (shift_values == NULL)
/* then */ 
      {
         printf("\ndefine_r_sons: error: shift_values == NULL");
         exit (1000);
      }

/* shift_values != NULL */


#if (dbg_flag > 100)
printf("\ndefine_r_sons: ckp: 7215: p = 0x%x: shift_values = 0x%x = %u",
p,
shift_values, 
shift_values
);
#endif


write_store_vertex(p, 3, (unsigned int) shift_values);

  
/*  define vindex head side 0  */


              head_vindex = UINT_MAX;

              for (i = 0; i < 3; i++)
                  {
             if (
/*
nonterminal((ptrvertex) read_store_vertex(p_new_0, i))
&&
*/

(new_vindex[0][i] < head_vindex)
                 )
             then  head_vindex = new_vindex[0][i];
                  }


/*  vindex head side 0 defined: head_vindex > min_vindex */
 

#if dbg5_def_r_sons
printf("\ndefine_r_sons: ckp: 700\n");
#endif

/* 
Define shift side 0 in shift_values[0]. 
Note: ok even if head_vindex = UINT_MAX.
*/

shift_values[0] = head_vindex - min_vindex;



  /*  define vindex head side 1  */


              head_vindex = UINT_MAX;

              for (i = 0; i < 3; i++)
                  {
             if (
/*
nonterminal((ptrvertex) read_store_vertex(p_new_1, i))
&& 
*/

(new_vindex[1][i] < head_vindex)
                 )
             then  head_vindex = new_vindex[1][i];
                  }


/*  vindex head side 1 defined  */
 
#if dbg5_def_r_sons
printf("\ndefine_r_sons: ckp: 800\n");
#endif


/* 
Define shift side 1 in shift_values[1].
Note: ok even if head_vindex = UINT_MAX.
*/

shift_values[1] = head_vindex - min_vindex;

#if (dbg_flag > 100)
printf("\ndefine_r_sons: ckp: 9345: p = 0x%x: read_store_vertex(p, 3) = 0x%x = %u",
p,
read_store_vertex(p, 3), 
read_store_vertex(p, 3)
);
printf("\nshift[0] = 0x%x = %u, shift[1] = 0x%x = %u",
((unsigned int *) read_store_vertex(p, 3))[0],
((unsigned int *) read_store_vertex(p, 3))[0], 
((unsigned int *) read_store_vertex(p, 3))[1],
((unsigned int *) read_store_vertex(p, 3))[1]
);
printf("\nshift_values = 0x%x = %u, shift_values[0] = 0x%x = %u, shift_values[1] = 0x%x = %u",
shift_values,
shift_values,
shift_values[0], 
shift_values[0], 
shift_values[1],
shift_values[1] 
);

#endif


/* end partial shifts definition  */

#if dbg5_def_r_sons
printf("\ndefine_r_sons: ckp: 1111\n");
#endif



} /* end program  */
