/*
*************************************************
file:  unlock_free
*************************************************
*/



/*
*************************************************

Unlock store p;
if possible, frees it;
update to_be_deleted.

*************************************************
*/



#include "local.h"

#define dbg0_unlock_free_store 0
#define dbg10_unlock_free_store 0
#define dbg5_unlock_free_store 0
#define dbg5_store 0




void unlock_free_store(type_bdd_store p)

{  /* begin program */


#if dbg0_unlock_free_store
static int count = 0;
#endif

#if dbg10_unlock_free_store
static int c_free_s = 0;
#endif

/*  program  */

#if dbg0_unlock_free_store
count = count + 1;
#endif
#if dbg5_unlock_free_store
printf("\ncall: %d: unlock_free_store\n", count);
#endif


unlock_bdd_store(p);




#if dbg5_unlock_free_store
printf("\nunlock_free_store: %d:  ckp 100\n", count);
#endif

          if ( read_store_in_edges(p) == 0 )
          /* then */   /* free p  */
             {

#if dbg5_unlock_free_store
printf("\nunlock_free_store: %d:  ckp 200\n", count);
#endif
#if dbg10_unlock_free_store
c_free_s = c_free_s + 1;
if (count%10000 == 0)
/* then */ 
{
printf("\n********************unlock_free_store: %d:  freeing store p = 0x%x", 
count, 
p
);
printf("\ncount_store = %d, read_store_in_edges(p) = %d", 
count_store,
read_store_in_edges(p)
);
printf("\nc_free_s = %d", c_free_s); 
printf("\nnum.elem. in T_ifte = %d, size of T_ifte = %d", 
get_cache_elements(T_ifte), get_cache_size(T_ifte));
printf("\nnum.elem. in T_graph = %d, size of T-graph = %d", 
get_lkup_table_elements(T_graph), get_lkup_table_size(T_graph));
printf("\nbuckets (non-null entries) in T_graph = %d",
get_non_null_entry(T_graph)
);
#if dbg5_store
printf("\ncount_store = %d", count_store);
printf("\ncreated_store = %d", created_store);
printf("\nfreed_store = %d", freed_store);
printf("\ncreated_store - freed_store = %d",
created_store - freed_store);
#endif
printf("\n************************************************************");
}
#endif





#if 0
/* unlock_vertex  */
/* Not needed   */
unlock_bdd_vertex( (ptrvertex) read_store_vertex(p, 3) );
#endif

   
   
        free_bdd_store(p);

#if dbg5_unlock_free_store
printf("\nunlock_free_store: %d:  ckp 300\n", count);
#endif

              }


#if dbg5_unlock_free_store
printf("\nend: %d: unlock_free_store\n", count);
#endif


}  /*  end program  */



