/*
**
**  file:  cleanup.lkup.table
**
*/


#include "lookuptb.h"
#include "local.h"

#define dbg_flag 0


void cleanup_lkup_table(look_up_table T)

{


/* declarations  */
int i;
lk_up_table_value p, v, pp;


/*  program  */


/*  preparation (updates free tags)  */

#if (dbg_flag > 100)
printf("\ncleanup_lkup_table: ckp 100");
#endif

for (i = 0; i < ((lkup_table *) T) -> size_table; i++)
  {
      p = ((lkup_table *) T) -> table[i];
 
#if (dbg_flag > 100)
printf("\ncleanup_lkup_table: ckp 200.%d: p = 0x%x",
i,
p);
#endif

      while (p != NULL)
           {

#if (dbg_flag > 100)
printf("\ncleanup_lkup_table: ckp 300.p = 0x%x",
p);
#endif
              ( *( ((lkup_table *) T) -> update_free_tags ) )(p);

#if (dbg_flag > 100)
printf("\ncleanup_lkup_table: ckp 400.p = 0x%x",
p);
#endif

              p =  ( *( ((lkup_table *) T) -> read_plot ) )(p);

#if (dbg_flag > 100)
printf("\ncleanup_lkup_table: ckp 500.p = 0x%x",
p);
#endif

           }
  }


/*  end preparation  */

#if (dbg_flag > 100)
printf("\ncleanup_lkup_table: ckp 900");
#endif


/*  begin erasing  */

for (i = 0; i < ((lkup_table *) T) -> size_table; i++)
  {

      p = ((lkup_table *) T) -> table[i];
 
#if (dbg_flag > 100)
printf("\ncleanup_lkup_table: ckp 1100.%d: p = 0x%x",
i,
p);
#endif

      while ( ( *( ((lkup_table *) T) -> to_be_erased ) )(p) )
           {
             v = ( *( ((lkup_table *) T) -> read_plot ) )(p);

             ( *( ((lkup_table *) T) -> free_value ) )(p);

          ((lkup_table *) T) -> elements_in_table = 
((lkup_table *) T) -> elements_in_table - 1;


              p = v;
           }

      /*  p is not to be erased  */



#if measure_non_null
/* update non_null_entry  */

      if ( (p == NULL) && (((lkup_table *) T) -> table[i] != NULL) )
      then
          {
          ((lkup_table *) T) -> non_null_entry = 
((lkup_table *) T) -> non_null_entry - 1;
          }
#endif


      ((lkup_table *) T) -> table[i] = p;

  
      pp = p;

      while (pp != NULL)
           {

      p = ( *( ((lkup_table *) T) -> read_plot ) )(p);

      while ( ( *( ((lkup_table *) T) -> to_be_erased ) )(p) )
           {
             v = ( *( ((lkup_table *) T) -> read_plot ) )(p);

             ( *( ((lkup_table *) T) -> free_value ) )(p);

          ((lkup_table *) T) -> elements_in_table = 
((lkup_table *) T) -> elements_in_table - 1;


              p = v;
           }

      /*  p is not to be erased  */

    ( *( ((lkup_table *) T) -> write_plot ) )(pp, p);

       pp = p;
           }  /*  end while  */

  }  /*  end for  */


/*  end erasing   */

#if (dbg_flag > 100)
printf("\ncleanup_lkup_table: ckp 2000 (end)");
#endif


}  /*  end program  */



