/*
**
**  file: write.lkup.table
**
*/

/*
**  insert new element in table
**
**  if data with same key already in table
**  new data inserted anyway (an the old one stays)
**
*/

#include "local.h"


void write_lkup_table(
look_up_table T, 
lk_up_table_value value
)
{

/* declarations  */
  unsigned int a;
  lk_up_table_value v, p;

#if debug_lkup_table
static int count = 0;
#endif

/* programs  */


#if debug_lkup_table
count = count + 1;
#endif


   a = tuple_value(T, value);


   if (  ((lkup_table *) T) -> table[a] == NULL )
   then /* no data with given key  */
        {
          ((lkup_table *) T) -> table[a] = value;

          ((lkup_table *) T) -> elements_in_table = 
((lkup_table *) T) -> elements_in_table + 1;



#if measure_non_null
/* update non_null_entry  */
          ((lkup_table *) T) -> non_null_entry = 
((lkup_table *) T) -> non_null_entry + 1;
#endif



           return ;   
           
         };  



/*  ((lkup_table *) T) -> table[a] != NULL  */



   v = ((lkup_table *) T) -> table[a];




   /*  v, p != NULL  */

    if (  ! ( *( ((lkup_table *) T) -> data_less_than ) )(v, value) )
    then  /* insert on head  */
         {
            ( *( ((lkup_table *) T) -> write_plot ) )(value, v);

            ((lkup_table *) T) -> table[a] = value;

          ((lkup_table *) T) -> elements_in_table = 
((lkup_table *) T) -> elements_in_table + 1;


             return;

          } 


/*  
**  ( *( ((lkup_table *) T) -> data_less_than ) )(v, value)
*/

      

      p = v;
      v =  ( *( ((lkup_table *) T) -> read_plot ) )(v);


   while ( ( *( ((lkup_table *) T) -> data_less_than ) )(v, value) ) 
      {
        p = v;
        v =  ( *( ((lkup_table *) T) -> read_plot ) )(v);

      }

    ( *( ((lkup_table *) T) -> write_plot ) )(value, v);

    ( *( ((lkup_table *) T) -> write_plot ) )(p, value);


          ((lkup_table *) T) -> elements_in_table = 
((lkup_table *) T) -> elements_in_table + 1;


      return ;



}  /* end program  */
