/*
**
**  file: read_write_dv_sgn
**
**
*/



/*
**  writes dvsgn value in store
**
**
*/


#include "local.h"


 /*  bit 6 */
#define mask_dvsgn_0 0x40  

 /*  bit 7  */
#define mask_dvsgn_1 0x80  

#define position_dvsgn_0 6  
#define position_dvsgn_1 7

#define word_dvsgn_0 0  
#define word_dvsgn_1 0  
 
  


void write_store_dv_sgn(
type_bdd_store p, 
int i, 
unsigned int value
)

{   /*  begin program  */

/* declarations  */

/*  program  */

switch (i)
           {
                 case 0:  
                          write_bdd_store_generic(
                            p, 
                            word_dvsgn_0, 
                            position_dvsgn_0, 
                            mask_dvsgn_0, 
                            value
                            );

      
                           return ;

                 case 1:  
                         write_bdd_store_generic(
                            p, 
                            word_dvsgn_1, 
                            position_dvsgn_1, 
                            mask_dvsgn_1, 
                            value
                            );

      
                           return ;

               default: return;


           }


}  /*  end program  */


unsigned int read_store_dv_sgn(
type_bdd_store p, 
int i
)

{   /*  begin program  */

/* declarations  */

/*  program  */

switch (i)
           {
                 case 0:  

                        return (
                                  read_bdd_store_generic(
                                        p, 
                                        word_dvsgn_0, 
                                        position_dvsgn_0, 
                                        mask_dvsgn_0
                                        )
                               );



                 case 1:  
                        return (
                                  read_bdd_store_generic(
                                        p, 
                                        word_dvsgn_1, 
                                        position_dvsgn_1, 
                                        mask_dvsgn_1
                                        )
                               );

 
              default: return (0u);


           }


}  /*  end program  */
