/*
**
**  file: read_write_flip
**
**
*/


#include "local.h"



/*
**  writes flip value in store
**
**
*/

#define word_flip 0  

#define mask_flip_0 0x4000
#define position_flip_0 14

#define mask_flip_1 0x8000
#define position_flip_1 15

#define mask_flip_2 0x10000
#define position_flip_2 16

#define mask_flip_3 0x2000000
#define position_flip_3 25



void write_store_flip(
type_bdd_store p, 
int i, 
unsigned int value
)

{   /*  begin program  */

/* declarations  */

/*  program  */

switch (i)
           {
                 case 0:  
                          write_bdd_store_generic(
                            p, 
                            word_flip, 
                            position_flip_0, 
                            mask_flip_0, 
                            value
                            );

      
                           return ;
      
                 case 1:  
                          write_bdd_store_generic(
                            p, 
                            word_flip, 
                            position_flip_1, 
                            mask_flip_1, 
                            value
                            );
      
                               return ;

                 case 2:  
                         write_bdd_store_generic(
                            p, 
                            word_flip, 
                            position_flip_2, 
                            mask_flip_2, 
                            value
                            );
       
                               return ;

                 case 3:  
                         write_bdd_store_generic(
                            p, 
                            word_flip, 
                            position_flip_3, 
                            mask_flip_3, 
                            value
                            );
       
                               return ;

               default: return;


           }


}  /*  end program  */


unsigned int read_store_flip(
type_bdd_store p, 
int i
)

{   /*  begin program  */

/* declarations  */

/*  program  */

switch (i)
           {
                 case 0:  

                        return (
                                  read_bdd_store_generic(
                                        p, 
                                        word_flip, 
                                        position_flip_0, 
                                        mask_flip_0
                                       )
                               );






                 case 1: 
 
                        return (
                                  read_bdd_store_generic(
                                        p, 
                                        word_flip, 
                                        position_flip_1, 
                                        mask_flip_1
                                       )
                               );



                 case 2:  

                        return (
                                  read_bdd_store_generic(
                                        p, 
                                        word_flip, 
                                        position_flip_2, 
                                        mask_flip_2 
                                       )
                               );


                 case 3:  

                        return (
                                  read_bdd_store_generic(
                                        p, 
                                        word_flip, 
                                        position_flip_3, 
                                        mask_flip_3
                                       )
                               );


              default: return (0u);


           }


}  /*  end program  */
