/*
**
**  file: read_write_p_flip
**
**
*/



/*
**  writes p_flip value in store
**
**
*/




#include "local.h"




#define mask_p_flip_0 0x100         /*  bit 8  */
#define mask_p_flip_1 0x200         /*  bit 9  */
#define mask_p_flip_2 0x400         /*  bit 10  */
#define mask_p_flip_3 0x1000000     /*  bit 24  */

#define position_p_flip_0 8  
#define position_p_flip_1 9
#define position_p_flip_2 10
#define position_p_flip_3 24

#define word_p_flip_0 0  
#define word_p_flip_1 0  
#define word_p_flip_2 0  
#define word_p_flip_3 0 
  


void write_store_p_flip(
type_bdd_store p, 
int i, 
unsigned int value
)

{   /*  begin program  */

/* declarations  */

/*  program  */

switch (i)
           {
                 case 0:  
                          write_bdd_store_generic(
                            p, 
                            word_p_flip_0, 
                            position_p_flip_0, 
                            mask_p_flip_0, 
                            (unsigned int) value
                            );
      
                               return ;

                 case 1:  

                          write_bdd_store_generic(
                            p, 
                            word_p_flip_1, 
                            position_p_flip_1, 
                            mask_p_flip_1, 
                            (unsigned int) value
                            );
      
                               return ;

                 case 2:  

                          write_bdd_store_generic(
                            p, 
                            word_p_flip_2, 
                            position_p_flip_2, 
                            mask_p_flip_2, 
                            (unsigned int) value
                            );
      
      
                               return ;

                 case 3:  
                          write_bdd_store_generic(
                            p, 
                            word_p_flip_3, 
                            position_p_flip_3, 
                            mask_p_flip_3, 
                            (unsigned int) value
                            );
      
      
                               return ;

               default: return;


           }


}  /*  end program  */


unsigned int read_store_p_flip(
type_bdd_store p, 
int i
)

{   /*  begin program  */

/* declarations  */

/*  program  */

switch (i)
           {
                 case 0:  

                        return (
                                  read_bdd_store_generic(
                                        p, 
                                        word_p_flip_0, 
                                        position_p_flip_0, 
                                        mask_p_flip_0
                                       )
                               );



                 case 1:  

                        return (
                                  read_bdd_store_generic(
                                        p, 
                                        word_p_flip_1, 
                                        position_p_flip_1, 
                                        mask_p_flip_1
                                       )
                               );

                case 2:  

                        return (
                                  read_bdd_store_generic(
                                        p, 
                                        word_p_flip_2, 
                                        position_p_flip_2, 
                                        mask_p_flip_2
                                       )
                               );

                 case 3:  

                        return (
                                  read_bdd_store_generic(
                                        p, 
                                        word_p_flip_3, 
                                        position_p_flip_3, 
                                        mask_p_flip_3
                                       )
                               );


              default: return (0);


           }


}  /*  end program  */
