/*
**
**  file: write_store_p_swap
**
**
*/



/*
**  writes p_swap value in store
**
**
*/



#include "local.h"



 
#define mask_p_swap_0 0x800         /*  bit 11  */
#define mask_p_swap_1 0x1000        /*  bit 12  */
#define mask_p_swap_2 0x2000        /*  bit 13  */
#define mask_p_swap_3 0x4000000     /*  bit 26  */ 

#define position_p_swap_0 11  
#define position_p_swap_1 12
#define position_p_swap_2 13
#define position_p_swap_3 26

#define word_p_swap_0 0  
#define word_p_swap_1 0  
#define word_p_swap_2 0  
#define word_p_swap_3 0  



void write_store_p_swap(
type_bdd_store p, 
int i, 
unsigned int value
)

{   /*  begin program  */

/* declarations  */

/*  program  */

switch (i)
           {
                 case 0:  
                          write_bdd_store_generic(
                            p, 
                            word_p_swap_0, 
                            position_p_swap_0, 
                            mask_p_swap_0, 
                            value
                            );
            
                               return ;

                 case 1:  
                          write_bdd_store_generic(
                            p, 
                            word_p_swap_1, 
                            position_p_swap_1, 
                            mask_p_swap_1, 
                            value
                            );
       
                               return ;

                 case 2:  
                          write_bdd_store_generic(
                            p, 
                            word_p_swap_2, 
                            position_p_swap_2, 
                            mask_p_swap_2, 
                            value
                            );
      
                               return ;

                 case 3:  
                          write_bdd_store_generic(
                            p, 
                            word_p_swap_3, 
                            position_p_swap_3, 
                            mask_p_swap_3, 
                            value
                            );
      
                               return ;

               default: return;


           }


}  /*  end program  */


unsigned int  read_store_p_swap(
type_bdd_store p, 
int i
)

{   /*  begin program  */

/* declarations  */

/*  program  */

switch (i)
           {
                 case 0:  

                        return (
                                  read_bdd_store_generic(
                                        p, 
                                        word_p_swap_0, 
                                        position_p_swap_0, 
                                        mask_p_swap_0
                                       )
                               );



                 case 1:  
                        return (
                                  read_bdd_store_generic(
                                        p, 
                                        word_p_swap_1, 
                                        position_p_swap_1, 
                                        mask_p_swap_1
                                       )
                               );

                 case 2:  

                        return (
                                  read_bdd_store_generic(
                                        p, 
                                        word_p_swap_2, 
                                        position_p_swap_2, 
                                        mask_p_swap_2
                                       )
                               );
                               
                               
                 case 3:  

                        return (
                                  read_bdd_store_generic(
                                        p, 
                                        word_p_swap_3, 
                                        position_p_swap_3, 
                                        mask_p_swap_3
                                       )
                               );



              default: return (0u);


           }


}  /*  end program  */
