/*
**
**  file: read_write_flip
**
**
*/



/*
**  writes swap value in store
**
**  It is assumed that we are in 
**  an Apply context (not an if_then_else).
**
**  full_size_store must be 11
**  if swap used.
**
**
*/


#include "local.h"

 
#define word_swap_0 0  
#define word_swap_1 0  
#define word_swap_2 0  
#define word_swap_3 0  
 
#define position_swap_0 17  
#define position_swap_1 18  
#define position_swap_2 19  
#define position_swap_3 27  
  
#define mask_swap_0 0x20000            /*  bit  17  */
#define mask_swap_1 0x40000            /*  bit  18  */
#define mask_swap_2 0x80000            /*  bit  19  */  
#define mask_swap_3 0x8000000          /*  bit  27  */   


void write_store_swap(
type_bdd_store p, 
int i, 
unsigned int value
)

{   /*  begin program  */

/* declarations  */

/*  program  */

switch (i)
           {
                 case 0:  
                          write_bdd_store_generic(
                            p, 
                            word_swap_0, 
                            position_swap_0, 
                            mask_swap_0, 
                            value
                            );

     
                               return ;

                 case 1:  
                          write_bdd_store_generic(
                            p, 
                            word_swap_1, 
                            position_swap_1, 
                            mask_swap_1, 
                            value
                            );
     
                               return ;

                 case 2:  
                           write_bdd_store_generic(
                            p, 
                            word_swap_2, 
                            position_swap_2, 
                            mask_swap_2, 
                            value
                            );
      
                 case 3:  
                           write_bdd_store_generic(
                            p, 
                            word_swap_3, 
                            position_swap_3, 
                            mask_swap_3, 
                            value
                            );
                               return ;


               default: return;


           }


}  /*  end program  */


unsigned int read_store_swap(
type_bdd_store p, 
int i
)

{   /*  begin program  */

/* declarations  */

/*  program  */

switch (i)
           {
                 case 0:  

                        return (
                                  read_bdd_store_generic(
                                        p, 
                                        word_swap_0, 
                                        position_swap_0, 
                                        mask_swap_0
                                       )
                               );



                 case 1: 
 
                        return (
                                  read_bdd_store_generic(
                                        p, 
                                        word_swap_1, 
                                        position_swap_1, 
                                        mask_swap_1
                                       )
                               );


                 case 2:  

                        return (
                                  read_bdd_store_generic(
                                        p, 
                                        word_swap_2, 
                                        position_swap_2, 
                                        mask_swap_2
                                       )
                               );

                 case 3:  

                        return (
                                  read_bdd_store_generic(
                                        p, 
                                        word_swap_3, 
                                        position_swap_3, 
                                        mask_swap_3
                                       )
                               );

           default: return (0u);


           }


}  /*  end program  */
