

/*
**
** file: rnext.c
**
*/



#include "local.h"


/*
******************************************
B is given accordingly to bdd vertex conceptual fields;
A is defined so that gvertex.h can be used
******************************************
*/



/*
**************************************************
B is as follows:
B[0] = flip side 0;
B[1] = flip side 1;
B[2] = swap side 0;
B[3] = swap side 1;
B[4] = shift side 0;
B[5] = shift side 1;
B[6] = next side 0;
B[7] = next side 1;
**************************************************
*/

#define mask_size_nonptr 0x3
#define mask_size_ptr_lab 0xc
#define mask_next_default 0x100    /* bit 8  */
#define mask_28_bit 0x1fffffff


ptrvertex read_vertex_next(ptrvertex v, int i)
{

unsigned int A[3];
unsigned int size_nonptr_lab;

/*  program  */

/*
define next fields;
return size_pointer_label.
*/


/*  define next_def_flag  */

A[0] = gvertex_hlab(v);

size_nonptr_lab = size_gvtx_nonptrlab(v);

           if (
			(A[0] & mask_ptr0)   /*   (B[6] != default_bddvtx)  */
		&&	(A[0] & mask_ptr1)   /*   (B[7] != default_bddvtx)   */
              )
           /* then  */
/*   (B[6] != default_bddvtx) && (B[7] != default_bddvtx)   */
          /* size_pointer_label = 2  */
           {
               return ( (ptrvertex)
                                    gvertex_tlab(v, size_nonptr_lab + i)
                         );
                    
           }
           
           

            if (
			!(A[0] & mask_ptr0)  /*   (B[6] == default_bddvtx)  */
		&&	(A[0] & mask_ptr1)  /*    (B[7] != default_bddvtx)   */
              )
           /* then  */
/*   (B[6] == default_bddvtx) && (B[7] != default_bddvtx)   */
          /* size_pointer_label = 1  */
           {
                  switch (i)
                     {
                         
                        case 0: 
                         		return ( default_bddvtx );
                        case 1: 
                 			return ( (ptrvertex)
                                    gvertex_tlab(v, size_nonptr_lab)
                        				 );
                         
                         default: return (default_bddvtx);
                         
                     }
           }




           if (
			(A[0] & mask_ptr0)  /*   (B[6] != default_bddvtx)  */
		&&	!(A[0] & mask_ptr1)  /*   (B[7] == default_bddvtx)   */
              )
           /* then  */
/*   (B[6] != default_bddvtx) && (B[7] == default_bddvtx)   */
          /* size_pointer_label = 1  */
           {
                  switch (i)
                     {
                         
                        case 0: 
                 			return ( (ptrvertex)
                                    gvertex_tlab(v, size_nonptr_lab)
                        				 );
                         
                        case 1: 
                         		return (default_bddvtx);
                         		
                         default: return (default_bddvtx);
                         
                     }
           }


                
/*   (B[6] == default_bddvtx) && (B[7] == default_bddvtx)   */


		return ( default_bddvtx );
                         
                  

}   /*  end program  */


