

/*
**
** file: get_new_vertex
**
*/



#include "local.h"

#include <math.h>



#define dbg_flag 0
#define threshold 0
#define sh0wide 15   /* last bit shift0 in 1 word shifts  */


  
/*
******************************************
B is given accordingly to bdd vertex conceptual fields;
A is defined so that gvertex.h can be used
******************************************
*/



/*
**************************************************
B is as follows:
B[0] = flip side 0;
B[1] = flip side 1;
B[2] = swap side 0;
B[3] = swap side 1;

B[4] = shift side 0;
B[5] = shift side 1;

B[6] = next side 0;
B[7] = next side 1;
**************************************************
*/



#if 0
unsigned int shift_default(unsigned int *A, unsigned int *B)
{

/*  declarations  */


#if (dbg_flag > 0)
static unsigned int count = 0;
#endif


/*

define A fields for shifts.
return size_nonpointer_label.

*/



/*  program  */

#if (dbg_flag > 0)
count++;
#endif

/*  define shift_def_flag  */


#if (dbg_flag > 10)
if (count > threshold)
{
printf("\nshift_default:%u: ckp 100: (begin)", count);
testfrexp();
}
#endif

           if ( (B[4] <= mask_shd) && (B[5] <= mask_shd) )
           /* then  */  
           /* size_nonpointer_label = 1, 
               shift_def_flag = 0   
           */
               {
                   
#if (dbg_flag > 10)
if (count > threshold)
{
printf("\nshift_default:%u: ckp 110", count);
}
#endif

              A[0] = (A[0] & ~mask_shflag); 
                   
  /* define shift values  */
 A[0] = 		(A[0] & ~mask_sh10) 
 		| 	((B[4] << 24) & mask_sh0) 
 		| 	((B[5] << 28) & mask_sh1) ;
 
#if (dbg_flag > 10)
if (count > threshold)
{
printf("\nshift_default:%u: ckp 120: end sh_sz = 1", count);
}
#endif

   /* size_nonpointer_label = 1  */
                   return (0x1);
                   
                }

#if (dbg_flag > 10)
if (count > threshold)
{
printf("\nshift_default:%u: ckp 200", count);
testfrexp();
}
#endif


/* At least one shift word needed  */

         A[0] = (A[0] | mask_shflag);   /*  shift info 1  */





/* sh0wide >= 0  */

 		
#if (dbg_flag > 10)
if (count > threshold)
{
printf("\nshift_default:%u: ckp 400", count);
}
#endif

/*  Define A[1] and (if appropriate) A[2]  */	

    if ( B[5] < pow(2, 32 - sh0wide - 1) )
    /*  there is space for B[5]  */
    	{
    	  
#if (dbg_flag > 10)
if (count > threshold)
{
printf("\nshift_default:%u: ckp 450", count);
}
#endif

 A[0] = 		(A[0] & ~mask_sh10) 
 		| 	((sh0wide << 24) & mask_shpos);

 	 A[1] =  (B[4] | (B[5] << (sh0wide + 1)) );

#if 0
#if (dbg_flag > 10)
printf("\n1 word shift %u: (5 word bddvtx) last bit shift_0: %u = 0x%x",
count,
sh0wide,
sh0wide
);
printf("\nshift_0 = %u = 0x%x, shift_1 = %u = 0x%x",  
B[4], 
B[4], 
B[5],
B[5]
);
#endif
#endif

#if (dbg_flag > 10)
if (count > threshold)
{
printf("\nshift_default:%u: ckp 500: sh_sz = 2", count);
}
#endif

   /* size_nonpointer_label = 2  */
                   return (0x2);
    	    
    	}
    else  /* no space for B[5]: use 2 words for shifts  */
    	{
        
#if (dbg_flag > 10)
if (count > threshold)
{
printf("\nshift_default:%u: ckp 600", count);
}
#endif

	  A[0] = ((A[0] & ~mask_sh10) | mask_shpos);

	 A[1] = B[4];
	 A[2] = B[5];

#if (dbg_flag > 10)
if (count > threshold)
{
printf("\nshift_default:%u: ckp 700: sh_sz = 3", count);
}
#endif

   /* size_nonpointer_label = 3  */
                   return (0x3);
   	    
    	}      


}

#endif






#if 1
/*   OLD VERSIN   */
unsigned int shift_default(unsigned int *A, unsigned int *B)
{

/*  declarations  */

double frp;
int sh0Mbit;

#if (dbg_flag > 0)
static unsigned int count = 0;
#endif


/*

define A fields for shifts.
return size_nonpointer_label.

*/



/*  program  */

#if (dbg_flag > 0)
count++;
#endif

/*  define shift_def_flag  */


#if (dbg_flag > 10)
if (count > threshold)
{
printf("\nshift_default:%u: ckp 100: (begin)", count);
testfrexp();
}
#endif

           if ( (B[4] <= mask_shd) && (B[5] <= mask_shd) )
           /* then  */  
           /* size_nonpointer_label = 1, 
               shift_def_flag = 0   
           */
               {
                   
#if (dbg_flag > 10)
if (count > threshold)
{
printf("\nshift_default:%u: ckp 110", count);
}
#endif

              A[0] = (A[0] & ~mask_shflag); 
                   
  /* define shift values  */
 A[0] = 		(A[0] & ~mask_sh10) 
 		| 	((B[4] << 24) & mask_sh0) 
 		| 	((B[5] << 28) & mask_sh1) ;
 
#if (dbg_flag > 10)
if (count > threshold)
{
printf("\nshift_default:%u: ckp 120: end sh_sz = 1", count);
}
#endif

   /* size_nonpointer_label = 1  */
                   return (0x1);
                   
                }

#if (dbg_flag > 10)
if (count > threshold)
{
printf("\nshift_default:%u: ckp 200", count);
testfrexp();
}
#endif


/* At least one shift word needed  */

         A[0] = (A[0] | mask_shflag);   /*  shift info 1  */

#if (dbg_flag > 10)
if (count > 0)
{
printf("\nshift_default:%u: ckp 250: B[4] = %u = %f", 
count,
B[4],
(double) B[4]
);
testfrexp();
}
#endif


/*  Compute number of bits needed to represent shift_0 (B[4])  */

           frp = frexp((double) B[4], &sh0Mbit);   

#if 0
sh0Mbit = 16;   /* just to try  */
#endif

#if (dbg_flag > 10)
if (count > 0)
{
printf("\nshift_default:%u: ckp 300: sh0Mbit = %d", 
count,
sh0Mbit
);
testfrexp();
}
#endif


/* Define value in bits 24 - 28 (last bit of B[4])  */

           if (sh0Mbit <=  0) 
           /* then */ 
           	sh0Mbit = 0;
           else
           	sh0Mbit = sh0Mbit - 1;

/* sh0Mbit >= 0  */

 		
#if (dbg_flag > 10)
if (count > threshold)
{
printf("\nshift_default:%u: ckp 400", count);
}
#endif

/*  Define A[1] and (if appropriate) A[2]  */	

    if ( (B[5] < pow(2, 32 - sh0Mbit - 1)) && (sh0Mbit < 31) )
    /*  there is space for B[5]  */
    	{
    	  
#if (dbg_flag > 10)
if (count > threshold)
{
printf("\nshift_default:%u: ckp 450", count);
}
#endif

 A[0] = 		(A[0] & ~mask_sh10) 
 		| 	((sh0Mbit << 24) & mask_shpos);

 	 A[1] =  (B[4] | (B[5] << (sh0Mbit + 1)) );

#if 0
#if (dbg_flag > 10)
printf("\n1 word shift %u: (5 word bddvtx) last bit shift_0: %u = 0x%x",
count,
sh0Mbit,
sh0Mbit
);
printf("\nshift_0 = %u = 0x%x, shift_1 = %u = 0x%x",  
B[4], 
B[4], 
B[5],
B[5]
);
#endif
#endif

#if (dbg_flag > 10)
if (count > threshold)
{
printf("\nshift_default:%u: ckp 500: sh_sz = 2", count);
}
#endif

   /* size_nonpointer_label = 2  */
                   return (0x2);
    	    
    	}
    else  /* no space for B[5]: use 2 words for shifts  */
    	{
        
#if (dbg_flag > 10)
if (count > threshold)
{
printf("\nshift_default:%u: ckp 600", count);
}
#endif

	  A[0] = ((A[0] & ~mask_sh10) | mask_shpos);

	 A[1] = B[4];
	 A[2] = B[5];

#if (dbg_flag > 10)
if (count > threshold)
{
printf("\nshift_default:%u: ckp 700: sh_sz = 3", count);
}
#endif

   /* size_nonpointer_label = 3  */
                   return (0x3);
   	    
    	}      


}

#endif




#if (test_bddvtx > 0)
void testfrexp()
{
static unsigned int i = 0;
int j;

double frpq;
double x = 17.0;

#if 0
int *pp;
pp = (int *) malloc(sizeof(int));
if (pp == NULL)
{
    printf("\nerror: no space for pp (test_frexp)");
    exit (1000);
}
/* pp != NULL  */
#endif


/*  program  */
i++;

printf(
"\nTest %u frexp: frexp = 0x%x; (* freexp) = 0x%x; \nx = %f; &j = 0x%x",
i,
(unsigned int) frexp,
(unsigned int) (*frexp),
x,
&j
);

j = 2;
printf("\nj = %d = %d = *(&j)", j, *(&j));
 
frpq = frexp(x, &j);

printf("\nfrexp(x, &j) = %f; j = %d",
frpq,
j
);

}  /*  test_frexp  */
#endif
