/*
************************************
file: ifte.c
************************************
*/


#include "local.h"




#define dbg_flag 0  /* normal value: 0  */


void apply_eval(prghdr *p)
{
/* dcl  */

FILE *qfile;

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif


/*  prg  */

#if (print_info > 5)
begin_prt_info(p);


#if (keep_ids > 0)
printf(": eval %s %s \"%s\"",
vtxeval(regfield(p -> pc, query_word0), 1),
vtxeval(regfield(p -> pc, query_word0 + 1), 1),
regfield(p -> pc, query_word0 + 2)
);
#endif



#if (keep_ids == 0)
printf(": eval p%x X%x \"%s\"",
regfield(p -> pc, query_word0),
regfield(p -> pc, query_word0 + 1),
regfield(p -> pc, query_word0 + 2)
);
#endif



#endif

#if (dbg_flag > 10)
printf("\napply_eval:%u: begin: p = 0x%x, pc = 0x%x", count, p, p -> pc);
#endif


/* print answer to query */

qfile = fopen(p -> answfilename, "a");



#if (keep_ids > 0)
fprintf(qfile, 
"\n\n\neval %s %s \"%s\" = \n",
vtxeval(regfield(p -> pc, query_word0), 1),
vtxeval(regfield(p -> pc, query_word0 + 1), 1),
regfield(p -> pc, query_word0 + 2)
);
#endif



#if (keep_ids == 0)
fprintf(qfile, 
"\n\n\neval p%x X%x \"%s\" = \n",
regfield(p -> pc, query_word0),
regfield(p -> pc, query_word0 + 1),
regfield(p -> pc, query_word0 + 2)
);
#endif


fprintf(qfile, 
"bdd for function p%x:", 
regfield(p -> pc, query_word0)
); 



fprint_bdd(
   qfile, 
   regfield(
	regfield(p -> pc, query_word0),
	bddvalue
	)
          );




fclose(qfile);


/* advance pc */

p -> pc = regfield(p -> pc, ptr_down);


#if (print_info > 5)
end_prt_info(p);
#endif


}  /*  apply_eval  */
