/*
************************************
file: ifte.c
************************************
*/


#include "local.h"


#define dbg_flag 0 /* normal value: 0  */
#define dbg_bdd 0  /* normal value: 0  */
#define dbg_vtx 0  /* normal value: 0  */



void apply_ifte(prghdr *p)
{
/* dcl  */


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif


/*  prg  */
#if (dbg_bdd > 100)
printf("\n\n");
#endif




#if (print_info > 5)

#if (filter_ids > 100)
if ( print_id_info(p) )
/* print id info  */
{
#endif

begin_prt_info(p);


#if (keep_ids > 0)
printf(": ifte %s ... ", vtxeval(p -> pc, 1));


#if (dbg_bdd > 100)
printf("\n\thdr=0x%x; vtx=0x%x;",
regfield(regfield(p -> pc, ifte_word0), bddvalue),
read_graph_root(
	regfield(regfield(p -> pc, ifte_word0), bddvalue)
               )
);
#if (dbg_vtx > 100)
prt_vtx_state(stdout, 
(void *) read_graph_root(
	regfield(regfield(p -> pc, ifte_word0), bddvalue)
		)
);
#endif



printf("\n\thdr=0x%x; vtx=0x%x;",
regfield(regfield(p -> pc, ifte_word0 + 1), bddvalue),
read_graph_root(
	regfield(regfield(p -> pc, ifte_word0 + 1), bddvalue)
		)
);
#if (dbg_vtx > 100)
prt_vtx_state(stdout, 
(void *) read_graph_root(
	regfield(regfield(p -> pc, ifte_word0 + 1), bddvalue)
		)
);
#endif

printf("\n\thdr=0x%x; vtx=0x%x;",
regfield(regfield(p -> pc, ifte_word0 + 2), bddvalue),
read_graph_root(
	regfield(regfield(p -> pc, ifte_word0 + 2), bddvalue)
		)
);
#if (dbg_vtx > 100)
prt_vtx_state(stdout, 
(void *) read_graph_root(
	regfield(regfield(p -> pc, ifte_word0 + 2), bddvalue)
		)
);
#endif

#endif

#if (dbg_bdd > 10000)
fprint_bdd(
   stdout, 
   regfield(regfield(p -> pc, ifte_word0), bddvalue)
          );
fprint_bdd(
   stdout, 
   regfield(regfield(p -> pc, ifte_word0 + 1), bddvalue)
          );
fprint_bdd(
   stdout, 
   regfield(regfield(p -> pc, ifte_word0 + 2), bddvalue)
          );
#endif




#if 0
printf(" %s %s %s",
vtxeval(regfield(p -> pc, ifte_word0), 1),
vtxeval(regfield(p -> pc, ifte_word0 + 1), 1),
vtxeval(regfield(p -> pc, ifte_word0 + 2), 1)
);
#endif

#endif


#if (keep_ids == 0)
printf(": ifte p%x ... ", p -> pc);

#if 0
printf(" p%x p%x p%x",
regfield(p -> pc, ifte_word0),
regfield(p -> pc, ifte_word0 + 1),
regfield(p -> pc, ifte_word0 + 2)
);
#endif


#endif


#if (filter_ids > 100)
}
#endif

#endif

#if (dbg_flag > 10)
printf("\napply_ifte:%u: begin: p = 0x%x, pc = 0x%x", count, p, p -> pc);
#endif


/* store old bddvalue  */

p -> old_bddvalue =  filter_resetted(regfield(p -> pc, bddvalue));


#if 0
/* just for debugging */
fprintf(stderr,
"\napply_ifte:p -> old_bddvalue = 0x%x, regfield(p -> pc, bddvalue) = 0x%x", 
p -> old_bddvalue,
regfield(p -> pc, bddvalue)
);
#endif


#if (dbg_flag > 10)
printf("\napply_ifte:%u: p -> old_bddvalue = 0x%x", 
count, p -> old_bddvalue);
#endif

regfield(p -> pc, bddvalue) = 
glb_bdd_filter(
 if_then_else(
	read_bddvalue(regfield(p -> pc, ifte_word0)), 
	read_bddvalue(regfield(p -> pc, ifte_word0 + 1)), 
	read_bddvalue(regfield(p -> pc, ifte_word0 + 2))
	    )
);



/* update present bddvalue */
p -> new_bddvalue =  regfield(p -> pc, bddvalue);


#if (dbg_bdd > 100)
printf("\nregfield(p -> pc, bddvalue) == 0x%x.0x%x ",
regfield(p -> pc, bddvalue),
read_graph_root(
	regfield(p -> pc, bddvalue)
		)
);
printf("\nroot == 0x%x ",
read_graph_root(
	regfield(p -> pc, bddvalue)
		)
);

#if 0
prt_vtx_state(stdout,
(void *) read_graph_root(
	regfield(p -> pc, bddvalue)
		)
); 
#endif

#endif



#if (dbg_bdd > 10000)
fprint_bdd(
   stdout, 
   regfield(p -> pc, bddvalue)
          );
printf("\n\n");
#endif



#if (dbg_flag > 10)
printf("\napply_ifte:%u: new_bddvalue = 0x%x.0x%x", 
count, 
regfield(p -> pc, bddvalue),
read_graph_root(
	regfield(p -> pc, bddvalue)
		)
);
#endif




#if (print_info > 5)

#if (filter_ids > 100)
if ( print_id_info(p) )
/* print id info  */
{
#endif

  end_prt_info(p);


#if (filter_ids > 100)
}
#endif

#endif



/* increment pc */

p -> pc = regfield(p -> pc, ptr_down);



#if (dbg_flag > 10)
printf("\napply_ifte:%u: newpc = 0x%x", count, p -> pc);
#endif


}  /*  apply_ifte  */
