/*
************************************
file: ifte.c
************************************
*/


#include "local.h"




#define dbg_flag 0  /* normal value: 0  */


void apply_isone(prghdr *p)
{
/* dcl  */

FILE *qfile;


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif


/*  prg  */

#if (print_info > 5)
begin_prt_info(p);



#if (keep_ids > 0)
printf(": isone %s %s \"%s\"",
vtxeval(regfield(p -> pc, query_word0), 1),
vtxeval(regfield(p -> pc, query_word0 + 1), 1),
regfield(p -> pc, query_word0 + 2)
);
#endif


#if (keep_ids == 0)
printf(": isone p%x X%x \"%s\"",
regfield(p -> pc, query_word0),
regfield(p -> pc, query_word0 + 1),
regfield(p -> pc, query_word0 + 2)
);
#endif


#endif


#if (dbg_flag > 10)
printf("\napply_isone:%u: begin: p = 0x%x, pc = 0x%x", count, p, p -> pc);
#endif

/* print answer to query */

qfile = fopen(p -> answfilename, "a");


#if (keep_ids > 0)
fprintf(qfile, 
"\n\n\nisone %s %s \"%s\" = \n",
vtxeval(regfield(p -> pc, query_word0), 1),
vtxeval(regfield(p -> pc, query_word0 + 1), 1),
regfield(p -> pc, query_word0 + 2)
);
#endif


#if (keep_ids == 0)
fprintf(qfile, 
"\n\n\nisone p%x X%x \"%s\" = \n",
regfield(p -> pc, query_word0),
regfield(p -> pc, query_word0 + 1),
regfield(p -> pc, query_word0 + 2)
);
#endif





               if ( is_bdd_one(
regfield(
	regfield(p -> pc, query_word0),
	bddvalue
	)  
			      )
                  )
               /* then  OK  */
                  {

                     fprintf(qfile, "function "); 

#if (keep_ids > 0)
fprintf(qfile, "%s",
vtxeval(regfield(p -> pc, query_word0), 1)
);
#endif

#if (keep_ids == 0)
fprintf(qfile, "p%x",
regfield(p -> pc, query_word0)
);
#endif

    fprintf(qfile, " is identically 1\n"); 

                       
                  }

               else 
                    {    /*  != 1  */


               if ( is_bdd_zero(
regfield(
	regfield(p -> pc, query_word0),
	bddvalue
	)  
			      )
                  )
               /* then  KO  */
                  {



                     fprintf(qfile, "function "); 

#if (keep_ids > 0)
fprintf(qfile, "%s",
vtxeval(regfield(p -> pc, query_word0), 1)
);
#endif

#if (keep_ids == 0)
fprintf(qfile, "p%x",
regfield(p -> pc, query_word0)
);
#endif


    fprintf(qfile, " is identically 0\n"); 


                       
                  }
              else   /* FAIL  */
                 {


                     fprintf(qfile, "function "); 

#if (keep_ids > 0)
fprintf(qfile, "%s",
vtxeval(regfield(p -> pc, query_word0), 1)
);
#endif

#if (keep_ids == 0)
fprintf(qfile, "p%x",
regfield(p -> pc, query_word0)
);
#endif

    fprintf(qfile, " is non 0 non 1\n"); 



                 }

           }    /*  != 1  */




fclose(qfile);


/* advance pc */

p -> pc = regfield(p -> pc, ptr_down);


#if (print_info > 5)
end_prt_info(p);
#endif


}  /*  apply_isone  */
