/*
************************************
file: local.h
************************************
*/



#include "apply.h"
#include "prgvtx.h"
#include "lextkns.h"
#include "runner.h"
#include "lexan.h"
#include "symbtab.h"

#include "bdd.h"



/* normal value: 10, use 0 for quiet operation   */

#define print_info 10 



int print_id_info(prghdr* p);


void begin_prt_info(prghdr* p);
void end_prt_info(prghdr* p);



void apply_ifte(prghdr *p);
void apply_compose(prghdr *p);
void apply_xarg(prghdr *p);
void apply_boolean(prghdr *p);
void apply_loopback(prghdr *p);
void apply_free(prghdr *p);

void apply_isone(prghdr *p);
void apply_eval(prghdr *p);
void apply_satasg(prghdr *p);
void apply_C_code(prghdr *p);

void apply_begin(prghdr *p);
void apply_end(prghdr *p);

void apply_join(prghdr *p);
void apply_prj(prghdr *p);
void apply_exec(prghdr *p);



void prt_vtx_state(FILE *fileptr, void *v);


bdd glb_bdd_copy(bdd G);
bdd glb_bdd_filter(bdd G);



