/*
************************************
file: ifte.c
************************************
*/


#include "local.h"


#define dbg_flag 0  /* normal value: 0  */



void apply_prj(prghdr *p)
{
/* dcl  */


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif


/*  prg  */

#if (print_info > 5)

#if (filter_ids > 100)
if ( print_id_info(p) )
/* print id info  */
{
#endif


begin_prt_info(p);


#if (keep_ids > 0)
printf(": prj %s %s %u",
vtxeval(p -> pc, 1),
vtxeval(regfield(p -> pc, prj_word0), 1),
regfield(p -> pc, prj_word0 + 1)
);
#endif


#if (keep_ids == 0)
printf(": prj p%x p%x %u",
p -> pc,
regfield(p -> pc, prj_word0),
regfield(p -> pc, prj_word0 + 1)
);
#endif


#if (filter_ids > 100)
}
#endif


#endif

#if (dbg_flag > 10)
printf("\napply_prj:%u: begin: p = 0x%x, pc = 0x%x", count, p, p -> pc);
#endif

/* store old bddvalue  */

p -> old_bddvalue =  filter_resetted(regfield(p -> pc, bddvalue));




#if (dbg_flag > 10)
printf("\napply_prj:%u: old_bddvalue = 0x%x\n", 
count, p -> old_bddvalue);


#if (keep_ids > 0)
fprint_prgvtx(stderr, p -> pc);
fprint_prgvtx(stderr, regfield(p -> pc, prj_word0));
printf("\ncomponent %u join: %s",
regfield(p -> pc, prj_word0 + 1),
vtxeval(
vtxeval(
  regfield(
             regfield(p -> pc, prj_word0), /* join ... */
             join_word0 + 1
           ),  /* (... join components ...)  */
   (unsigned int) regfield(p -> pc, prj_word0 + 1)
       ),
1)
);
printf("\ncomponent %u join: bdd = 0x%x",
regfield(p -> pc, prj_word0 + 1),
regfield(
 vtxeval(
   regfield(
             regfield(p -> pc, prj_word0), /* join ... */
             join_word0 + 1
           ),  /* (... join components ...)  */
   (unsigned int) regfield(p -> pc, prj_word0 + 1)
       ),
  bddvalue
        )
);
printf("\npresent prj bddvalue: 0x%x",
regfield(p -> pc, bddvalue)
);
#endif

#endif


#if 0
regfield(p -> pc, bddvalue) = 
duplicate(
 regfield(
 vtxeval(
   regfield(
             regfield(p -> pc, prj_word0), /* join ... */
             join_word0 + 1
           ),  /* (... join components ...)  */
   (unsigned int) regfield(p -> pc, prj_word0 + 1)
       ),
  bddvalue
        )
);
#endif




regfield(p -> pc, bddvalue)
=
glb_bdd_copy(
(bdd)   read_bddarray(
            regfield(p -> pc, prj_word0), /* join ... */
            (unsigned int) regfield(p -> pc, prj_word0 + 1)
                     )
);


/* update present bddvalue */
p -> new_bddvalue =  regfield(p -> pc, bddvalue);


#if (dbg_flag > 10)
printf("\napply_prj:%u: new_bddvalue = 0x%x", 
count, regfield(p -> pc, bddvalue)
);
#endif




#if (print_info > 5)

#if (filter_ids > 100)
if ( print_id_info(p) )
/* print id info  */
{
#endif


end_prt_info(p);

#if (filter_ids > 100)
}
#endif

#endif


/* increment pc */

p -> pc = regfield(p -> pc, ptr_down);


#if (dbg_flag > 10)
printf("\napply_prj:%u: newpc = 0x%x: end\n", count, p -> pc);
#endif


}  /*  apply_prj  */
