/*
************************************
file: ifte.c
************************************
*/


#include "local.h"




#define dbg_flag 0  /* normal value: 0  */


void apply_satasg(prghdr *p)
{
/* dcl  */
FILE *qfile;

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif


/*  prg  */

#if (print_info > 5)
begin_prt_info(p);

#if (keep_ids > 0)
printf(": satasg %s %s \"%s\"",
vtxeval(regfield(p -> pc, query_word0), 1),
vtxeval(regfield(p -> pc, query_word0 + 1), 1),
regfield(p -> pc, query_word0 + 2)
);
#endif


#if (keep_ids == 0)
printf(": satasg p%x X%x \"%s\"",
regfield(p -> pc, query_word0),
regfield(p -> pc, query_word0 + 1),
regfield(p -> pc, query_word0 + 2)
);
#endif


#endif

#if (dbg_flag > 10)
printf("\napply_satasg:%u: begin: p = 0x%x, pc = 0x%x", count, p, p -> pc);
#endif

/* print answer to query */

qfile = fopen(p -> answfilename, "a");




#if (keep_ids > 0)
fprintf(qfile, 
"\n\n\nsatasg %s %s \"%s\" =",
vtxeval(regfield(p -> pc, query_word0), 1),
vtxeval(regfield(p -> pc, query_word0 + 1), 1),
regfield(p -> pc, query_word0 + 2)
);
#endif


#if (keep_ids == 0)
fprintf(qfile, 
"\n\n\nsatasg p%x X%x \"%s\" =",
regfield(p -> pc, query_word0),
regfield(p -> pc, query_word0 + 1),
regfield(p -> pc, query_word0 + 2)
);
#endif



ord_satisfy_all(

qfile,

regfield(
	regfield(p -> pc, query_word0),
	bddvalue
	),

p -> maxarg,  /* max number of bdd variables expected */

(unsigned int) 
regfield(
	regfield(p -> pc, query_word0 + 1),
	ordlist_word0
	),  /* size of ord_array */

regfield(
	regfield(p -> pc, query_word0 + 1),
	ordlist_word0 + 1
	)  /*  ord_array  */

);


fclose(qfile);


/* advance pc */

p -> pc = regfield(p -> pc, ptr_down);

#if (print_info > 5)
end_prt_info(p);
#endif


}  /*  apply_satasg  */
