/*
*************************************
file: eptyfifo.c

Store fifo in a vector and delete fifo.

*************************************
*/


#include "local.h"



#define dbg_flag 0  /* normal value: 0  */
 


void emptyfifo2vtx(
void* listq, /* fifo buffer */
void* tlist,   /* vtx buffer */
unsigned int listsize  /* fifo size */
)
{
/*  dcl  */
unsigned int i;

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif


/*  prg  */


#if (dbg_flag > 1000)
printf("\nemptyfifo2vtx:%u: ckp 100 (begin)", count);
#endif


#if (dbg_flag > 10)
printf("\nemptyfifo2vtx:%u: vtx = 0x%x: size = %u", 
count, 
tlist, 
listsize
);
#endif



for (i = 0; i < listsize; i++)
   {

     ((void* *) tlist)[i] = (void *) out_fifo(listq);

#if (dbg_flag > 10)
printf("\n\t((void* *) vtx)[%u] = %u = %d = 0x%x", 
i,
((void* *) tlist)[i],
((void* *) tlist)[i],
((void* *) tlist)[i]
);
#endif

 
   }


/* fifo empty */
delete_fifo(listq);



}  /*  emptyfifo2vtx  */ 












