/*
*************************************
file: get.c


Given a term returns a prg vertex.

*************************************
*/


#include "local.h"



#define dbg_flag 0 /* normal value: 0  */
 



void* get_prgvtx(unsigned int size)
{
/* dcl */

void* p;


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif




/* prg  */




p = (void *) malloc(sizeof(void *) * size);

if (p == NULL)
/* error  */
{
   printf("\nget_prgvtx: error: no malloc space\n");
   exit (1000); 
 
}

/* ok  */


#if (dbg_flag > 100)
printf("\nget_prgvtx:%u: ckp 100: p = 0x%x", count, p);
#endif

return (p);


}   /* prg  */







prghdr* get_prghdr()
{
/* dcl */

void* p;


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif




/* prg  */




p = (prghdr *) malloc(sizeof(prghdr));

if (p == NULL)
/* error  */
{
   printf("\nget_prgvtx: error: no malloc space\n");
   exit (1000); 
 
}

/* ok  */


#if (dbg_flag > 100)
printf("\nget_prghdr:%u: ckp 100: p = 0x%x", count, p);
#endif


return (p);


}   /* prg  */





















