/*
********************************
file: glb_bdd.c
********************************
*/



#include "local.h"

#define dbg_flag 0  /* normal value: 0  */





void init_global_bdds()
{
/* declarations   */

/* program  */

glb_bdd_zero = zero();
glb_bdd_one = one();
   
}   /* init_global_bdds   */







void delete_nonglb_bdd(bdd G)
{
/* declarations   */

if ( G == glb_bdd_zero )
{ return; }

if ( G == glb_bdd_one )
{ return;}


/* nonglobal bdd   */

delete_bdd(G);  
    
}



bdd nonglb2null(bdd G)
{

if ( G == glb_bdd_zero )
{ return (G); }

if ( G == glb_bdd_one )
{ return (G); }

/* non global bdd   */

return (NULL);  

}






bdd glb_bdd_copy(bdd G)
{

if ( bdd_equal(
         (bdd) glb_bdd_zero,
          G
              )
   )
{
   return ((bdd) glb_bdd_zero);
}
else
if ( bdd_equal(
         (bdd) glb_bdd_one,
          G
              )
   )
{
   return ((bdd) glb_bdd_one);
}
else
{
   return (duplicate(G));
}


}  /*  end  */












bdd glb_bdd_filter(bdd G)
{

if ( bdd_equal(
         (bdd) glb_bdd_zero,
          G
              )
   )
{
   delete_nonglb_bdd(G);
   return ((bdd) glb_bdd_zero);
}
else
if ( bdd_equal(
         (bdd) glb_bdd_one,
          G
              )
   )
{
   delete_nonglb_bdd(G);
   return ((bdd) glb_bdd_one);
}
else
{
   return (G);
}


}  /*  end  */






bdd read_bddvalue(void *ptr_id_def)
{
    if ( regeval(ptr_id_def) == NULL )
       { /* not yet defined */
         return ((bdd) glb_bdd_zero);
       }
    else
       { /* defined */

return ( (bdd) regfield(ptr_id_def, bddvalue) );

       }

 
}  /* read_bddvalue()  */









bdd read_bddarray(void *ptr_id_def, unsigned int i)
{
    if ( regeval(ptr_id_def) == NULL )
       { /* not yet defined */
         return ((bdd) glb_bdd_zero);
       }

    else
       { /* defined */

return ( (bdd) vtxeval(regfield(ptr_id_def, bddarray), i) );

       }

}  /* read_bddvalue()  */





bdd filter_resetted(void *G)
{

if (G == NULL)
   /* id was resetted */
  {
      return ((bdd) glb_bdd_zero);
  }
else 
  {
     return (G);
  }


}
