/*
*********************************
file: bp11.c
*********************************
*/


#include "local.h"

#include <time.h>


#include "etlogo.h"


#define dbg_flag 0   /*  normal value: 0  */
#define dbg_flag_1 0   /*  normal value: 0  */




void bp11(char *prgfile, char* answfile)
{
/* declarations  */
FILE *qfile;
FILE *cfile;

prghdr* prg;



/* prg */


#if (dbg_flag > 0)
printf("\nbp11: begin: prgfile = %s, answfile = %s",
prgfile, answfile
);
#endif


printf("\n\n\nbp11 version: 1.1 (May 98)");
et_signature();



#if (dbg_flag_1 > 10)
fprintf(stderr, "\n\nbp11: malloc = 0x%x\n\n", malloc);
#endif


#if (dbg_flag > 0)
printf("\nbp11: upload %s", prgfile);
#endif


prg = upload(prgfile);


#if (dbg_flag > 10)
printf("\nbp11: show prgfile");
download(prg, "showprg.b10");
#endif


#if (dbg_flag > 100)
printf("\nbp11: check syntax");
#endif



syntax(prg);



#if (dbg_flag > 100)
printf("\nbp11: run program");
#endif



printf("\n\n\nbp11: time, memory info:\n\n\n");

print_rusage(stdout);



#if (dbg_flag > 100)
printf("\nbp11: end");
#endif

}    /*  main  */



