/*
*********************************
file; main.c


Test lexan
*********************************
*/


#include <stdio.h>
#include <stdlib.h>

#include "parser.h"



#define dbg_flag 0  /*  normal value: 0  */




main()
{
/* declarations  */


prghdr* prg;


/* prg */


#if (dbg_flag > 0)
printf("\n\nmain: ckp 100: (begin)");
#endif


setbuf(stdout, NULL);




prg = upload("input.bsa");


#if (dbg_flag > 0)
printf("\n\nmain: show input");
#endif


download(prg, "showin.bsa");



#if (dbg_flag > 0)
printf("\n\nmain: loop optimization");
#endif

loop_optimization(prg);


#if (dbg_flag > 0)
printf("\n\nmain: show loop optimization");
#endif


download(prg, "loop.bsa");


#if (dbg_flag > 0)
printf("\n\nmain: def loopback");
#endif



define_loopback(prg);

insert_loopback(prg);


#if (dbg_flag > 0)
printf("\n\nmain: show loopback def");
#endif


download(prg, "back.bsa");

#if (dbg_flag > 100)
printf("\nmain: define free");
#endif



define_free(prg);

#if (dbg_flag > 0)
printf("\n\nmain: show free def");
#endif


download(prg, "free.bsa");


#if (dbg_flag > 100)
printf("\nmain: position query");
#endif


position_query(prg);

#if (dbg_flag > 0)
printf("\n\nmain: show prg after query positioning");
#endif


download(prg, "query.bsa");

#if (dbg_flag > 100)
printf("\nmain: ckp 3000: (end)");
#endif

}    /*  main  */



