/*
*************************************
file: prj.c


Read id def via boole.


Returns pointer to id defined.
*************************************
*/


#include "local.h"



#define dbg_flag 0  /* normal value: 0  */
 


void* read_prj(void* *p  /* token */)
{
/*  dcl  */
void* result;
void* vtx;


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif


/*  prg  */


#if (dbg_flag > 1000)
printf("\nread_prj:%u: ckp 100 (begin)", count);
#endif


/* 
   Opcode is in token[0].
   We need to read 1 id and an unsigned int
*/



vtx = get_prgvtx(size_prj);

((void* *) vtx)[op_code] = p[0];


read_new_token(p);
if (p[0] != (void *) tk_id)
/* error */
{
                 printf("\nerror in file %s line %u: id expected",
                          lexan_fname(), lex_line_number());

                 exit (1);
}


/* ok: p[0] == tk_id  */
check_newdef(p);

result = read_stbk_info(p[1]);
*((void* *) result) = vtx;






read_new_token(p);
if (p[0] != (void *) tk_id)
/* error */
{
                 printf("\nerror in file %s line %u: id expected",
                          lexan_fname(), lex_line_number());

                 exit (1);
}


/* ok: p[0] == tk_id  */

((void* *) vtx)[prj_word0] = read_stbk_info(p[1]);







read_new_token(p);
if (p[0] != (void *) tk_num)
/* error */
{
                 printf("\nerror in file %s line %u: num expected",
                          lexan_fname(), lex_line_number());

                 exit (1);
}


/* ok: p[0] == tk_num */

((void* *) vtx)[prj_word0 + 1] = p[1];



/* return result */

return (result);


}  /*  read_prj  */ 












