/*
********************************
file: local.h
********************************
*/

#include "syntax.h"
#include "lextkns.h"




void loop_optmz1(prghdr* p);



void* move_reg(
	prghdr *p, 
	void *append_reg, 
	void *prg_reg);



int compose_is_movable(prghdr *p, void *prg_reg);
int ifte_is_movable(prghdr *p, void *prg_reg);

int join_is_movable(prghdr *p, void *prg_reg);
int prj_is_movable(prghdr *p, void *prg_reg);

void move_mark_def(prghdr *p, void *prg_reg);
void bdd_to_null(prghdr *p);
int reg_is_undefined(
	prghdr *p, 
	void *prg_reg, 
	void *arg_reg);




void start_call_env();
void end_call_env();
void define_calls(prghdr* p);
int reg_calls(
	prghdr *p, 
	void *calling_reg, 
	void *called_reg
	);







void loop_optmz2(prghdr* p);


void define_loopback(prghdr* p);

void insert_loopback(prghdr *p);


void define_free(prghdr* p);


void append_newreg(void *prg_reg, void *new_reg);
void stack_newreg(void* new_reg, void *target_reg);


void position_query(prghdr* p);


