/*
*************************************
file: loopopt.c

Esy part of loop optimization.



*************************************
*/


#include "local.h"



#define dbg_flag 0 /* normal value: 0  */
 

/*
 Stack new_reg on target_reg.
*/


/*
HYP: regfield(target_reg, ptr_up) != NULL
*/
 
void stack_newreg(void* new_reg, void *target_reg)
{

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif


/* prg  */

#if (dbg_flag > 100)
printf("\nstack_newreg:%u: begin: new_reg = 0x%x, target_reg = 0x%x, target.up = 0x%x, target.down = 0x%x", 
count, 
new_reg, target_reg, 
regfield(target_reg, ptr_up),
regfield(target_reg, ptr_down) 
);
#endif


regfield(new_reg, ptr_down) = target_reg;
regfield(new_reg, ptr_up) = regfield(target_reg, ptr_up) ;
regfield(regfield(target_reg, ptr_up), ptr_down) = new_reg;
regfield(target_reg, ptr_up) = new_reg;

#if (dbg_flag > 100)
printf("\nstack_newreg:%u: end: new_reg.up = 0x%x, new_reg.down = 0x%x, target.up = 0x%x, target.down = 0x%x", 
count, 
regfield(new_reg, ptr_up),
regfield(new_reg, ptr_down),
regfield(target_reg, ptr_up),
regfield(target_reg, ptr_down)
);
#endif

}


