/*
*************************************
file: compose.c


Read id def via ifte or compose.
In general op of arity arity.


Returns pointer to id defined.
*************************************
*/


#include "local.h"



#define dbg_flag 0  /* normal value: 0  */
 


void* read_compose(void* *p  /* token */)
{
/*  dcl  */
void* result;
void* vtx;


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif


/*  prg  */


#if (dbg_flag > 1000)
printf("\nread_compose:%u: ckp 100 (begin)", count);
#endif


/* 
   Opcode is in token[0].
   We need to read 4 ids.  
   The first id is the one being defined.
*/



vtx = get_prgvtx(size_ifte);


((void* *) vtx)[op_code] = p[0];





read_new_token(p);
if (p[0] != (void *) tk_id)
/* error */
{
                 printf("\nerror in file %s line %u: id expected",
                          lexan_fname(), lex_line_number());

                 exit (1);
}


/* ok: p[0] == tk_id  */
check_newdef(p);

result = read_stbk_info(p[1]);
((void* *) result)[0] = vtx;



/*  read preg  */
read_new_token(p);
if (p[0] != (void *) tk_id)
/* error */
{
                 printf("\nerror in file %s line %u: id expected",
                          lexan_fname(), lex_line_number());

                 exit (1);
}


/* ok: p[0] == tk_id  */

((void* *) vtx)[compose_word0] = read_stbk_info(p[1]);








/* read xlist */
read_new_token(p);
if (p[0] != (void *) tk_id)
/* error */
{
                 printf("\nerror in file %s line %u: id expected",
                          lexan_fname(), lex_line_number());

                 exit (1);
}


/* ok: p[0] == tk_id  */

((void* *) vtx)[compose_word0 + 1] = read_stbk_info(p[1]);





/* read reglist  */
read_new_token(p);
if (p[0] != (void *) tk_id)
/* error */
{
                 printf("\nerror in file %s line %u: id expected",
                          lexan_fname(), lex_line_number());

                 exit (1);
}


/* ok: p[0] == tk_id  */

((void* *) vtx)[compose_word0 + 2] = read_stbk_info(p[1]);





/* check that xlist and reglist have smae size */


if (  vtxeval(regeval(vtxeval(vtx, compose_word0 + 1) /* xlist_reg */
                     ), /* xlist_vtx */
              xlist_word0
              )  /* xlist size */
      !=

     vtxeval(regeval(vtxeval(vtx, compose_word0 + 2) /* reglist_reg */
                     ), /* reglist_vtx */
              reglist_word0
              )  /* reglist size */
   )
/*  error  */
  {
  printf("\nerror in file %s line %u: same size expected for xlist and reglist",
                          lexan_fname(), lex_line_number());

                 exit (1);



  }





/* return result */

return (result);


}  /*  read_compose()  */ 












