/*
*************************************
file: defid.c


Read id def via ifte or compose.
In general op of arity arity.


Returns pointer to id defined.
*************************************
*/


#include "local.h"



#define dbg_flag 0 /* normal value: 0  */
 


void* read_ifte(void* *p  /* token */)
{
/*  dcl  */
unsigned int i;

void* result;
void* vtx;


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif


/*  prg  */


#if (dbg_flag > 1000)
printf("\nread_ifte:%u: ckp 100 (begin)", count);
#endif


/* 
   Opcode is in token[0].
   We need to read 4 ids.  
   The first id is the one being defined.
*/



vtx = get_prgvtx(size_ifte);


((void* *) vtx)[op_code] = p[0];


read_new_token(p);
if (p[0] != (void *) tk_id)
/* error */
{
                 fprintf(stderr,
"\nerror in file %s line %u: found tkcode %u = '%c': tk_id = %u expected as arg{1} in ifte",
lexan_fname(), 
lex_line_number(),
p[0], p[0],
tk_id
);

                 exit (1);
}


/* ok: p[0] == tk_id  */

check_newdef(p);

result = read_stbk_info(p[1]);
*((void* *) result) = vtx;




for (i = 0; i < 3; i++)
   {

read_new_token(p);
if (p[0] != (void *) tk_id)
/* error */
{
                 fprintf(stderr,
"\nerror in file %s line %u: found tkcode %u = '%c': tk_id = %u expected as arg{%u} in ifte",
lexan_fname(), 
lex_line_number(),
p[0], p[0],
tk_id,
i + 2
);

                 exit (1);
}


/* ok: p[0] == tk_id  */

((void* *) vtx)[ifte_word0 + i] = read_stbk_info(p[1]);


    }






/* return result */

return (result);


}  /*  read_ifte()  */ 












