/*
*************************************
file: splitcmp.c


Define bsa ordlist, i.e.
invert bso ordlist pad it to maxarg 
double (to account for dummy var in compose).

The resulting array should have size 2*maxarg.
*************************************
*/


#include "local.h"



#define dbg_flag 0 /* normal value: 0  */




void def_bsa_ordlist(prghdr* p)
{
/* dcl */

unsigned int *bsaord_array;
unsigned int bsiord_size, bsaord_size, i;



#if (dbg_flag > 0)
static int count = 0;
count++;
#endif


/* prg  */

#if (dbg_flag > 100)
printf("\nbsa_ordlist_array:%u: begin: program = 0x%x", count, p);
#endif



bsiord_size = (unsigned int) regfield(p -> ordlist, ordlist_word0);

bsaord_size = (p -> maxarg);

if (bsaord_size < bsiord_size)  bsaord_size = bsiord_size;

bsaord_array = (unsigned int *) get_prgvtx(2*bsaord_size);



/* note bsaord_array is inverse permutation of bsiord_array */

for (i = 0; i < bsaord_size; i++)
   {
bsaord_array[2*argpos(p, i)] = i;
bsaord_array[2*argpos(p, i) + 1] = bsaord_size + i;
   }



regfield(p -> ordlist, ordlist_word0) = (void *) (2 * bsaord_size);

free(regfield(p -> ordlist, ordlist_word0 + 1));
regfield(p -> ordlist, ordlist_word0 + 1) = (void *) bsaord_array;






#if (dbg_flag > 100)
printf("\nbsa_ordlist_array:%u: end: program = 0x%x", count, p);
#endif


}   /* prg  */






