/*
********************************
file: local.h

********************************
*/



#include "parser.h"
#include "lexan.h"
#include "prgvtx.h"
#include "lextkns.h"



void* read_new_term();


void* create_fifo();
void in_fifo(void *fifo, unsigned int value);
unsigned int out_fifo(void *fifo);
void delete_fifo(void *fifo);
void** emptyfifo(void* tbuf, unsigned int tsize);



void* read_boole(void* *p  /* token */);
void* read_compose(void* *p  /* token */);
void* read_ifte(void* *p  /* token */);
void* read_ordlist(void* *p  /* token */);
void* read_query(void* *p  /* token */);
void* read_reglist(void* *p  /* token */);
void* read_xarg(void* *p  /* token */);
void* read_xlist(void* *p  /* token */);


void* read_new_term();


void emptyfifo2vtx(
void* listq, /* fifo buffer */
void* tlist,   /* vtx buffer */
unsigned int listsize  /* fifo size */
);


void check_newdef(void* *p  /* token */);


void read_varord(void* vtx, void* *p  /* token */);


int check_ordlist(void* ordlist_reg  /* != NULL */);



void* read_boole_op(void* *p  /* token */, unsigned int arity);

void* read_quantifiers(void* *p  /* token */);





void* read_join(void* *p  /* token */);

void* read_prj(void* *p  /* token */);

void* read_exec(void* *p  /* token */);


