/*
*************************************
file: eptyfifo.c

Store fifo in a vector and delete fifo.

*************************************
*/


#include "local.h"



#define dbg_flag 0  /* normal value: 0  */
 


void eptybopfifo2vtx(
void* listq, /* fifo buffer */
void* tlist,   /* vtx buffer */
unsigned int listsize  /* fifo size */
)
{
/*  dcl  */
unsigned int i;

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif


/*  prg  */


#if (dbg_flag > 1000)
printf("\neptybopfifo2vtx:%u: ckp 100 (begin)", count);
#endif


#if (dbg_flag > 10)
printf("\neptybopfifo2vtx:%u: vtx = 0x%x: size = %u", 
count, 
tlist, 
listsize
);
#endif

vtxeval(tlist, bop_arity) = (void *) listsize;


for (i = 0; i < listsize; i++)
   {

     vtxeval(tlist, bop_word0 + i) = (void *) out_fifo(listq);

#if (dbg_flag > 10)
printf("\n\tvtxeval(tlist, bop_word0 + %u) = %u = %d = 0x%x", 
i,
vtxeval(tlist, bop_word0 + i),
vtxeval(tlist, bop_word0 + i),
vtxeval(tlist, bop_word0 + i)
);
#endif

 
   }


/* fifo empty */
delete_fifo(listq);



}  /*  eptybopfifo2vtx  */ 












