/*
*********************************
file: go.c
*********************************
*/


#include "local.h"
#include "etlogo.h"




#define dbg_flag 0  /*  normal value: 0  */




void bp50(char *prgfile, char* outfile)
{
/* declarations  */


prghdr* prg;


/* prg */


#if (dbg_flag > 0)
printf("\nbp50: begin: prgfile = %s, outfile = %s",
prgfile, outfile
);
#endif



  printf("\n\n\nbp50 version: 1.1 (April 1997)");

et_signature();



#if (dbg_flag > 0)
printf("\nbp50: upload %s", prgfile);
#endif


prg = upload(prgfile);


#if (dbg_flag > 10)
printf("\nbp50: show input prgfile in: showprg.bp50");
download(prg, "showprg.bp50");
#endif



bsp_download(prg, outfile);





printf("\n\n\nbp50: time, memory info:\n\n\n");

print_rusage(stdout);

#if 0
system("ps -u | egrep \"PID|bp50\""); /* linux home PC */
system("ps -lu tronci | egrep \"PID|bp50\""); /* SUN, Solaris: smaq20 */
#endif




#if (dbg_flag > 100)
printf("\nbp50: end");
#endif

}    /*  main  */



