/*
**  file: id.c
**
*/


#include "local.h"
#include "terms.h"



/*
***********************
Note:
id_count is a unique number assigned to each id.
************************
*/


void* get_newid_vtx()
{
/* dcl */
 void *p, *tkid_ptr;
 static unsigned int id_count = 0;  /* count ids */


/* prg */
id_count++;

 
 p = (void *) malloc(lexid_size * sizeof(void* *)); 
 
 if (p == NULL)
 {
 	printf("\nerror: no space for new id vtx (get_newid_vtx) \n");
 	exit (1234);

  }

/*  p != NULL  */

/* initialize id type to id_undef */

((void **) p)[lexid_type] = (void *) id_undef;



/* initialize id vctsize to 1 */

((void **) p)[lexid_vctsize] = (void *) 1;



/* define lexid_idcount */

((void **) p)[lexid_idcount] = (void *) id_count;


/* define tkid  */

 tkid_ptr = (void *) malloc((op_word0 + id_args) * sizeof(void* *)); 
 
 if (tkid_ptr == NULL)
 {
 	printf("\nerror: no space for tkid (get_newid_vtx) \n");
 	exit (1234);

  }

/*  tkid_ptr != NULL  */


/* initialize lexid_tkid */

((void **) p)[lexid_tkid] = tkid_ptr;



/* return result */

return (p);


}






