/*
*********************************
file: go.c
*********************************
*/


#include "local.h"
#include "etlogo.h"



#define dbg_flag 0  /*  normal value: 0  */




void bp60(char *prgfile, char* outfile)
{
/* declarations  */


prghdr* prg;


/* prg */


#if (dbg_flag > 0)
printf("\nbp60: begin: prgfile = %s, outfile = %s",
prgfile, outfile
);
#endif



  printf("\n\n\nbp60 version: 1.1 (April 1997)");

et_signature();



#if (dbg_flag > 0)
printf("\nbp60: upload %s", prgfile);
#endif


prg = upload(prgfile);


#if (dbg_flag > 10)
printf("\nbp60: show input prgfile in: showprg.b60");
download(prg, "showprg.b60");
printf("\nbp60: begin syntax");
#endif




 syntax(prg);



#if (dbg_flag > 10)
printf("\nbp60: syntax done (show.b61): begin translation");
download(prg, "show.b61");
#endif




translate(prg, outfile);



#if (dbg_flag > 10)
printf("\nbp60: end translation");
#endif


printf("\n\n\nbp60: time, memory info:\n\n\n");


print_rusage(stdout);

#if 0
system("ps -u | egrep \"PID|bp60\""); /* linux home PC */
system("ps -lu tronci | egrep \"PID|bp60\""); /* SUN, Solaris: smaq20 */
#endif
 



#if (dbg_flag > 100)
printf("\nbp60: end");
#endif

}    /*  main  */



