
/*
**********************

term points to
(def t (op ... A   ... ))

term_def points to:

(def A (....))


term_id point to A
*********************
*/




#include "local.h"



#define dbg_flag 0  /* normal value: 0  */





void check_lexid_def(void *term, void* term_def)
{

if (
     (unsigned int) vtxeval(
                      vtxeval(vtxeval(term_def, op_word0), op_word0),
                      lexid_type
                           )
     ==
     
    id_undef
  )
/* error */
{
   fprintf(stderr, "\nerror id %s undefined in bfun %s\n",
             vtxeval(
               vtxeval(vtxeval(term_def, op_word0), op_word0),
               lexid_string
                    ),
vtxeval(
               vtxeval(vtxeval(term, op_word0), op_word0),
               lexid_string
                    )
);

exit (1);

}


/*  ok  */

#if (dbg_flag > 0)
fprintf(stderr, "\ncheck_id_def: term: %s, arg %s, size = %u",
vtxeval(
               vtxeval(vtxeval(term, op_word0), op_word0),
               lexid_string
                    ),
vtxeval(
               vtxeval(vtxeval(term_def, op_word0), op_word0),
               lexid_string
                    ),
     vtxeval(
           vtxeval(vtxeval(term_def, op_word0), op_word0),
           lexid_vctsize
        )
);
#endif

}  /* check  */







unsigned int term_id_vctsize(void *term, void* term_id)
{
/* dcls */
void *term_def;


/* prg  */




#if (dbg_flag > 0)
fprintf(stderr, "\nterm_id_vctsize: begin: term_id"
);
print_term(stderr, term_id);
#endif



switch (  (int) vtxeval(term_id, op_code) )
     {

          case tk_b0:
          case tk_b1:

                       return (1);



          case tk_id:


term_def = 
    vtxeval(
           vtxeval(term_id, op_word0), 
           lexid_def
        );


#if (dbg_flag > 0)
fprintf(stderr, "\nterm_id_vctsize: tk_id: term_def =  "
);
print_term(stderr, term_def);
#endif



check_lexid_def(term, term_def);



#if (dbg_flag > 0)
fprintf(stderr, "\nterm_id_vctsize: lexid def ok: vctsize term_def = %u",
     ((unsigned int)
     vtxeval(
           vtxeval(vtxeval(term_def, op_word0), op_word0),
           lexid_vctsize
        ))

);
#endif

return (

     ((unsigned int)
     vtxeval(
           vtxeval(vtxeval(term_def, op_word0), op_word0),
           lexid_vctsize
        ))

       );



     default:  /* error  */


          fprintf(stderr, "\nterm_id_vctsize: error: unexpected symbol\n");

           exit (1);




    }   /* switch  */




}
