/*
*************************************
file: remove.c

*************************************
*/


#include "local.h"



#define dbg_flag 0  /* normal value: 0  */




void remove_prgword(prghdr* phdr, void *p)
{
/* dcl  */


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
printf("\nremove:%u: begin term = 0x%x", 
count, 
vtxeval(p, prgwrd_value)
);
#endif




if ( vtxeval(p, ptr_up) != NULL )
/* forward skip p  */
{
vtxeval(vtxeval(p, ptr_up), ptr_down) 
= vtxeval(p, ptr_down);
}



if ( vtxeval(p, ptr_down) != NULL )
/* backward skip p  */
{
vtxeval(vtxeval(p, ptr_down), ptr_up) 
= vtxeval(p, ptr_up);
}


/* 
We do not worry too much about freeing all term since memory
not critic here
*/

free(p);



#if (dbg_flag > 10)
printf("\nremove:%u: end", count);
#endif

}  /*  prg  */










