/*
********************************
file: local.h
********************************
*/

#include "lexan.h"
#include "prgvtx.h"
#include "trans.h"






/* 
Only used to compile old functions.
These shuold be eliminated
*/
#define bop_arity 1
#define bop_word0 2
#define tk_begin 0
#define tk_end 1
#define regfield(L, M) ((void *) NULL)
#define query_word0 2




#if (mkpins > 10)
extern FILE *pinptr;
#endif


unsigned int new_argindx();

unsigned int 
print_array_regs(FILE* fileptr, void* term);
unsigned int 
print_array_args(FILE* fileptr, void* term);

void record(FILE* fileptr, void* term);
unsigned int 
record_reglist(FILE* fileptr, void* term);
void record_xlist(FILE* fileptr, void* term);
void array(FILE* fileptr, void* term);
void trans_def(FILE* fileptr, void* term);
void dollar(FILE* fileptr, void* term);
void b0b1(FILE* fileptr, void* term, int bvalue);




void boole_op(FILE* fileptr, void* term);


void bop_component(
FILE* fileptr, 
void* term, 
unsigned int i
);


void def_bop_arg(
FILE* fileptr, 
void* term, 
unsigned int i, 
unsigned int j
);



void prt_bop_arg(
FILE* fileptr, 
void* term, 
unsigned int i, 
unsigned int j
);




void* record_entry(
void* term, 
unsigned int rec_entry,
unsigned int *ar_entry
);

void dcl(FILE* fileptr, void* term);



void prj(FILE* fileptr, void* term);



void prt_join_arg(FILE* fileptr, void* term, unsigned int i, unsigned int j);


void def_join_arg(
FILE* fileptr, 
void* term, 
unsigned int i, 
unsigned int j
);


void join_flat(FILE* fileptr, void* term, unsigned int i);




void join(FILE* fileptr, void* term);







void binders(FILE* fileptr, void* term);


void binder_component(FILE* fileptr, void* term, unsigned int i);


void def_binder_arg(
FILE* fileptr, 
void* term, 
unsigned int i, 
unsigned int j
);

void prt_binder_arg(FILE* fileptr, 
      void* term, unsigned int i, unsigned int j);

void prt_binder_var(FILE* fileptr, 
      void* term, unsigned int i, unsigned int j);





void compose(FILE* fileptr, void* term);
void cmp_component(
FILE* fileptr, 
void* term, 
unsigned int i
);
void prt_cmp_xlist(
FILE* fileptr, 
void* term, 
unsigned int i, 
unsigned int j
);
void prt_cmp_reglist(
FILE* fileptr, 
void* term, 
unsigned int i, 
unsigned int j
);


void argord(
FILE* fileptr, 
prghdr* phdr, 
void* term
);



void query(FILE* fileptr, prghdr* phdr, void* term);

void bsp_uint(FILE* fileptr, void* term);


#if 0
void and(FILE* fileptr, void* prg_reg);
void or(FILE* fileptr, void* prg_reg);
void boole(FILE* fileptr, void* prg_reg);
void ifte(FILE* fileptr, void* prg_reg);
void ordlist(FILE* fileptr, void* prg_reg);
void query(FILE* fileptr, void* prg_reg);
void reglist(FILE* fileptr, void* prg_reg);
void xarg(FILE* fileptr, void* prg_reg);
void xlist(FILE* fileptr, void* prg_reg);
void not(FILE* fileptr, void* prg_reg);
void xor(FILE* fileptr, void* prg_reg);
void eq(FILE* fileptr, void* prg_reg);
void nor(FILE* fileptr, void* prg_reg);
void nand(FILE* fileptr, void* prg_reg);
void imp(FILE* fileptr, void* prg_reg);
void exists(FILE* fileptr, void* prg_reg);
void forall(FILE* fileptr, void* prg_reg);
#endif


