/*
*************************************
file: download.c



Write program p in file filename.
*************************************
*/


#include "local.h"



#define dbg_flag 0   /* normal value: 0  */




void download(prghdr* phdr, /* program header */
              char *filename)
{

/* dcl  */
FILE* fileptr;
void* p;  /* prg label for instruction  */
void *p_vtx;   /* prg vertex  */
unsigned int i;



#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
printf("\ndownload:%u: begin, open file", count);
#endif


/* initialize lexan  */

fileptr = fopen(filename, "w");



#if (dbg_flag > 100)
printf("\ndownload:%u: print reglist", count);
#endif





#if (dbg_flag > 100)
printf("\ndownload:%u: print program", count);
#endif


/*
*************************
Print program instructions
*************************
*/
#if 0
fprintf(fileptr, "\n\n/* Program Instructions */\n\n");
#endif

/*  first instruction */
p = phdr -> prg;




 while (p != NULL)
  {
       /* print line, p != NULL */

#if (dbg_flag > 100)
printf("\ndownload:%u: prg word: 0x%x, term: 0x%x", 
count, 
p,
vtxeval(p, prgwrd_value)
);
#endif


       print_term(fileptr, vtxeval(p, prgwrd_value));
       fprintf(fileptr, "\n");

       p = vtxeval(p, ptr_down);

  }   /* while */







#if (dbg_flag > 100)
printf("\ndownload:%u: close file", count);
#endif



fclose(fileptr);


#if (dbg_flag > 10)
printf("\ndownload:%u: end", count);
#endif




}  /*  prg  */





















