/*
*************************************
file: sub.c

HYP:
No terms nested in bp63.


*************************************
*/


#include "local.h"


#define MOD 9


#define dbg_flag 0   /* normal value: 0  */





/*
************************
term is
=
(def p (sub p1 p2))


************************
*/


void sub(FILE* fileptr,  void* term)
{
/* dcl  */

int i, rhs_size;

void *rhs_term;

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
printf("\nsub:%u: begin", count);
#endif

rhs_term = vtxeval(term, op_word0 + 2);



#if (dbg_flag > 10)
printf("\nsub:%u: rhs_term = 0x%x", count, rhs_term);
print_term(stderr, rhs_term);
#endif


rhs_size = 
(int) 
vtxeval(
    idarray(vtxeval(vtxeval(rhs_term, op_word0 + 1), op_word0)),
    lexid_vctsize
       );


#if (dbg_flag > 10)
printf("\nsub:%u: size of rhs terms = %u", count, lhs_size);
#endif



i = 0;

/* define ripple */
fprintf(fileptr, "(def %s%u_%u b0)\n",

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
MOD*i

);


#if (dbg_flag > 10)
printf("\nsub:%u:  defined %s%u_%u", count, 
signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
2*i
);
#endif





/* define sub */



for (i = 0; i < rhs_size - 1; i++)
   {


#if (dbg_flag > 10)
printf("\nsub:%u:  begin for i = %u", count, i);
#endif

/* define proj  */

fprintf(fileptr, "(def %s%u_%u (prj %s %u))\n",

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
MOD*i + 1,

vtxeval(
   idarray(vtxeval(vtxeval(rhs_term, op_word0 + 1), op_word0)),
   lexid_string
       ),
i

);


fprintf(fileptr, "(def %s%u_%u (prj %s %u))\n",

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
MOD*i + 2,

vtxeval(
   idarray(vtxeval(vtxeval(rhs_term, op_word0 + 2), op_word0)),
   lexid_string
       ),
i

);


/* define sub */
fprintf(fileptr, "(def %s%u_%u (xor %s%u_%u %s%u_%u %s%u_%u))\n",

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
MOD*i + 3,


signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
MOD*i,


signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
MOD*i + 1,


signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
MOD*i + 2

);



/* define ripple (i + 1) */

fprintf(fileptr, "(def %s%u_%u (not %s%u_%u))\n",

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
MOD*i + 4,



signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
MOD*i + 1

);





fprintf(fileptr, "(def %s%u_%u (not %s%u_%u))\n",

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
MOD*i + 5,



signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
MOD*i + 2

);





fprintf(fileptr, "(def %s%u_%u (and %s%u_%u %s%u_%u))\n",

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
MOD*i + 6,



signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
MOD*i + 4,

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
MOD*i + 2



);




fprintf(fileptr, "(def %s%u_%u (and %s%u_%u %s%u_%u %s%u_%u))\n",

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
MOD*i + 7,



signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
MOD*i,

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
MOD*i + 4,

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
MOD*i + 5



);















fprintf(fileptr, "(def %s%u_%u (and %s%u_%u %s%u_%u %s%u_%u))\n",

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
MOD*i + 8,



signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
MOD*i,

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
MOD*i + 1,

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
MOD*i + 2



);





fprintf(fileptr, "(def %s%u_%u (or %s%u_%u %s%u_%u %s%u_%u))\n",

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
MOD*(i + 1),



signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
MOD*i + 6,

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
MOD*i + 7,


signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
MOD*i + 8


);





#if (dbg_flag > 10)
printf("\nsub:%u:  end for i = %u", count, i);
#endif


   }   /* for i */


/* i = rhs_size - 1 */


/* define sum, no need for last ripple since overflow ignored */



fprintf(fileptr, "(def %s%u_%u (prj %s %u))\n",

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
MOD*i + 1,

vtxeval(
   idarray(vtxeval(vtxeval(rhs_term, op_word0 + 1), op_word0)),
   lexid_string
       ),
i

);


fprintf(fileptr, "(def %s%u_%u (prj %s %u))\n",

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
MOD*i + 2,

vtxeval(
   idarray(vtxeval(vtxeval(rhs_term, op_word0 + 2), op_word0)),
   lexid_string
       ),
i

);



/* define sum */
fprintf(fileptr, "(def %s%u_%u (xor %s%u_%u %s%u_%u %s%u_%u))\n",

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
MOD*i + 3,


signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
MOD*i,


signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
MOD*i + 1,


signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
MOD*i + 2

);





/*  define output  */

fprintf(fileptr, "(def %s (join",

vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_string
       )
);




for (i = 0; i < rhs_size; i++)
   {

fprintf(fileptr, " %s%u_%u",

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
MOD*i + 3

);


   }


fprintf(fileptr, "))\n");



#if (dbg_flag > 10)
printf("\nsub:%u: end", count);
#endif

}  /* sub */


