/*
*********************************
file: go.c
*********************************
*/


#include "local.h"



#define dbg_flag 0  /*  normal value: 0  */




void bp65(char *prgfile, char* outfile)
{
/* declarations  */


prghdr* prg;


/* prg */


#if (dbg_flag > 0)
printf("\nbp65: begin: prgfile = %s, outfile = %s",
prgfile, outfile
);
#endif



  printf("\n\n\nbp65 version: 1.1 (June 1997)");
et_signature();


#if (dbg_flag > 0)
printf("\nbp65: upload %s", prgfile);
#endif


prg = upload(prgfile);


#if (dbg_flag > 10)
printf("\nbp65: show input prgfile in: showprg.b65\n");
#endif





#if (dbg_flag > 10)
printf("\nbp65: begin syntax");
#endif



 syntax(prg);



#if (dbg_flag > 10)
printf("\nbp65: syntax done: begin translation");
download(prg, "showprg.b65");
#endif


translate(prg, outfile);



#if (dbg_flag > 10)
printf("\nbp65: end translation");
#endif


printf("\n\n\nbp65: time, memory info:\n\n\n");


print_rusage(stdout);

#if 0
system("ps -u | egrep \"PID|bp65\""); /* linux home PC */
system("ps -lu tronci | egrep \"PID|bp65\""); /* SUN, Solaris: smaq20 */
#endif




#if (dbg_flag > 100)
printf("\nbp65: end");
#endif

}    /*  main  */



