/*
*************************************
file: download.c



Write program p in file filename.
*************************************
*/


#include "local.h"



#define dbg_flag 0  /* normal value: 0  */



void translate(prghdr* phdr, /* program header */
              char *filename)
{
/* dcl  */
FILE* fileptr;
void* p;  /* prg label for instruction  */
void *p_vtx;   /* prg vertex  */
unsigned int i;



#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
printf("\ntranslate:%u: begin, open file: %s", count, filename);
#endif


/* initialize lexan  */

fileptr = fopen(filename, "w");


begin_trans_symtab();


#if (dbg_flag > 100)
printf("\ntranslate:%u: print program", count);
#endif


/*
*************************
Print program instructions
*************************
*/



/*  first instruction */
p = phdr -> prg;




 while (p != NULL)
  {
       /* print line, p != NULL */

       term_trans(
fileptr, 
vtxeval(p, prgwrd_value)
);

       p = vtxeval(p, ptr_down);

 
  }   /* while */





end_trans_symtab();



#if (dbg_flag > 100)
printf("\ntranslate:%u: close file: %s", count, filename);
#endif



fclose(fileptr);


#if (dbg_flag > 10)
printf("\ntranslate:%u: end", count);
#endif

}  /*  prg  */




















