/*
*********************************
file: go.c
*********************************
*/


#include "local.h"

#include "etlogo.h"


#define dbg_flag 0  /*  normal value: 0  */



void bp70(char *prgfile, char* outfile)
{
/* declarations  */


prghdr* prg;


/* prg */


#if (dbg_flag > 0)
printf("\nbp70: begin: prgfile = %s, outfile = %s",
prgfile, outfile
);
#endif



  printf("\n\n\nbp70 version: 1.1 (June 1997)");

et_signature();


#if (dbg_flag > 0)
printf("\nbp70: upload %s", prgfile);
#endif


prg = upload(prgfile);


#if (dbg_flag > 10)
printf("\nbp70: show input prgfile in: showprg.b70\n");
#endif





#if (dbg_flag > 10)
printf("\nbp70: begin syntax");
#endif



 syntax(prg);



#if (dbg_flag > 10)
printf("\nbp70: syntax done: begin translation");
download(prg, "showprg.b70");
#endif


translate(prg, outfile);



#if (dbg_flag > 10)
printf("\nbp70: end translation");
#endif

print_rusage(stdout);


#if 0
printf("\n\n\nbp70: time, memory info:\n\n\n");
system("ps -u | egrep \"PID|bp70\""); /* linux home PC */
system("ps -lu tronci | egrep \"PID|bp70\""); /* SUN, Solaris: smaq20 */
#endif




#if (dbg_flag > 100)
printf("\nbp70: end");
#endif

}    /*  main  */



