/*
*********************************
file: go.c
*********************************
*/


#include "local.h"

#include "etlogo.h"


#define dbg_flag 0  /*  normal value: 0  */




void bp80(char *prgfile, char* outfile)
{
/* declarations  */


prghdr* prg;


/* prg */


#if (dbg_flag > 0)
printf("\nbp80: begin: prgfile = %s, outfile = %s",
prgfile, outfile
);
#endif



  printf("\n\n\nbp80 version: 1.1 (June 1997)");

et_signature();


#if (dbg_flag > 0)
printf("\nbp80: upload %s", prgfile);
#endif


prg = upload(prgfile, outfile);


#if (dbg_flag > 10)
printf("\nbp80: show input prgfile in: showprg.b80\n");
download(prg, "showprg.b80");
#endif



#if 0
/* no term storage */

#if (dbg_flag > 10)
printf("\nbp80: begin syntax");
#endif



 syntax(prg);



#if (dbg_flag > 10)
printf("\nbp80: syntax done: begin translation");
#endif


translate(prg, outfile);



#if (dbg_flag > 10)
printf("\nbp80: end translation");
#endif

#endif



printf("\n\n\nbp80: time, memory info:\n\n\n");

print_rusage(stdout);


#if 0
system("ps -u | egrep \"PID|bp80\""); /* linux home PC */
system("ps -lu tronci | egrep \"PID|bp80\""); /* SUN, Solaris: smaq20 */
#endif
 



#if (dbg_flag > 100)
printf("\nbp80: end");
#endif

}    /*  main  */



