/*
********************************
file: local.h
********************************
*/

#include "lexan.h"
#include "prgvtx.h"



void dcl_outsize(prghdr* phdr);

void prg_outsize(prghdr* phdr);


unsigned term_outsize(void* term);

unsigned atom_outsize(void* term);

unsigned nonatom_outsize(void* term);





void check_present_state(void* term);

void check_next_state(void* term);

void check_transition(void* term);

void check_update(void* term);




void remove_prgword(prghdr* phdr, void *p);


void rm_dcl_dup(prghdr* phdr);
 
void check_lexid_def(void *term, void* term_def);

unsigned int term_id_vctsize(void *term, void* term_id);





void const_term(prghdr* phdr);
unsigned int const_id(void* term);
unsigned int nonatom_term(void* term);




unsigned int apterm_eval(void* term);



void syntax_enum(prghdr* phdr);
void enum_ids(void* term);
void nonatom_enum(void* term);




void syntax_macro(prghdr* phdr);
void macro_term(void* term);
void nonatom_macro(void* term);

