/*
*************************************
file: const.c


Defines value for const id's.




*************************************
*/


#include "local.h"



#define dbg_flag 0   /* normal value: 0  */




void syntax_macro(prghdr* phdr)
{
/* dcl  */
void  *p;  /* prg label for instruction  */
void *term;

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
printf("\nsyntax_macro:%u: begin", count);
#endif



/*  first instruction */
p = phdr -> prg;




 while (p != NULL)
  {
       /* print line, p != NULL */

       macro_term(vtxeval(p, prgwrd_value));

       p = vtxeval(p, ptr_down);


  }



#if (dbg_flag > 10)
printf("\nsyntax_macro:%u: end", count);
#endif

}  /*  prg  */







void macro_term(void* term)
{
/* dcl  */

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
printf("\nmacro_term:%u: begin", count);
#endif




#if (dbg_flag > 0)
fprintf(stderr, "\n\nmacro_term: term: ");
print_term(stderr, term);
#endif

switch ( (unsigned int) vtxeval(term, op_code) )
     {
         case tk_ap: 

         
                   nonatom_macro(term);


         default:  /* atom: cannot be (enum ...) */

                   return ;
   

     }






#if (dbg_flag > 10)
printf("\nmacro_term:%u: end", count);
#endif

}  /*  prg  */








/*
**************
term is (ap id/keyword .... )
**************
*/


void nonatom_macro(void* term)
{
/* dcl  */
void  *rhs_term;
unsigned int lhsop, i, rhs_size;



#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
printf("\nnonatom_macro:%u: begin", count);
#endif




lhsop = (unsigned int) vtxeval(vtxeval(term, op_word0), op_code);



#if (dbg_flag > 0)
fprintf(stderr, "\n\nnnonatom_macro: lhsop = %u: term: ", lhsop);
print_term(stderr, term);
#endif


switch (lhsop)
     {

        case tk_macro:  /* macro */


#if (dbg_flag > 0)
fprintf(stderr, "\nnonatom_macro: switch: macro: term = 0x%x",
term
);
#endif

/* define lexid_def for macro name */

rhs_term = vtxeval(term, op_word0 + 1);

vtxeval(
   idarray(
      vtxeval(vtxeval(rhs_term, op_word0), op_word0)
          ), 
   lexid_def
)
=
term;




vtxeval(
   idarray(
      vtxeval(vtxeval(rhs_term, op_word0), op_word0)
          ), 
   lexid_type
)
=
(void *) id_macro;




/* set formal par  */





rhs_size = (unsigned int) vtxeval(rhs_term, op_args);





#if 0

for (i = 1; i < rhs_size; i++)
   {

vtxeval(
   idarray(
      vtxeval(vtxeval(rhs_term, op_word0 + i), op_word0)
          ), 
   lexid_type
)
=
(void *) id_macro_arg;


vtxeval(
   idarray(
      vtxeval(vtxeval(rhs_term, op_word0 + i), op_word0)
          ), 
   lexid_value
)
=
(void *) NULL;


   }


#endif






                    return;






                 default:  /* do nothing */

                           return ;




          }  /* switch */





#if (dbg_flag > 10)
printf("\nnonatom_macro:%u: end", count);
#endif

}  /*  prg  */
















