/*
******************
file mkargord.c

Reads file (stdin)

(def .._a (array sza))
(def .._px (array szx))
(def ..._nx (array szx))
....


and returns (stdout)

(argord
        0 sza 1
        sza szx 2
        sza+1 szx 2

        ...
)


******************
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>



#define dbgflag 0  /* normal value: 0  */



#define USIZE 200


main()
{
/* dcls */

unsigned int first_idx_av = 0;
unsigned int sz = 0;
int res = 0;

char sigbuf[USIZE];

char buf[1000];

/* prg  */


#if (dbgflag > 0)
setbuf(stdout, NULL);
setbuf(stderr, NULL);
#endif



#if (dbgflag > 0)
fprintf(stderr, "\nmkargord: begin");
#endif


 printf("\n(argord");

while ( gets(buf) != NULL )
{

#if (dbgflag > 0)
fprintf(stderr, "\nmkargord: begin while ...");
#endif


            if (
sscanf(buf, "(def %s (array %u))", sigbuf, &sz) != 2
               )
        /* no matching, skip */
       {
#if (dbgflag > 0)
fprintf(stderr, "\nmkargord: skipping: %s", buf);
#endif

         continue;
       }

#if (dbgflag > 0)
fprintf(stderr, "\nmkargord: matched: %s", buf);
fprintf(stderr, "\nmkargord: sigbuf = %s, sigbuf[%u] = %c", 
sigbuf, 
strlen(sigbuf) - 1,
sigbuf[strlen(sigbuf) - 1]
);
#endif


/* ok, res == 2 */

if (sigbuf[strlen(sigbuf) - 1] == 'x')
    {
      if (sigbuf[strlen(sigbuf) - 2] == 'p') 
          /* present state */
        {
           printf("\n\t%u %u 2", first_idx_av, sz);
           continue;
        }
      else /* next state */
       {
         printf("\n\t%u %u 2", first_idx_av + 1, sz);
         first_idx_av = first_idx_av + 2*sz;
         continue;
       }

    }




if (sigbuf[strlen(sigbuf) - 1] == 'a')  
    /* action */
    {
      printf("\n\t%u %u 1", first_idx_av, sz);
      first_idx_av = first_idx_av + sz;
      continue;
    }



#if (dbgflag > 0)
fprintf(stderr, "\nmkargord: end while");
#endif

}      /* while */

 printf("\n)");


#if (dbgflag > 0)
fprintf(stderr, "\nmkargord: end");
#endif


}  /* main */

