/*
*********************************
file; main.c


Test lexan
*********************************
*/


#include <stdio.h>
#include <stdlib.h>


#include "lexan.h"
#include "symbtab.h"



#define dbg_flag 0  /*  normal value: 0  */




main()
{
/* declarations  */


void* p[2];

FILE* lexinput;

unsigned int i;

unsigned int token_code;





/* programs  */


#if (dbg_flag > 0)
printf("\n\nmain: ckp 100: (begin)");
#endif


#if 0
/*  test isalpha  */

for (i = 0; i < 256; i++)
   {
      printf("\ni = %d, isalpha(%c) = %d", i, i, isalpha(i));
   }
#endif






setbuf(stdout, NULL);

lexinput = fopen("input.lex", "r");


#if (dbg_flag > 0)
printf("\nmain: ckp 200:");
#endif
  




begin_lexan();
set_lexan(lexinput, "input.lex");


#if (dbg_flag > 0)
printf("\nmain: ckp 300:");
#endif




i = 0;


/* read tokens */
while (1)
     {

i++;

#if (dbg_flag > 0)
printf("\nmain: ckp 400: i = %u", i);
#endif
      
       p[1] = NULL;


      token_code = read_new_token(p);

#if (dbg_flag > 0)
printf("\nmain: ckp 500: i = %u, p[0] = %u, tokenk_code = %u", 
i, p[0], token_code
);
#endif


       printf("\ntoken %u: token_code = %u",
                i, p[0]
             );

       switch (token_code)
            {

               case tk_eof: /* eof */
                     printf(": EOF\n");
                     exit (0);


               case tk_num:  /* number */
                     printf(" = (number): token_val = %d,", p[1]);
                     break;

               case tk_unk:  /* unknown */
                     printf(" = tk_unk: token_char = %c,", p[1]);
                     break;

               case tk_string:  /* string */
                     printf(" = tk_string: token_val = %s,", 
                                           (char *) p[1]);

                     break;



               case tk_newid:  /* newid */
                     printf(" = tk_newid: token_val = %s,", 
                                     (char *) read_stbk_key(p[1]));

                     break;





               case tk_oldid:  /* oldid */
                     printf(" = tk_oldid: token_val = %s,", 
                                     (char *) read_stbk_key(p[1]));

                     break;




               default:  /* keyword */
                     printf(" = keyword: keyword = %s", 
(char *) read_stbk_key(p[1]));
                     break;

            }


#if (dbg_flag > 0)
printf("\nmain: ckp 900: i = %u", i);
#endif



     }



#if (dbg_flag > 0)
printf("\nmain: ckp 1000: end while loop");
#endif



end_lexan();




#if (dbg_flag > 0)
printf("\nmain: ckp 1100");
#endif


fclose(lexinput);





#if (dbg_flag > 100)
printf("\nmain: ckp 3000: (end)");
#endif

}    /*  main  */



