/*
**************************
lexan.h
**************************
*/



#ifndef lexan_h
#define lexan_h

#include <stdlib.h>
#include <stdio.h>

#include "lextkns.h"
#include "symbtab.h"
#include "bspauxid.h"




void begin_lexan();
void end_lexan();



char* keywstring(unsigned int tokencode);

unsigned int read_new_token(void* *p);



void set_lexan(
FILE* src_file, 
char* filename
);

FILE* lexan_file();

char* lexan_fname();

void lexreset_linenum();

unsigned int lex_line_number();












/*  token manipulation functions  */
void* make_token();
unsigned int read_token_lexcode(void* token);
unsigned int read_token_value(void* token);
void write_token_lexcode(void* token, unsigned int value);
void write_token_value(void* token, unsigned int value);



void init_id_string(void* temp);



void check_id_def(void* T);




#endif

