
/*
**
**  file local.h
**
**
**  primitives for symbol table
**
**  
*/




#include <limits.h>


typedef unsigned int ht_value;


struct Hash_Table
{
  unsigned int size_table;
  unsigned int elements_in_table;
  unsigned int non_null_entry;
  unsigned int maxsize_sofar;
  ht_value *table;
};


typedef struct Hash_Table hash_table;



void* read_stbk_next(void* v);
void write_stbk_next(void* v, void* value);



unsigned int 
symbtab_hash(unsigned int symbtab_size, char* A);

