/*
**  file: buckets.c
**
*/


#include "local.h"



#define bksize 4


char* read_stbk_key(void* v)
{   
   return ( (char *) ((void* *) v)[0]);
}



void* read_stbk_info(void* v)
{
   return ( ((void* *) v)[1] );
}


void* read_stbk_next(void* v)
{
   return ( ((void* *) v)[2]);
}



unsigned int read_stbk_tkcode(void* v)
{
   return ( (unsigned int) ((void* *) v)[3]);
}



void* get_new_stbk()
{
 void* p;
 
 p = (void *) malloc(bksize * sizeof(void*)); 
 
 if (p == NULL)
 {
 	printf("\nerror: no space for new bucket (get_new_stbk) \n");
 	exit (1234);

  }

/*  p != NULL  */


return (p);


}








void write_stbk_key(void* v, char* value)
{
   ((void* *) v)[0] = (void *) value;
}


void write_stbk_info(void* v, void* value)
{
   ((void* *) v)[1] =  value;
}

void write_stbk_next(void* v, void* value)
{
   ((void* *) v)[2] = value;
}


void write_stbk_tkcode(void* v, unsigned int value)
{
   ((void* *) v)[3] = (void *) value;
}





