/*
**
**  file:  hash.c
**
*/





#include "local.h"
#include <string.h>




unsigned int symbtab_hash(unsigned int symbtab_size, char* A)

{  /* declarations  */
   unsigned int i, total, base;
   
   size_t size_key;





   /* program  */

   size_key = strlen(A);


   
   base = 1u;
   total =  A[0]%symbtab_size;





   for (i = 1; i < size_key; i++)
      {

          base =  (
((UINT_MAX%symbtab_size + 1)%symbtab_size) * base
                  )%symbtab_size;

          total = 
(total +  
          ( base * (
                           A[i]
                           %
                           symbtab_size
                     )
           )%symbtab_size

)%symbtab_size ;

       }





   return ( total );


 }   /*  symbtab_hash   */  


