/*
**
**  file: read.lkup.table
**
*/

#include "local.h"


#define dbg_flag 0







void print_symbtab(FILE *myfile, void* T)
{

/* declarations  */
  ht_value *v;
  unsigned int i, j, h;
  

#if (dbg_flag > 0)
static int count = 0;
#endif

/* programs  */


#if (dbg_flag > 0)
count++;
#endif


fprintf(myfile, "\nSymbol Table 0x%x", T); 
fprintf(myfile, "\nSize = %u, num elements in table = %u",
get_symbtab_size(T),
get_symbtab_elements(T)
); 
fprintf(myfile, "\nformat: bk_num bk_adr (key, tkcode, info, next)", T); 


h = 0;  /*  num elements count  */


    for (i = 0; i < get_symbtab_size(T); i++)
       {
          v = (ht_value *) ( ((hash_table *) T) -> table[i] );

          if (v != NULL)

         {
          
          fprintf(myfile, "\n%u:  row %u", h, i); 
          j = 0;
          while (v != NULL)
          {
             
             fprintf(myfile, "\n\tbk %u: 0x%x: (%s, %u = %c, 0x%x, 0x%x)",
             		j, v,
             		read_stbk_key(v),
             		read_stbk_tkcode(v), read_stbk_tkcode(v),
            		read_stbk_info(v),
             		read_stbk_next(v)
             );
             v = read_stbk_next(v);
             
             j++;

             h++;  /*  increment elements count  */

          }  /*  while  */


         }  /*  then   */


       }


          fprintf(myfile, "\n\nFound %u elements in symbol table 0x%x", 
h, T
); 


}  /* end program  */
